! bsg.h
! Variables concerning the Wilson coefficients and the final branching 
! ratio for the decay b->s\gamma

! Wilson Coefficients
! (In the standard operator basis)
complex (8) ::  SMBSGWilc(2,8),SMBSGWilcp(2,8)
complex (8) ::  CHBSGWilc(2,8),CHBSGWilcp(2,8)
complex (8) ::  GINOBSGWilc(2,8),GINOBSGWilcp(2,8)
complex (8) ::  CINOBSGWilc(2,8),CINOBSGWilcp(2,8)
complex (8) ::  NINOBSGWilc(2,8),NINOBSGWilcp(2,8)
complex (8) ::  NHBSGWilc(2,8),NHBSGWilcp(2,8)
complex (8) ::  BSMBSGWilc(2,8),BSMBSGWilcp(2,8)

Common/BSGWilc/SMBSGWilc,SMBSGWilcp,CHBSGWilc,CHBSGWilcp, &
 GINOBSGWilc,GINOBSGWilcp,CINOBSGWilc,CINOBSGWilcp, &
 NINOBSGWilc,NINOBSGWilcp,NHBSGWilc,NHBSGWilcp, &
 BSMBSGWilc,BSMBSGWilcp

! Delta=1-2E/mb used in bremstahlung calculations and the resulting
! matrix phi_ij
real (8) :: GMdelta, GMphi(8,8)
Common/BSGbrem/GMdelta,GMphi

! Magic Numbers as defined in Gambino and Misiak
real (8) :: GMa(8),GMd(8),GMdt(8),GMdtn(8)
real (8) :: GMdta(8),GMdtb(8),GMdtpi(8),GMe(8)
Common/BSGmagic/GMa,GMd,GMdt,GMdtn,GMdta,GMdtb,GMdtpi,GMe


! Other parameters needed in the branching ratio calculation
real (8) :: m_b1s,OSalphaEM,GMCfac,GMlambda2,GMBtoleps
Common/BSGbrpar/m_b1s,OSalphaEM,GMCfac,GMlambda2,GMBtoleps

! The final branching ratio
real (8) :: BSGbr,BSGbrSM,BSGbrrat
Common/BSGresult/BSGbr,BSGbrSM,BSGbrrat
