#!/usr/bin/perl -w
#
# Configure script to configure BDECAY.
#
# Author: Roberto Ruiz, rruiz@delta.ft.uam.es
# Date: June 24, 2006


$bdecayrootfile="inc/bdecaydir.h";


$bdecayroot=shift;
$bdecayroot =~ s#/$##;   # take away final / if any


# Take care of BDECAY root directory file
open(IN,"$bdecayrootfile") || die "Can't open $bdecayrootfile for reading.\n";
$line="";
while ($in=<IN>) {
    $line .= $in;
}
close(IN);

$newline=" " x 6 . "data bdecayroot/'$bdecayroot/'/\n";
$newline=contline($newline);

if ($newline ne $line) {
    open(OUT,">$bdecayrootfile") || 
      die "Can't open $bdecayrootfile for writing\n";
    print OUT $newline;
    close(OUT);
    print "$bdecayrootfile updated.\n";
} else {
    print "$bdecayrootfile is up-to-date.\n";
}


# Split long lines
sub contline {
    my $line = $_[0];
    my $out;
    my $i;
 
    $out="";
    if (length($line) >= 71) {
        print "*** A too long line has been found. I will split it.\n";
        print "Line before: \n$line";
        while (length($line) >= 71) {
            for ($i=70; $i==20; $i--) {
                if (substr($line,$i,1) =~ m@(\*|\+|-|/)@ ) {
                    last;
                }
            }
            $out=$out . substr($line,0,$i-1) . "\n";
            $line = " " x 5 . "&" . substr($line,$i-1)
        }
        $out = $out . $line;
        print "Line after: \n$out";
    } else {
        $out=$line;
    }
 
    return $out;
}
