c***********************************************************************
c The loop functions used for the LO and NLO SM and BSM contributions
c Taken from hep-ph/0308 and hep-ph/0104034 the functions being preceded
c by OR or GM respectively.
c***********************************************************************

      Double Precision Function OR_F71(x)

      Implicit NONE

c Inputs

      Double Precision x

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_F71=-5.D0/48.D0
      Else
         OR_F71=(x*(7.D0-5.D0*x-8.D0*x**2))/(24.D0*(x-1.D0)**3)
     &        +(x**2*(3.D0*x-2.D0))/(4.D0*(x-1.D0)**4)*LOG(x)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_F81(x)

      Implicit NONE

c Inputs

      Double Precision x

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_F81=-1.D0/16.D0
      Else
         OR_F81=(x*(2.D0+5.D0*x-x**2))/(8.D0*(x-1.D0)**3)
     &        -(3.D0*x**2)/(4.D0*(x-1.D0)**4)*LOG(x)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_F72(x)

      Implicit NONE

c Inputs

      Double Precision x

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_F72=-7.D0/36.D0
      Else
         OR_F72=(x*(3.D0-5.D0*x))/(12.D0*(x-1.D0)**2)
     &        +(3.D0*x**2-2.D0*x)/(6.D0*(x-1.D0)**3)*LOG(x)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_F82(x)

      Implicit NONE

c Inputs

      Double Precision x

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_F82=-1.D0/6.D0
      Else
         OR_F82=(x*(3.D0-x))/(4.D0*(x-1.D0)**2)
     &        -x/(2.D0*(x-1.D0)**3)*LOG(x)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_H71(x)

      Implicit NONE

c Inputs

      Double Precision x

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H71=5.D0/72.D0
      Else
         OR_H71=(-3.D0*x**2+2.D0*x)/(6.D0*(1.D0-x)**4)*LOG(x)
     &        +(-8.D0*x**2-5.D0*x+7.D0)/(36.D0*(1.D0-x)**3)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_H81(x)

      Implicit NONE

c Inputs

      Double Precision x

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H81=1.D0/24.D0
      Else
         OR_H81=x/(2.D0*(1.D0-x)**4)*LOG(x)
     &        +(-x**2+5.D0*x+2.D0)/(12.D0*(1.D0-x)**3)
      End If

      Return
      End
c***********************************************************************

      Double Precision Function OR_H72(x)

      Implicit NONE

c Inputs

      Double Precision x

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H72=-7.D0/18.D0
      Else
         OR_H72=(-3.D0*x**2+2.D0*x)/(3.D0*(1.D0-x)**3)*LOG(x)
     &        +(-5.D0*x**2+3.D0*x)/(6.D0*(1.D0-x)**2)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_H82(x)

      Implicit NONE

c Inputs

      Double Precision x

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H82=-1.D0/3.D0
      Else
         OR_H82=x/((1.D0-x)**3)*LOG(x)
     &        +(-x**2+3.D0*x)/(2.D0*(1.D0-x)**2)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_H73(x)

      Implicit NONE

c Inputs

      Double Precision x, OR_H81

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H73=-1.D0/3.D0*OR_H81(x)
      Else
         OR_H73=-1.D0/3.D0*OR_H81(x)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_H83(x)

      Implicit NONE

c Inputs

      Double Precision x,OR_H81

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H83=OR_H81(x)
      Else
         OR_H83=OR_H81(x)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_H74(x)

      Implicit NONE

c Inputs

      Double Precision x, OR_H82

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H74=-1.D0/3.D0*(OR_H82(x)+1.D0/2.D0)
      Else
         OR_H74=-1.D0/3.D0*(OR_H82(x)+1.D0/2.D0)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_H84(x)

      Implicit NONE

c Inputs

      Double Precision x, OR_H82

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H84=OR_H82(x)+1.D0/2.D0
      Else
         OR_H84=OR_H82(x)+1.D0/2.D0
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_H75(x)

      Implicit NONE

c Inputs

      Double Precision x, OR_H81

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H75=-1.D0/3.D0*(OR_H81(x))
      Else
         OR_H75=-1.D0/3.D0*(OR_H81(x))
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_H85(x)

      Implicit NONE

c Inputs

      Double Precision x

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H85=-5.D0/96.D0
      Else
         OR_H85=(9.D0*x**2-x)/(16.D0*(1.D0-x)**4)*LOG(x)
     &        +(19.D0*x**2+40.D0*x-11.D0)/(96.D0*(1.D0-x)**3)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_H76(x)

      Implicit NONE

c Inputs

      Double Precision x, OR_H82

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H76=-1.D0/3.D0*(OR_H82(x)+1.D0/2.D0)
      Else
         OR_H76=-1.D0/3.D0*(OR_H82(x)+1.D0/2.D0)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_H86(x)

      Implicit NONE

c Inputs

      Double Precision x

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H86=-19.D0/48.D0
      Else
         OR_H86=(9.D0*x**2-x)/(8.D0*(1.D0-x)**3)*LOG(x)
     &        +(13.D0*x-5.D0)/(8.D0*(1.D0-x)**2)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function BMU_EW(x)

      Implicit NONE

c Equation 40

c Inputs

      Double Precision x

      If (ABS(x-1.D0).lt.1.D-3) Then
         BMU_EW=-5.D0/72.D0
      Else
         BMU_EW=(4.D0*x**4-16.D0*x**3+15.D0*x**2)
     &        /(6.D0*(1.D0-x)**4)*LOG(x)
     &        +(7.D0*x**3-35.D0*x**2+42.D0*x-8.D0)/(12.D0*(1.D0-x)**3)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function BMU_GEW7(x)

      Implicit NONE

c The first three terms of equation 41

c Inputs

      Double Precision x

c Local
      Double Precision tmp
      Double Complex z

c Functions
      Double Complex DiLog

      z=DCMPLX(x,0.D0)
      tmp=DBLE(DiLog(1.D0-1.D0/z))

      If (ABS(x-1.D0).lt.1.D-3) Then
         BMU_GEW7=-3751.D0/9720.D0
      Else
         BMU_GEW7=(-16.D0*x**4-122.D0*x**3+80.D0*x**2-8.D0*x)
     &        /(9.D0*(1.D0-x)**4)*tmp
     &        +(-4.D0*x**5+407.D0*x**4+1373.D0*x**3-957.D0*x**2
     &        +45.D0*x)/(81.D0*(1.D0-x)**5)*LOG(x)
     &        +(1520.D0*x**4+12961.D0*x**3-12126.D0*x**2
     &        +3409.D0*x-580.D0)/(486.D0*(1.D0-x)**4)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function BMU_DeltaEW7(x)

      Implicit NONE

c Inputs

      Double Precision x

      If (ABS(x-1.D0).lt.1.D-3) Then
         BMU_DeltaEW7=1609.D0/810.D0
      Else
         BMU_DeltaEW7=(106.D0*x**4+287.D0*x**3+1230.D0*x**2-1207.D0*x
     &        +232.D0)/(81.D0*(1.D0-x)**4)
     &        +(6.D0*x**4+46.D0*x**3-28.D0*x**2)
     &        /(3.D0*(1.D0-x)**5)*LOG(x)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function BMU_GEW8(x)

      Implicit NONE

c Inputs

      Double Precision x

c Local
      Double Precision tmp
      Double Complex z

c Functions
      Double Complex DiLog

      z=DCMPLX(x,0.D0)

      tmp=DBLE(DiLog(1.D0-1.D0/z))

      If (ABS(x-1.D0).lt.1.D-3) Then
         BMU_GEW8=-9971.D0/12960.D0
      Else
         BMU_GEW8=(-4.D0*x**4+40.D0*x**3+41.D0*x**2+x)
     &        /(6.D0*(1.D0-x)**4)*tmp
     &        +(32.D0*x**5-16.D0*x**4-2857.D0*x**3-3981.D0*x**2
     &        -90.D0*x)/(216.D0*(1.D0-x)**5)*LOG(x)
     &        +(611.D0*x**4-13346.D0*x**3-29595.D0*x**2+1510.D0*x
     &        -652.D0)/(1296.D0*(1.D0-x)**4)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function BMU_DeltaEW8(x)

      Implicit NONE

c The coefficient of LOG(mu0/mt) in equation 42

c Inputs
      Double Precision x

      If (ABS(x-1.D0).lt.1.D-3) Then
         BMU_DeltaEW8=989.D0/1080.D0
      Else
         BMU_DeltaEW8=(89.D0*x**4-446.D0*x**3-1437.D0*x**2-950.D0*x
     &        +152.D0)/(108.D0*(1.D0-x)**4)
     &        +(-17.D0*x**3-31.D0*x**2)/(2.D0*(1.D0-x)**5)*LOG(x)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function BMU_ECH(x,ctb2)

      Implicit NONE

c Equation 46

c Inputs
      Double Precision x,ctb2

      If (ABS(x-1.D0).lt.1.D-3) Then
         BMU_ECH=1.D0/8.D0*ctb2
      Else
         BMU_ECH=ctb2*((-7.D0*x**3+29.D0*x**2-16.D0*x)
     &        /(36.D0*(1.D0-x)**3)
     &        +(3.D0*x**2-2.D0*x)/(6.D0*(1.D0-x)**4)*LOG(x))
      End If

      Return
      End

c***********************************************************************

      Double Precision Function BMU_GCH7(x,ctb2)

      Implicit NONE

c Inputs

      Double Precision x,ctb2

c Local
      Double Precision tmp
      Double Complex z

c Functions
      Double Complex DiLog

      z=DCMPLX(x,0.D0)

      tmp=DBLE(DiLog(1.D0-1.D0/z))

      If (ABS(x-1.D0).lt.1.D-3) Then
         BMU_GCH7=(641.D0*ctb2+7240.D0)/3240.D0
      Else
         BMU_GCH7=(-32.D0*x**3+112.D0*x**2-48.D0*x)
     &        /(9.D0*(1.D0-x)**3)*tmp
     &        +(14.D0*x**3-128.D0*x**2+66.D0*x)
     &        /(9.D0*(1.D0-x)**4)*LOG(x)
     &        +(8.D0*x**3-52.D0*x**2+28.D0*x)
     &        /(3.D0*(1.D0-x)**3)
     &        +ctb2*((16.D0*x**4-74.D0*x**3+36.D0*x**2)
     &        /(9.D0*(1.D0-x)**4)*tmp
     &        +(-63.D0*x**4+807.D0*x**3-463.D0*x**2+7.D0*x)
     &        /(81.D0*(1.D0-x)**5)*LOG(x)
     &        +(-1202.D0*x**4+7569.D0*x**3-5436.D0*x**2+797.D0*x)
     &        /(486.D0*(1.D0-x)**4))
      End If

      Return
      End

c***********************************************************************

      Double Precision Function BMU_DeltaCH7(x,ctb2)

      Implicit NONE

c The coefficients of Log(mu) in eqn 47

c Inputs
      Double Precision x,ctb2

      If (ABS(x-1.D0).lt.1.D-3) Then
         BMU_DeltaCH7=-(79.D0*ctb2+350.D0)/270.D0
      Else
         BMU_DeltaCH7=(-12.D0*x**3-56.D0*x**2+32.D0*x)
     &        /(9.D0*(1.D0-x)**4)*LOG(x)
     &        +(16.D0*x**3-94.D0*x**2+42.D0*x)
     &        /(9.D0*(1.D0-x)**3)
     &        +ctb2*((6.D0*x**4+46.D0*x**3-28.D0*x**2)
     &        /(9.D0*(1.D0-x)**5)*LOG(x)
     &        +(-14.D0*x**4+135.D0*x**3-18.D0*x**2-31.D0*x)
     &        /(27.D0*(1.D0-x)**4))
      End If

      Return
      End

c***********************************************************************

      Double Precision Function BMU_GCH8(x,ctb2)

      Implicit NONE

c Inputs

      Double Precision x,ctb2

c Local
      Double Precision tmp
      Double Complex z

c Functions
      Double Complex DiLog

      z=DCMPLX(x,0.D0)

      tmp=DBLE(DiLog(1.D0-1.D0/z))

      If (ABS(x-1.D0).lt.1.D-3) Then
         BMU_GCH8=301.D0*ctb2/4320.D0+3620.D0/4320.D0
      Else
         BMU_GCH8=(-17.D0*x**3+25.D0*x**2-36.D0*x)
     &        /(6.D0*(1.D0-x)**3)*tmp
     &        +(34.D0*x**3-7.D0*x**2+165.D0*x)
     &        /(12.D0*(1.D0-x)**4)*LOG(x)
     &        +(29.D0*x**3-44.D0*x**2+143.D0*x)
     &        /(8.D0*(1.D0-x)**3)
     &        +ctb2*((13.D0*x**4-17.D0*x**3+30.D0*x**2)
     &        /(6.D0*(1.D0-x)**4)*tmp
     &        +(-468.D0*x**4+321.D0*x**3-2155.D0*x**2-2.D0*x)
     &        /(216.D0*(1.D0-x)**5)*LOG(x)
     &        +(-4451.D0*x**4+7650.D0*x**3-18153.D0*x**2+1130.D0*x)
     &        /(1296.D0*(1.D0-x)**4))
      End If

      Return
      End

c***********************************************************************

      Double Precision Function BMU_DeltaCH8(x,ctb2)

      Implicit NONE

c Inputs

      Double Precision x,ctb2

      If (ABS(x-1.D0).lt.1.D-3) Then
         BMU_DeltaCH8=-(59.D0*ctb2+400.D0)/360.D0
      Else
         BMU_DeltaCH8=(7.D0*x**3-16.D0*x**2+81.D0*x)
     &        /(6.D0*(1.D0-x)**3)
     &        +(17.D0*x**2+19.D0*x)
     &        /(3.D0*(1.D0-x)**4)*LOG(x)
     &        +ctb2*((-7.D0*x**4+18.D0*x**3-261.D0*x**2-38.D0*x)
     &        /(36.D0*(1.D0-x)**4)
     &        +(-17.D0*x**3-31.D0*x**2)
     &        /(6.D0*(1.D0-x)**5)*LOG(x))
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_H41(x)

      Implicit NONE

c Inputs

      Double Precision x

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H41=1.D0/12.D0
      Else
         OR_H41=-1.D0/(3.D0*(1.D0-x)**4)*LOG(x)
     &        +(-2.D0*x**2+7.D0*x-11.D0)/(18.D0*(1.D0-x)**3)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_H71p(x)

      Implicit NONE

c Inputs

      Double Precision x

c Local
      Double Precision tmp
      Double Complex z

c Functions
      Double Complex DiLog

      z=DCMPLX(x,0.D0)

      tmp=DBLE(DiLog(1.D0-1.D0/z))

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H71p=-119.D0/1620.D0
      Else
         OR_H71p=(24.D0*x**3+52.D0*x**2-32.D0*x)/(9.D0*(1.D0-x)**4)*tmp
     &        +(-189.D0*x**3-783.D0*x**2+425.D0*x+43.D0)
     &        /(81.D0*(1.D0-x)**5)*LOG(x)
     &        +(-1030.D0*x**3-1899.D0*x**2+1332.D0*x+85.D0)
     &        /(243.D0*(1.D0-x)**4)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_H71pp(x)

      Implicit NONE

c Inputs

      Double Precision x

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H71pp=119.D0/270.D0
      Else
         OR_H71pp=(6.D0*x**3-62.D0*x**2+32.D0*x)
     &        /(9.D0*(1.D0-x)**5)*LOG(x)
     &        +(28.D0*x**3-129.D0*x**2-12.D0*x+41.D0)
     &        /(27.D0*(1.D0-x)**4)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_H72p(x)

      Implicit NONE

c Inputs

      Double Precision x

c Local
      Double Precision tmp
      Double Complex z

c Functions
      Double Complex DiLog

      z=DCMPLX(x,0.D0)

      tmp=DBLE(DiLog(1.D0-1.D0/z))

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H72p=-1.D0/81.D0
      Else
         OR_H72p=(112.D0*x**2-48.D0*x)/(9.D0*(1.D0-x)**3)*tmp
     &        +(12.D0*x**3-176.D0*x**2+64.D0*x+16.D0)
     &        /(9.D0*(1.D0-x)**4)*LOG(x)
     &        +(-170.D0*x**2+66.D0*x+20.D0)
     &        /(9.D0*(1.D0-x)**3)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_H72pp(x)

      Implicit NONE

c Inputs

      Double Precision x

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H72pp=41.D0/27.D0
      Else
         OR_H72pp=(12.D0*x**3-88.D0*x**2+40.D0*x)
     &        /(9.D0*(1.D0-x)**4)*LOG(x)
     &        +(-14.D0*x**2-54.D0*x+32.D0)
     &        /(9.D0*(1.D0-x)**3)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_H81p(x)

      Implicit NONE

c Inputs

      Double Precision x

c Local
      Double Precision tmp
      Double Complex z

c Functions
      Double Complex DiLog

      z=DCMPLX(x,0.D0)

      tmp=DBLE(DiLog(1.D0-1.D0/z))

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H81p=11.D0/135.D0
      Else
         OR_H81p=(-9.D0*x**3-46.D0*x**2-49.D0*x)/(12.D0*(1.D0-x)**4)*tmp
     &        +(81.D0*x**3+594.D0*x**2+1270.D0*x+71.D0)
     &        /(108.D0*(1.D0-x)**5)*LOG(x)
     &        +(923.D0*x**3+3042.D0*x**2+6921.D0*x+1210.D0)
     &        /(648.D0*(1.D0-x)**4)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_H81pp(x)

      Implicit NONE

c Inputs

      Double Precision x

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H81pp=47.D0/180.D0
      Else
         OR_H81pp=(5.D0*x**2+19.D0*x)
     &        /(3.D0*(1.D0-x)**5)*LOG(x)
     &        +(7.D0*x**3-30.D0*x**2+141.D0*x+26.D0)
     &        /(18.D0*(1.D0-x)**4)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_H82p(x)

      Implicit NONE

c Inputs

      Double Precision x

c Local
      Double Precision tmp
      Double Complex z

c Functions
      Double Complex DiLog

      z=DCMPLX(x,0.D0)

      tmp=DBLE(DiLog(1.D0-1.D0/z))

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H82p=29.D0/54.D0
      Else
         OR_H82p=(-16.D0*x**2-12.D0*x)/(3.D0*(1.D0-x)**3)*tmp
     &        +(52.D0*x**2+109.D0*x+7.D0)
     &        /(6.D0*(1.D0-x)**4)*LOG(x)
     &        +(95.D0*x**2+180.D0*x+61.D0)
     &        /(12.D0*(1.D0-x)**3)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_H82pp(x)

      Implicit NONE

c Inputs

      Double Precision x

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H82pp=4.D0/9.D0
      Else
         OR_H82pp=(10.D0*x**2+26.D0*x)
     &        /(3.D0*(1.D0-x)**4)*LOG(x)
     &        +(-x**2+30.D0*x+7.D0)
     &        /(3.D0*(1.D0-x)**3)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_H73p(x)

      Implicit NONE

c Inputs

      Double Precision x

c Local
      Double Precision tmp
      Double Complex z

c Functions
      Double Complex DiLog

      z=DCMPLX(x,0.D0)

      tmp=DBLE(DiLog(1.D0-1.D0/z))

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H73p=181.D0/1620.D0
      Else
         OR_H73p=(16.D0*x**2+28.D0*x)/(9.D0*(1.D0-x)**4)*tmp
     &        +(-108.D0*x**2-358.D0*x-38.D0)/(81.D0*(1.D0-x)**5)*LOG(x)
     &        +(23.D0*x**3-765.D0*x**2-693.D0*x-77.D0)
     &        /(243.D0*(1.D0-x)**4)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_H73pp(x)

      Implicit NONE

c Inputs

      Double Precision x

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H73pp=-23.D0/135.D0
      Else
         OR_H73pp=(4.D0*x**2-28.D0*x)
     &        /(9.D0*(1.D0-x)**5)*LOG(x)
     &        +(-8.D0*x**3+42.D0*x**2-84.D0*x-22.D0)
     &        /(27.D0*(1.D0-x)**4)
      End If

      Return
      End


c***********************************************************************

      Double Precision Function OR_H74p(x)

      Implicit NONE

c Inputs

      Double Precision x

c Local
      Double Precision tmp
      Double Complex z

c Functions
      Double Complex DiLog

      z=DCMPLX(x,0.D0)

      tmp=DBLE(DiLog(1.D0-1.D0/z))

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H74p=17.D0/81.D0
      Else
         OR_H74p=(16.D0*x**2+48.D0*x)/(9.D0*(1.D0-x)**3)*tmp
     &        +(-8.D0*x**2-68.D0*x-8.D0)/(9.D0*(1.D0-x)**4)*LOG(x)
     &        +(-26.D0*x**2-54.D0*x-4.D0)
     &        /(9.D0*(1.D0-x)**3)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_H74pp(x)

      Implicit NONE

c Inputs

      Double Precision x

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H74pp=-13.D0/27.D0
      Else
         OR_H74pp=(8.D0*x**2-44.D0*x)
     &        /(9.D0*(1.D0-x)**4)*LOG(x)
     &        +(10.D0*x**2-30.D0*x-16.D0)
     &        /(9.D0*(1.D0-x)**3)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_H83p(x)

      Implicit NONE

c Inputs

      Double Precision x, OR_H81p

      OR_H83p=OR_H81p(x)

      Return
      End

c***********************************************************************

      Double Precision Function OR_H83pp(x)

      Implicit NONE

c Inputs

      Double Precision x,OR_H81pp

      OR_H83pp=OR_H81pp(x)

      Return
      End


c***********************************************************************

      Double Precision Function OR_H84p(x)

      Implicit NONE

c Inputs

      Double Precision x,OR_H82p

      OR_H84p=OR_H82p(x)

      Return
      End

c***********************************************************************

      Double Precision Function OR_H84pp(x)

      Implicit NONE

c Inputs

      Double Precision x, OR_H82pp

      OR_H84pp=OR_H82pp(x)

      Return
      End

c***********************************************************************

      Double Precision Function OR_H45pp(x)

      Implicit NONE

c Inputs

      Double Precision x

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H45pp=13.D0/48.D0
      Else
         OR_H45pp=(18.D0*x**3-27.D0*x**2+1.D0)
     &        /(24.D0*(1.D0-x)**4)*LOG(x)
     &        +(73.D0*x**2-134.D0*x+37.D0)/(72.D0*(1.D0-x)**3)
      End If

      Return
      End


c***********************************************************************

      Double Precision Function OR_H75p(x)

      Implicit NONE

c Inputs

      Double Precision x

c Local
      Double Precision tmp
      Double Complex z

c Functions
      Double Complex DiLog

      z=DCMPLX(x,0.D0)

      tmp=DBLE(DiLog(1.D0-1.D0/z))

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H75p=-53.D0/1620.D0
      Else
         OR_H75p=(17.D0*x**2+86.D0*x-15.D0)/(18.D0*(1.D0-x)**4)*tmp
     &        +(6.D0*x**3+45.D0*x**2+66.D0*x-5.D0)
     &        /(12.D0*(1.D0-x)**5)*(LOG(x))**2
     &        +(-36.D0*x**4-315.D0*x**3+1161.D0*x**2+751.D0*x+23.D0)
     &        /(162.D0*(1.D0-x)**5)*LOG(x)
     &        +(-799.D0*x**3+1719.D0*x**2+10431.D0*x-1847.D0)
     &        /(972.D0*(1.D0-x)**4)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_H75pp(x)

      Implicit NONE

c Inputs

      Double Precision x

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H75pp=-31.D0/1080.D0
      Else
         OR_H75pp=(18.D0*x**3+107.D0*x**2+43.D0*x)
     &        /(18.D0*(1.D0-x)**5)*LOG(x)
     &        +(-5.D0*x**3+384.D0*x**2+609.D0*x+20.D0)
     &        /(108.D0*(1.D0-x)**4)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_H76p(x)

      Implicit NONE

c Inputs

      Double Precision x

c Local
      Double Precision tmp
      Double Complex z

c Functions
      Double Complex DiLog

      z=DCMPLX(x,0.D0)

      tmp=DBLE(DiLog(1.D0-1.D0/z))

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H76p=-377.D0/648.D0
      Else
         OR_H76p=(19.D0*x**2+60.D0*x-15.D0)/(9.D0*(1.D0-x)**3)*tmp
     &        +(6.D0*x**3+36.D0*x**2+48.D0*x-5.D0)
     &        /(6.D0*(1.D0-x)**4)*(LOG(x))**2
     &        +(-27.D0*x**3+106.D0*x**2+52.D0*x+1.D0)
     &        /(9.D0*(1.D0-x)**4)*LOG(x)
     &        +(14.D0*x**2+333.D0*x-83.D0)
     &        /(18.D0*(1.D0-x)**3)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_H76pp(x)

      Implicit NONE

c Inputs

      Double Precision x

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H76pp=1.D0/54.D0
      Else
         OR_H76pp=(18.D0*x**3+80.D0*x**2+28.D0*x)
     &        /(9.D0*(1.D0-x)**4)*Log(x)
     &        +(55.D0*x**2+69.D0*x+2.D0)/(9.D0*(1.D0-x)**3)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_H85p(x)

      Implicit NONE

c Inputs

      Double Precision x

c Local
      Double Precision tmp
      Double Complex z

c Functions
      Double Complex DiLog

      z=DCMPLX(x,0.D0)

      tmp=DBLE(DiLog(1.D0-1.D0/z))

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H85p=-217.D0/540.D0
      Else
         OR_H85p=(45.D0*x**3-1208.D0*x**2+901.D0*x-570.D0)
     &        /(96.D0*(1.D0-x)**4)*tmp
     &        +(-237.D0*x**3-846.D0*x**2+282.D0*x-95.D0)
     &        /(32.D0*(1.D0-x)**5)*(LOG(x))**2
     &        +(2520.D0*x**4-10755.D0*x**3-10638.D0*x**2-6427.D0*x
     &        -44.D0)
     &        /(864.D0*(1.D0-x)**5)*LOG(x)
     &        +(5359.D0*x**3-241425.D0*x**2+143253.D0*x-59251.D0)
     &        /(5184.D0*(1.D0-x)**4)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_H85pp(x)

      Implicit NONE

c Inputs

      Double Precision x

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H85pp=-13.D0/45.D0
      Else
         OR_H85pp=(-747.D0*x**3-640.D0*x**2+43.D0*x)
     &        /(48.D0*(1.D0-x)**5)*LOG(x)
     &        +(-779.D0*x**3-7203.D0*x**2-93.D0*x+11.D0)
     &        /(288.D0*(1.D0-x)**4)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_H86p(x)

      Implicit NONE

c Inputs

      Double Precision x

c Local
      Double Precision tmp
      Double Complex z

c Functions
      Double Complex DiLog

      z=DCMPLX(x,0.D0)

      tmp=DBLE(DiLog(1.D0-1.D0/z))

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H86p=1031.D0/864.D0
      Else
         OR_H86p=(-359.D0*x**2+339.D0*x-204.D0)/(24.D0*(1.D0-x)**3)*tmp
     &        +(-78.D0*x**3-333.D0*x**2+105.D0*x-34.D0)
     &        /(8.D0*(1.D0-x)**4)*(LOG(x))**2
     &        +(-207.D0*x**3-1777.D0*x**2+23.D0*x-151.D0)
     &        /(48.D0*(1.D0-x)**4)*LOG(x)
     &        +(-1667.D0*x**2+990.D0*x-379.D0)
     &        /(24.D0*(1.D0-x)**3)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function OR_H86pp(x)

      Implicit NONE

c Inputs

      Double Precision x

      If (ABS(x-1.D0).lt.1.D-3) Then
         OR_H86pp=-119.D0/36.D0
      Else
         OR_H86pp=(-126.D0*x**3-133.D0*x**2+7.D0*x)
     &        /(6.D0*(1.D0-x)**4)*LOG(x)
     &        +(-553.D0*x**2+84.D0*x-35.D0)/(12.D0*(1.D0-x)**3)
      End If

      Return
      End

c***********************************************************************

      Double Complex Function GM_afun(x)

c Eqn D.1 of Gambino and Misiak hep-ph/0104034
c***********************************************************************
      
      Implicit NONE

c Inputs
      Double Precision x
            
c Parameters
      Double Precision PI
      Parameter (PI=3.1415926535897932384626433832795029D0)
      Double Precision zeta3
      Parameter(zeta3=1.2020569031595942854D0)

      If (x.eq.0.D0) Then
         GM_afun=0.D0
      Else
         GM_afun=16.D0/9.D0*((5.D0/2.D0-1.D0/3.D0*PI**2-3*zeta3
     &        +(5.D0/2.D0-3.D0/4.D0*PI**2)*LOG(x)
     &        +1.D0/4.D0*LOG(x)**2+1.D0/12.D0*LOG(x)**3)*x
     &        +(7.D0/4.D0+2.D0/3.D0*PI**2-1.D0/2.D0*PI**2*LOG(x)
     &        -1.D0/4.D0*LOG(x)**2+1.D0/12.D0*LOG(x)**3)*x**2
     &        +(-7.D0/6.D0-1.D0/4.D0*PI**2+2.D0*LOG(x)
     &        -3.D0/4.D0*LOG(x)**2)*x**3
     &        +DCMPLX(0.D0,1.D0)*PI*((2.D0-1.D0/6.D0*PI**2
     &        +1.D0/2.D0*LOG(x)+1.D0/2.D0*LOG(x)**2)*x
     &        +(1.D0/2.D0-1.D0/6.D0*PI**2-LOG(x)
     &        +1.D0/2.D0*LOG(x)**2)*x**2+x**3))
      End If
      
      Return
      End
      
c***********************************************************************

      Double Complex Function GM_bfun(x)

c Eqn D.2 of Gambino and Misiak hep-ph/0104034
c***********************************************************************
      
      Implicit NONE

c Inputs
      Double Precision x
            
c Parameters
      
      Double Precision PI
      Parameter (PI=3.1415926535897932384626433832795029D0)

      
      If (x.eq.0.D0) Then
         GM_bfun=0.D0
      Else
         GM_bfun=-8.D0/9.D0*((-3.D0+1.D0/6.D0*PI**2-LOG(x))*x
     &        +(1.D0/2.D0+PI**2-2.D0*LOG(x)-1.D0/2.D0*LOG(x)**2)*x**2
     &        +(-25.D0/12.D0-1.D0/9.D0*PI**2-19.D0/18.D0*LOG(x)
     &        +2.D0*LOG(x)**2)*x**3-2.D0/3.D0*PI**2*x**(3.D0/2.D0)
     &        +DCMPLX(0.D0,1.D0)*PI*(-x+(1.D0-2.D0*LOG(x))*x**2
     &        +(-10.D0/9.D0+4.D0/3.D0*LOG(x))*x**3))
      End If
      
      Return
      End
      
c***********************************************************************

      Double Precision Function GM_A0(x)

c Eqn 2.7a of Gambino and Misiak hep-ph/0104034
c***********************************************************************
    
      Implicit NONE

c Inputs
      Double Precision x
            
c Parameters
      
      If (ABS(x-1.D0).lt.1.D-3) Then
         GM_A0=-77.D0/72.D0
      Else
         GM_A0=(-3.D0*x**3+2.D0*x**2)/(2.D0*(x-1.D0)**4)*LOG(x)
     &        +(-22.D0*x**3+153.D0*x**2-159.D0*x+46.D0)
     &        /(36.D0*(x-1.D0)**3)
      End If
      
      Return
      End
      
c***********************************************************************

      Double Precision Function GM_F0(x)

c Eqn 2.7a of Gambino and Misiak hep-ph/0104034
c***********************************************************************
    
      Implicit NONE

c Inputs
      Double Precision x
            
c Parameters
      
      If (ABS(x-1.D0).lt.1.D-3) Then
         GM_F0=-13.D0/24.D0
      Else
         GM_F0=3.D0*x**2/(2.D0*(x-1.D0)**4)*LOG(x)
     &        +(-5.D0*x**3+9.D0*x**2-30.D0*x+8.D0)/(12.D0*(x-1.D0)**3)
      End If
      
      Return
      End
      
c***********************************************************************

      Double Precision Function GM_A0pr(x)

c The derivative w.r.t x of Eqn 2.7a of Gambino and Misiak
c***********************************************************************
    
      Implicit NONE

c Inputs
      Double Precision x
            
c Parameters
      
      If (ABS(x-1.D0).lt.1.D-3) Then
         GM_A0pr=13.D0/120.D0
      Else
         GM_A0pr=(3.D0*x**3+5.D0*x**2-4.D0*x)
     &        /(2.D0*(x-1.D0)**5)*LOG(x)
     &        +(-47.D0*x**3+63.D0*x**2-9.D0*x-7.D0)/(12.D0*(x-1.D0)**5)
      End If
      
      Return
      End
      
c***********************************************************************

      Double Precision Function GM_F0pr(x)

c The derivative w.r.t x of Eqn 2.7b of Gambino and Misiak
c***********************************************************************
    
      Implicit NONE

c Inputs
      Double Precision x
      
      If (ABS(x-1.D0).lt.1.D-3) Then
         GM_F0pr=1.D0/20.D0
      Else
         GM_F0pr=(-3.D0*x**2-3.D0*x)/((x-1.D0)**5)*LOG(x)
     &        +(x**2+10.D0*x+1.D0)/(2.D0*(x-1.D0)**4)
      End If
      
      Return
      End

c***********************************************************************

      Double Precision Function GM_E0(x)

c Eqn 3.8 of Gambino and Misiak hep-ph/0104034
c***********************************************************************
    
      Implicit NONE

c Inputs
      Double Precision x
            
c Parameters
      
      If (ABS(x-1.D0).lt.1.D-3) Then
         GM_E0=17.D0/24.D0
      Else
         GM_E0=(-9.D0*x**2+16.D0*x-4)/(6.D0*(x-1.D0)**4)*LOG(x)
     &        +(7.D0*x**3+21.D0*x**2-42.D0*x-4.D0)/(36.D0*(x-1.D0)**3)
      End If
      
      Return
      End

c***********************************************************************

      Double Precision Function GM_A1(x)

c Eqn 3.8 of Gambino and Misiak hep-ph/0104034
c***********************************************************************
    
      Implicit NONE

c Inputs
      Double Precision x

c Local
      Double Precision tmp
      Double Complex z

c Functions
      Double Complex DiLog

      z=DCMPLX(x,0.D0)
      tmp=DBLE(DiLog(1.D0-1.D0/z))
      
      If (ABS(x-1.D0).lt.1.D-3) Then
         GM_A1=10757.D0/1620.D0
      Else
         GM_A1=(32.D0*x**4+244.D0*x**3-160.D0*x**2+16.D0*x)
     &        /(9.D0*(1.D0-x)**4)*tmp
     &        +(-774.D0*x**4-2826.D0*x**3+1994.D0*x**2-130.D0*x+8.D0)
     &        /(81.D0*(1.D0-x)**5)*LOG(x)
     &        +(-94.D0*x**4-18665.D0*x**3+20682.D0*x**2-9113.D0*x
     &        +2006.D0)/(243.D0*(1.D0-x)**4)
      End If
      
      Return
      End      
      
c***********************************************************************

      Double Precision Function GM_F1(x)

c Eqn 3.8 of Gambino and Misiak hep-ph/0104034
c***********************************************************************
    
      Implicit NONE

c Inputs
      Double Precision x

c Local
      Double Precision tmp
      Double Complex z

c Functions
      Double Complex DiLog

      z=DCMPLX(x,0.D0)
      tmp=DBLE(DiLog(1.D0-1.D0/z))
      
      If (ABS(x-1.D0).lt.1.D-3) Then
         GM_F1=4537.D0/2160.D0
      Else
         GM_F1=(4.D0*x**4-40.D0*x**3-41.D0*x**2-x)
     &        /(3.D0*(1.D0-x)**4)*tmp
     &        +(-144.D0*x**4+3177.D0*x**3+3661.D0*x**2+250.D0*x-32.D0)
     &        /(108.D0*(1.D0-x)**5)*LOG(x)
     &        +(-247.D0*x**4+11890.D0*x**3+31779.D0*x**2-2966.D0*x
     &        +1016.D0)/(648.D0*(1.D0-x)**4)
      End If
      
      Return
      End

c***********************************************************************

      Double Precision Function phi22(delta)

c Eqn E.2 of Gambino and Misiak hep-ph/0104034
c***********************************************************************

      Implicit NONE

c Inputs
      Double Precision delta,z
      Common/phiarg/z

      Double Precision Integrand1,Integrand2
      Double Precision work(400),res1,res2,abserr
      Integer ier,iwork(100),last,neval

      External Integrand1,Integrand2

      Call dqags(Integrand1,0.D0,(1.D0-delta)/z,1D-5,1D-6,res1,abserr,
     &     neval,ier,100,400,last,iwork,work)

      If (ier.ne.0) Then
         Write(*,*) ier, 'ERROR IN NUMERICAL INTEGRATION'
      End If

      Call dqags(Integrand2,(1.D0-delta)/z,1.D0/z,1D-5,1D-6,res2,abserr,
     &     neval,ier,100,400,last,iwork,work)

      If (ier.ne.0) Then
         Write(*,*) ier, 'ERROR IN NUMERICAL INTEGRATION'
      End If

      phi22=16.D0/27.D0*z*(delta*res1+res2)

      Return
      End

c***********************************************************************

      Double Precision Function phi27(delta)

c Eqn E.3 of Gambino and Misiak hep-ph/0104034
c***********************************************************************

      Implicit NONE

c Inputs
      Double Precision delta,z
      Common/phiarg/z

      Double Precision Integrand3,Integrand4
      Double Precision work(400),res1,res2,abserr
      Integer ier,iwork(100),last,neval

      External Integrand3,Integrand4

      Call dqags(Integrand3,0.D0,(1.D0-delta)/z,1D-5,1D-6,res1,abserr,
     &     neval,ier,100,400,last,iwork,work)

      If (ier.ne.0) Then
         Write(*,*) ier, 'ERROR IN NUMERICAL INTEGRATION'
      End If

      Call dqags(Integrand4,(1.D0-delta)/z,1.D0/z,1D-5,1D-6,res2,abserr,
     &     neval,ier,100,400,last,iwork,work)

      If (ier.ne.0) Then
         Write(*,*) ier, 'ERROR IN NUMERICAL INTEGRATION'
      End If

      phi27=-8.D0/9.D0*z**2*(delta*res1+res2)

      Return
      End

c***********************************************************************

      Double Precision Function phi77(delta)

c Eqn E.4 of Gambino and Misiak hep-ph/0104034
c***********************************************************************

      Implicit NONE

c Inputs
      Double Precision delta

      If (delta.eq.1.D0) Then
         phi77=0.D0
      Else
         phi77=-2.D0/3.D0*LOG(delta)**2-7.D0/3.D0*LOG(delta)-31.D0/9.D0
     &        +10.D0/3.D0*delta+1.D0/3.D0*delta**2-2.D0/9.D0*delta**3
     &        +1.D0/3.D0*delta*(delta-4.D0)*LOG(delta)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function phi78(delta)

c Eqn E.5 of Gambino and Misiak hep-ph/0104034
c***********************************************************************

      Implicit NONE

c Inputs
      Double Precision delta

c Local
      Double Precision tmp
      Double Complex zd

c Functions
      Double Complex DiLog

c Parameters
      Double Precision PI
      Parameter (PI=3.1415926535897932384626433832795029D0)

      zd=DCMPLX(delta,0.D0)
      tmp=DBLE(DiLog(1.D0-zd))

      If (delta.eq.1.D0) Then
         phi78=0.D0
      Else
         phi78=8.D0/9.D0*(tmp-PI**2/6.D0-delta*LOG(delta)
     &        +9.D0/4.D0*delta-1.D0/4.D0*delta**2+1.D0/12.D0*delta**3)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function phi88(delta,xbs)

c Eqn E.5 of Gambino and Misiak hep-ph/0104034
c***********************************************************************

      Implicit NONE

c Inputs
      Double Precision delta,xbs

c Local
      Double Precision tmp
      Double Complex zd

c Functions
      Double Complex DiLog

c Parameters
      Double Precision PI
      Parameter (PI=3.1415926535897932384626433832795029D0)

      zd=DCMPLX(delta,0.D0)
      tmp=DBLE(DiLog(1.D0-zd))

      If (delta.eq.1.D0) Then
         phi88=0.D0
      Else
         phi88=1.D0/27.D0*(-2.D0*LOG(xbs)*(delta**2+2.D0*delta
     &        +4.D0*LOG(1.D0-delta))+4.D0*tmp-2.D0*PI**2/3.D0
     &        -delta*(2.D0+delta)*LOG(delta)+8.D0*LOG(1.D0-delta)
     &        -2.D0/3.D0*delta**3+3.D0*delta**2+7.D0*delta)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function Integrand1(t)

c Eqn E.2 of Gambino and Misiak hep-ph/0104034
c***********************************************************************

      Implicit NONE
      
c Inputs
      Double Precision t

c Local
      Double Complex tmp

c Common
      Double Precision z
      Common/phiarg/z

c Parameters
      Double Precision PI
      Parameter (PI=3.1415926535897932384626433832795029D0)

      If (t.eq.0.D0) Then
         tmp=DCMPLX(0.D0,0.D0)
         Integrand1=(1.D0-z*t)*ABS(tmp)**2
      Else If (t.lt.4.D0) Then
         tmp=(-2.D0*ATAN(SQRT(t/(4.D0-t)))**2)/t+1.D0/2.D0
         Integrand1=(1.D0-z*t)*ABS(tmp)**2
      Else
         tmp=(-PI**2/2.D0+2.D0*LOG((SQRT(t)+SQRT(t-4.D0))/2.D0)**2
     &        -2.D0*DCMPLX(0.D0,1.D0)
     &        *PI*LOG((SQRT(t)+SQRT(t-4.D0))/2.D0))/t+1.D0/2.D0
         Integrand1=(1.D0-z*t)*ABS(tmp)**2
      End If

      Return
      End

c***********************************************************************

      Double Precision Function Integrand2(t)

c Eqn E.3 of Gambino and Misiak hep-ph/0104034
c***********************************************************************

      Implicit NONE

c Inputs
      Double Precision t

c Local
      Double Complex tmp

c Common
      Double Precision z
      Common/phiarg/z

c Parameters
      Double Precision PI
      Parameter (PI=3.1415926535897932384626433832795029D0)

      If (t.eq.0.D0) Then
         tmp=DCMPLX(0.D0,0.D0)
         Integrand2=(1.D0-z*t)**2*ABS(tmp)**2
      Else If (t.lt.4.D0) Then
         tmp=(-2.D0*ATAN(SQRT(t/(4.D0-t)))**2)/t+1.D0/2.D0
         Integrand2=(1.D0-z*t)**2*ABS(tmp)**2
      Else
         tmp=(-PI**2/2.D0+2.D0*LOG((SQRT(t)+SQRT(t-4.D0))/2.D0)**2
     &        -2.D0*DCMPLX(0.D0,1.D0)
     &        *PI*LOG((SQRT(t)+SQRT(t-4.D0))/2.D0))/t+1.D0/2.D0
         Integrand2=(1.D0-z*t)**2*ABS(tmp)**2
      End If

      Return
      End

c***********************************************************************

      Double Precision Function Integrand3(t)

c Eqn E.2 of Gambino and Misiak hep-ph/0104034
c***********************************************************************

      Implicit NONE

c Inputs
      Double Precision t

c Local
      Double Complex tmp

c Parameters
      Double Precision PI
      Parameter (PI=3.1415926535897932384626433832795029D0)

      If (t.eq.0.D0) Then
         tmp=DCMPLX(0.D0,0.D0)
         Integrand3=DBLE(tmp)
      Else If (t.lt.4.D0) Then
         tmp=(-2.D0*ATAN(SQRT(t/(4.D0-t)))**2)+t/2.D0
         Integrand3=DBLE(tmp)
      Else
         tmp=-PI**2/2.D0+2.D0*LOG((SQRT(t)
     &        +SQRT(t-4.D0))/2.D0)**2
     &        -2.D0*DCMPLX(0.D0,1.D0)
     &        *PI*LOG((SQRT(t)+SQRT(t-4.D0))/2.D0)+t/2.D0
         Integrand3=DBLE(tmp)
      End If

      Return
      End

c***********************************************************************

      Double Precision Function Integrand4(t)

c Eqn E.3 of Gambino and Misiak hep-ph/0104034
c***********************************************************************

      Implicit NONE

c Inputs      
      Double Precision t

c Local
      Double Complex tmp

c Commons
      Double Precision z
      Common/phiarg/z

c Parameters
      Double Precision PI
      Parameter (PI=3.1415926535897932384626433832795029D0)

      If (t.eq.0.D0) Then
         tmp=DCMPLX(0.D0,0.D0)
         Integrand4=DBLE(tmp)
      Else If (t.lt.4.D0) Then
         tmp=(-2.D0*ATAN(SQRT(t/(4.D0-t)))**2)+t/2.D0
         Integrand4=(1.D0-z*t)*DBLE(tmp)
      Else
         tmp=-PI**2/2.D0+2.D0*LOG((SQRT(t)+SQRT(t-4.D0))/2.D0)**2
     &        -2.D0*DCMPLX(0.D0,1.D0)
     &        *PI*LOG((SQRT(t)+SQRT(t-4.D0))/2.D0)+t/2.D0
         Integrand4=(1.D0-z*t)*DBLE(tmp)
      End If

      Return
      End
