c**********************************************************************

      Subroutine bsgsetup(debug)

c Subroutine that reads the various parameters needed for the
c calculation \overline{B}_s\to X_s\gamma from the file bsgpar.in
c**********************************************************************

      Implicit NONE
      
      Include 'insm.h'
      Include 'vars.h'
      Include 'bsg.h'

c Input
      Integer debug

c Local variables
      Integer i,j,m

c Functions
      Double Precision MSrmass
      Double Precision phi22,phi27,phi77,phi78,phi88
      Character*150 filein

      Double Precision z
      Common/phiarg/z

      filein = trim(bdecayroot)//'BDin/bsgpar.in'

      Open(11,FILE=filein,status='OLD')

c Read data from the file

      Do i=1,4
         Read(11,*)
      End Do

      Read(11,*) GMa(1),GMa(2),GMa(3),GMa(4)
      Read(11,*) GMa(5),GMa(6),GMa(7),GMa(8)

      Do i=1,2
         Read(11,*)
      End Do

      Read(11,*) GMd(1),GMd(2),GMd(3),GMd(4)
      Read(11,*) GMd(5),GMd(6),GMd(7),GMd(8)

      Do i=1,2
         Read(11,*)
      End Do

      Read(11,*) GMdt(1),GMdt(2),GMdt(3),GMdt(4)
      Read(11,*) GMdt(5),GMdt(6),GMdt(7),GMdt(8)

      Do i=1,2
         Read(11,*)
      End Do

      Read(11,*) GMdtn(1),GMdtn(2),GMdtn(3),GMdtn(4)
      Read(11,*) GMdtn(5),GMdtn(6),GMdtn(7),GMdtn(8)

      Do i=1,2
         Read(11,*)
      End Do

      Read(11,*) GMdta(1),GMdta(2),GMdta(3),GMdta(4)
      Read(11,*) GMdta(5),GMdta(6),GMdta(7),GMdta(8)

      Do i=1,2
         Read(11,*)
      End Do

      Read(11,*) GMdtb(1),GMdtb(2),GMdtb(3),GMdtb(4)
      Read(11,*) GMdtb(5),GMdtb(6),GMdtb(7),GMdtb(8)

      Do i=1,2
         Read(11,*)
      End Do

      Read(11,*) GMdtpi(1),GMdtpi(2),GMdtpi(3),GMdtpi(4)
      Read(11,*) GMdtpi(5),GMdtpi(6),GMdtpi(7),GMdtpi(8)

      Do i=1,2
         Read(11,*)
      End Do

      Read(11,*) GMe(1),GMe(2),GMe(3),GMe(4)
      Read(11,*) GMe(5),GMe(6),GMe(7),GMe(8)

      Do i=1,2
         Read(11,*)
      End Do

      Read(11,*) m_b1s

      Do i=1,2
         Read(11,*)
      End Do

      Read(11,*) GMCfac

      Do i=1,2
         Read(11,*)
      End Do

      Read(11,*) GMlambda2

      Do i=1,2
         Read(11,*)
      End Do

      Read(11,*) GMBtoleps

      Do i=1,2
         Read(11,*)
      End Do

      Read(11,*) OSalphaEM

      Do i=1,2
         Read(11,*)
      End Do

      Read(11,*) GMdelta

      Close(Unit=11,Status='KEEP')

c Now calculate the matrix phi_ij relevant to the bremstrahlung
c contribution.

      Do i=1,8
         Do j=1,8
            GMphi(i,j)=0.D0
         End Do
      End Do

      z=((MSrmass(mub,4,5,4)+MSrmass(mu_up(2),4,5,4))/2.D0)**2/m_b1s**2

      GMphi(2,2)=phi22(GMdelta)
      GMphi(2,7)=phi27(GMdelta)
      GMphi(7,7)=phi77(GMdelta)
      GMphi(7,8)=phi78(GMdelta)
      GMphi(8,8)=phi88(GMdelta,(m_b1s/MSrmass(mub,3,5,4)))
      GMphi(1,1)=1.D0/36.D0*GMphi(2,2)
      GMphi(1,2)=-1.D0/3.D0*GMphi(2,2)
      GMphi(1,7)=-1.D0/6.D0*GMphi(2,7)
      GMphi(1,8)=1.D0/18.D0*GMphi(2,7)
      GMphi(2,8)=-1.D0/3.D0*GMphi(2,7)

      Return
      End
