c***********************************************************************

      Subroutine calc3x3(th12,th13,th23,delta,V)

c Subroutine that uses the standard parameterisation of a 3x3 unitary 
c matrix to determine the remaining elements of the matrix from the 3
c angles and complex phase.
c Based on set_standard3x3.f by Ken-ichi Okumura
c***********************************************************************

      Implicit NONE

c Input
      Double Precision th12,th13,th23,delta
c Output
      Double Complex V(3,3)

c*************************************************************
c Parameterisation based on that detailed in PDG review

      V(1,1)=DCMPLX(DCOS(th12)*DCOS(th13),0.0D0)
      V(1,2)=DCMPLX(DSIN(th12)*DCOS(th13),0.0D0)
      V(1,3)=DCMPLX(DSIN(th13),0.0D0)
     &	*DCMPLX(DCOS(-delta),DSIN(-delta))
      V(2,1)=(DCMPLX(-DSIN(th12)*DCOS(th23),0.0D0)
     &	+DCMPLX(-DCOS(th12)*DSIN(th23)*DSIN(th13),0.0D0)
     &	*DCMPLX(DCOS(delta),DSIN(delta)))
      V(2,2)=(DCMPLX(DCOS(th12)*DCOS(th23),0.0D0)
     &	+DCMPLX(-DSIN(th12)*DSIN(th23)*DSIN(th13),0.0D0)
     &	*DCMPLX(DCOS(delta),DSIN(delta)))
      V(2,3)=DCMPLX(DSIN(th23)*DCOS(th13),0.0D0)
      V(3,1)=(DCMPLX(DSIN(th12)*DSIN(th23),0.0D0)
     &	+DCMPLX(-DCOS(th12)*DCOS(th23)*DSIN(th13),0.0D0)
     &	*DCMPLX(DCOS(delta),DSIN(delta)))
      V(3,2)=(DCMPLX(-DCOS(th12)*DSIN(th23),0.0D0)
     &	+DCMPLX(-DSIN(th12)*DCOS(th23)*DSIN(th13),0.0D0)
     &	*DCMPLX(DCOS(delta),DSIN(delta)))
      V(3,3)=DCMPLX(DCOS(th23)*DCOS(th13),0.0D0)

      Return
      End
