c***********************************************************************

      Subroutine SVDmat(debug,dim,Mat,ZSU,ZSV,EVals)

c Subroutine that diagonalizes the dim*dim matrix Mat such that
c EVals=U*Mat*V^{dag}
c***********************************************************************

      Implicit NONE

c Inputs
      Integer debug,dim
      Double Complex Mat(dim,dim)

c Outputs
      Double Complex ZSU(dim,dim), ZSV(dim,dim)
      Double Precision EVals(dim)

c Local
      Integer i,j,k,l
      Integer ierr
      Double Complex tmp1
      Double Complex MMatrix(dim,dim), MDi(dim,dim)
      Double Complex ZSU1(dim,dim), ZSV1(dim,dim)
      Double Precision Evals1(dim)

      Double Complex work(4*dim)
      Double Precision rwork(5*dim)

      Do i=1,dim
         Do j=1,dim
            MMatrix(i,j)=Mat(i,j)
         End Do
      End Do

      Call ZGESVD('A','A',dim,dim,MMatrix,dim,EVals1,ZSU1,dim,ZSV1,dim,
     &     work,4*dim,rwork,ierr)

      Do i=1,dim
         Do j=1,dim
            ZSU(dim-i+1,j)=DCONJG(ZSU1(j,i))
            ZSV(dim-i+1,j)=ZSV1(i,j)
         End Do
         EVals(i)=EVals1(dim-i+1)
      End Do

      Do i=1,dim
         Do j=1,dim
            tmp1=DCMPLX(0.D0,0.D0)
            Do k=1,dim
               Do l=1,dim
                  tmp1=tmp1+ZSU(i,k)*Mat(k,l)*DCONJG(ZSV(j,l))
               End Do
            End Do
            MDi(i,j)=tmp1
         End Do
      End Do

      Return
      End
