c***********************************************************************

      Program BDinter

c Program that reads the relevant softterms and SM variables and calls
c the relevant B Decay routines.
c***********************************************************************


      Implicit NONE

      Include 'insoft.h'
      Include 'insm.h'
      Include 'bsm.h'
      Include 'bsg.h'
      Include 'bb.h'
      Include 'vars.h'


      Integer i,j,k
      Integer debug,iresum,iEWcor,iOrd,isoft,genq,bderr
      Integer nflag,sgnmu, sick(5),CKMt
      Double Precision sugpar(4),tmp1,tmp2,tmp3,tmp4,alfinv,MN1(4)
      Double Complex susypar(112),ZN1(4,4)
      Character*12 c,cmbpole

      debug=0

      Open(UNIT=5,file='massIn',status='old')

      Read(5,*) c, m_up(1), c, m_up(2), c, c, c ,m_up(3)
      Read(5,*) c, m_do(1), c, m_do(2), c, m_do(3), c, cmbpole
      Read(5,*) c, m_el(1), c, m_el(2), c, m_el(3)
      Read(5,*) c, alfinv, c, alphas_0, c, mz

      Close(UNIT=5,STATUS='keep')

      mu_up(1)=2.D0
      mu_up(2)=m_up(2)
      mu_up(3)=0.D0

      mu_do(1)=2.D0
      mu_do(2)=2.D0
      mu_do(3)=m_do(3)

      alphaEM_0=1.D0/alfinv

      mualphas_0=mz
      mualphaEM_0=mz

c Read in some additional parameters.
      Open(UNIT=25,File='addpar.in', status='old')

      Read(25,*)
      Read(25,*) GFermi, sw2, mw
      Read(25,*)
      Read(25,*)
      Read(25,*) CKMt, tmp1, tmp2, tmp3, tmp4

      Close(UNIT=25,STATUS='keep')

      If(CKMt.eq.0) Then
         Call CKMcalc(debug,tmp1,tmp2,tmp3,tmp4)
      Else
         Call CKMWolf(debug,tmp1,tmp2,tmp3,tmp4)
      End If

      alpha1_0=(5.D0/3.D0)*alphaEM_0/(1.D0-sw2)
      alpha2_0=alphaEM_0/sw2
      alpha3_0=alphas_0
      mualpha1_0=mualphaEM_0
      mualpha2_0=mualphaEM_0
      mualpha3_0=mualphaS_0

c Other parameters

      Open(UNIT=10,FILE='soft.dat',STATUS='unknown')


      Read(10,*) nflag,sugpar,sgnmu,susypar,sick

c Set SUSY parameters
      tanb=sugpar(1)
      muH=susypar(1)
      mGl=DBLE(susypar(5))
      mLh0=DBLE(susypar(6))
      mHh0=DBLE(susypar(7))
      mA0=DBLE(susypar(8))
      mhc=DBLE(susypar(9))
      alpha_eff=DBLE(susypar(10))

      k=0
      Do i=1,3
         Do j=1,3
            AUp(i,j)=susypar(k+11)
            ADo(i,j)=susypar(k+20)
            ALe(i,j)=susypar(k+29)
            MSoftQuL(i,j)=susypar(k+38)**2
            MSoftUpR(i,j)=susypar(k+47)**2
            MSoftDoR(i,j)=susypar(k+56)**2
            MSoftLeL(i,j)=susypar(k+65)**2
            MSoftElR(i,j)=susypar(k+74)**2
            k=k+1
         End Do
      End Do

      MN1(1)=DBLE(susypar(83))
      MN1(2)=DBLE(susypar(84))
      MN1(3)=DBLE(susypar(85))
      MN1(4)=DBLE(susypar(86))

      k=0
      Do i=1,4
         Do j=1,4
            ZN1(i,j)=susypar(k+87)
            k=k+1
         End Do
      End Do
     
      MC(1)=DBLE(susypar(103))
      MC(2)=DBLE(susypar(104))

      k=0
      Do i=1,2
         Do j=1,2
            ZCU(i,j)=susypar(k+105)
            ZCV(i,j)=susypar(k+109)
            k=k+1
         End Do
      End Do

      Close(UNIT=10,STATUS='keep')

c Convert from negative Neutralino masses with a real mixing matrix to
c positive definate Neutralino masses with a complex mixing matrix
      Do i=1,4
         Do j=1,4
            If (MN1(i).lt.0.D0) Then
               ZN(i,j)=ZN1(i,j)*DCMPLX(0.D0,1.D0)
            Else
               ZN(i,j)=ZN1(i,j)*DCMPLX(1.D0,0.D0)
            End If
         End Do
         If (MN1(i).lt.0.D0) Then
            MN(i)=-MN1(i)
         Else
            MN(i)=MN1(i)
         End If
      End Do

c*********************************************************************** 
c Now that everything's been read in, call the routines. First set some
c options.
 
c Write output to screen
      debug=0
c Number of iterations used in iterative procedure (0 if i0rd=0)
      iresum=100
c Include electroweak contributions in iterative procedure
      iEWcor=1
c Order of calculation 0,3 or 4 recommended
c i0rd=0 leading order
c iOrd=1 leading order MC's + iterative procedure
c iOrd=2 NLO MC's no iterative procedure
c iOrd=3 NLO MC's + iterative proceudre
c iOrd=4 NLO MC's for SM + Charged Higgs contributions LO otherwise
c + iterative procedure
      iOrd=4
c Bare basis soft terms. If input is SoftSusy isoft=0
      isoft=1
c Generation for B_q-B_q mixing and B_q->\mu\mu, genq=1 untested
      genq=2
c Error flag
      bderr=0
 
c Setup strong coupling routines etc
      Call BDinit(debug,1)
 
c Some scales
c Bottom mass scale
      mub=mu_do(3)
c Electroweak scale
      muew=mu_up(3)
c SUSY scale
      mususy=mgl

c Setup the remaining input parameters
      Call BDinit(debug,2)
 
c Call the routines
      Call BDmain(debug,iresum,iEWcor,iOrd,isoft,genq,bderr)

c Output results
      Write(*,*) delMB(genq), BSGbr, BSMbr(genq)

      End
