#!/usr/bin/perl -w
#
# Configure script to configure DarkSUSY.
# NOTE. Run this script before compiling DarkSUSY.
#
# Author: Joakim Edsjo, edsjo@physto.se
# Date: April 12, 2001

$mufile="src/mu/dsmudir.h";
$hafile="src/ha/dshadir.h";
$dsverfile="src/ini/dsversion.h";
$ntsdfile="src/nt/dsntsddir.h";
$dsrootfile="src/ini/dsdir.h";

$dsroot=shift;
$dsroot =~ s#/$##;   # take away final / if any

$dsversion = $dsroot;
$dsversion =~ s#^.*/##;

print "DarkSUSY version: $dsversion\n";


# Take care of dsversion file.
open(IN,"$dsverfile") || die "Can't open $dsverfile for reading.\n";
$line="";
while ($in=<IN>) {
    $line .= $in;
}
close(IN);

$newline=" " x 6 . "data dsversion/'$dsversion'/\n";
$newline=contline($newline);

if ($newline ne $line) {
    open(OUT,">$dsverfile") || 
      die "Can't open $dsverfile for writing\n";
    print OUT $newline;
    close(OUT);
    print "$dsverfile updated.\n";
} else {
    print "$dsverfile is up-to-date.\n";
}

# Take care of DarkSUSY root directory file
open(IN,"$dsrootfile") || die "Can't open $dsrootfile for reading.\n";
$line="";
while ($in=<IN>) {
    $line .= $in;
}
close(IN);

$newline=" " x 6 . "data dsroot/'$dsroot/'/\n";
$newline=contline($newline);

if ($newline ne $line) {
    open(OUT,">$dsrootfile") || 
      die "Can't open $dsrootfile for writing\n";
    print OUT $newline;
    close(OUT);
    print "$dsrootfile updated.\n";
} else {
    print "$dsrootfile is up-to-date.\n";
}


### Split long lines

sub contline {
    my $line = $_[0];
    my $out;
    my $i;
 
    $out="";
    if (length($line) >= 71) {
        print "*** A too long line has been found. I will split it.\n";
        print "Line before: \n$line";
        while (length($line) >= 71) {
            for ($i=70; $i==20; $i--) {
                if (substr($line,$i,1) =~ m@(\*|\+|-|/)@ ) {
                    last;
                }
            }
            $out=$out . substr($line,0,$i-1) . "\n";
            $line = " " x 5 . "&" . substr($line,$i-1)
        }
        $out = $out . $line;
        print "Line after: \n$out";
    } else {
        $out=$line;
    }
 
    return $out;
}
