      real*8 function Delta7_H(arg)
c_______________________________________________________________________
c  function in giudice et al, hep-ph/9710335
c  author: roberto ruiz
c=======================================================================
      implicit none
      include 'sheffaccom.h'

      real*8 arg,fun,Delta1_H,Delta2_H
    

      fun = arg-1.0d0

      If(arg .eq. 1.0d0) then
       Delta1_H = 35.0d0/6.0d0
       Delta2_H = -79.0d0/60.0d0
      else
       Delta1_H =
     &  (21.0d0-47.0d0*arg
     &          + 8.0d0*arg**2.0d0)/fun**3.0d0
     &  +2.0d0*(-8.0d0+14.0d0*arg
     &          + 3.0d0*arg**2.0d0)/fun**4.0d0*dlog(arg)

       Delta2_H =
     &  (-31.0d0-18.0d0*arg+135.0d0*arg**2.0d0
     &         - 14.0d0*arg**3.0d0)/6.0d0/fun**4.0d0
     &  +arg*(14.0d0-23.0d0*arg
     &         - 3.0d0*arg**2.0d0)/fun**5.0d0*dlog(arg)
      endif 

       Delta7_H = 2.0d0/9.0d0*arg*(Au*Ad*Delta1_H
     &         + Au**2.0d0*Delta2_H)
      return
      end

      real*8 function Delta7_1chi(arg)
c_______________________________________________________________________
c  function in giudice et al, hep-ph/9806308
c  author: roberto ruiz
c=======================================================================
      implicit none

      real*8 arg

      real*8 F7_1, F8_1 
    

      Delta7_1chi =
     &  32.0d0/27.0d0*(F8_1(arg)-3.0d0*F7_1(arg))


      return
      end


      real*8 function Delta7_2chi(arg)
c_______________________________________________________________________
c  function in giudice et al, hep-ph/9806308
c  author: roberto ruiz
c=======================================================================
      implicit none

      real*8 arg

      real*8 F7_3, F8_3 
    

      Delta7_2chi =
     &  16.0d0/9.0d0*(F8_3(arg)-3.0d0*F7_3(arg))

        return
      end
