      real*8 function G7_SM(x)
c_______________________________________________________________________
c  function in giudice et al, hep-ph/9710335
c  author: roberto ruiz
c=======================================================================
      implicit none
      
      real*8 x,y
c---- function
      real*8 RLI2    

      y = x-1.0d0

      If(x .eq. 1.0d0) then
        G7_SM = -3451.0d0/9720.0d0
      else
        G7_SM =
     &  (-16.0d0*x**4.0d0-122.0d0*x**3.0d0+80.0d0*x**2.0d0
     &     -8.0d0*x)/9.0d0/y**4.0d0*RLI2(y/x)
     &  +(6.0d0*x**4.0d0+46.0d0*x**3.0d0
     &     -28.0d0*x**2.0d0)/3.0d0/y**5.0d0*dlog(x)**2.0d0
     &  +(-102.0d0*x**5.0d0-588.0d0*x**4.0d0-2262.0d0*x**3.0d0
     &     +3244.0d0*x**2.0d0-1364.0d0*x
     &     +208.0d0)/81.0d0/y**5.0d0*dlog(x)
     &  +(1646.0d0*x**4.0d0+12205.0d0*x**3.0d0
     &     -10740.0d0*x**2.0d0+2509.0d0*x
     &     -436.0d0)/486.0d0/y**4.0d0
      endif

      return
      end

      real*8 function G7_H(arg)
c_______________________________________________________________________
c  function in giudice et al, hep-ph/9710335
c  author: roberto ruiz
c=======================================================================
      implicit none
      include 'sheffaccom.h'      

      real*8 arg,fun,G1_H,G2_H
c---- function
      real*8 RLI2    

      fun = arg-1.0d0

      If(arg .eq. 1.0d0) then
        G1_H = -181.0d0/108.0d0
        G2_H = 641.0d0/720.0d0
      else
        G1_H =
     &  4.0d0*(-3.0d0+7.0d0*arg
     &          -2.0d0*arg**2.0d0)/3.0d0/fun**3.0d0*RLI2(fun/arg)
     &  +(8.0d0-14.0d0*arg
     &     -3.0d0*arg**2.0d0)/3.0d0/fun**4.0d0*dlog(arg)**2.0d0
     &  +2.0d0*(-3.0d0-arg+12.0d0*arg**2.0d0
     &     -2.0d0*arg**3.0d0)/3.0d0/fun**4.0d0*dlog(arg)
     &  +(7.0d0-13.0d0*arg
     &     +2*arg**2.0d0)/fun**3.0d0

        G2_H =
     &  arg*(18.0d0-37.0d0*arg
     &          +8.0d0*arg**2.0d0)/fun**4.0d0*RLI2(fun/arg)
     &  +arg*(-14.0d0+23.0d0*arg
     &     +3.0d0*arg**2.0d0)/fun**5.0d0*dlog(arg)**2.0d0
     &  +(-50.0d0+251.0d0*arg-174.0d0*arg**2.0d0-192.0d0*arg**3.0d0
     &     +21.0d0*arg**4.0d0)/9.0d0/fun**5.0d0*dlog(arg)
     &  +(797.0d0-5436.0d0*arg
     &     +7569*arg**2.0d0-1202.0d0*arg**3.0d0)/108.0d0/fun**4.0d0
      endif      

      G7_H = arg*(4.0d0/3.0d0*Au*Ad*G1_H+2.0d0/9.0d0*Au**2.0d0*G2_H)  

      return
      end

      real*8 function G7_1chi(arg,i)
c_______________________________________________________________________
c  function in giudice et al, hep-ph/9806308
c  author: roberto ruiz
c=======================================================================
      implicit none
      include 'dssusy.h'
      
      integer i
      real*8 arg,temp
c---- function
      real*8 RLI2,F7_1,Delta1_td   

      temp = arg-1.0d0

      
      If(arg .eq. 1.0d0) then
         G7_1chi = 
     & - 8.0d0/9.0d0*F7_1(arg)*(Delta1_td(1,4)+Delta1_td(1,6)
     &       -1.0d0+6.0d0*dlog(mass(kw)/mass(kcha(i))))
     & + 77.0d0/324.0d0 !From limit
      else
         G7_1chi =
     & - 8.0d0/9.0d0*F7_1(arg)*(Delta1_td(1,4)+Delta1_td(1,6)
     &       -1.0d0+6.0d0*dlog(mass(kgluin)/mass(kcha(i)))) 
     & + arg*(-85.0d0+347.0d0*arg
     &       - 526.0d0*arg**2.0d0)/243.0d0/temp**3.0d0
     & + 4.0d0*arg**2.0d0*(-8.0d0+13.0d0*arg
     &       +6.0d0*arg**2.0d0)/9.0d0/temp**4.0d0*RLI2(temp/arg)
     & - 4.0d0*arg*(20.0d0-126.0d0*arg+144*arg**2.0d0
     &       + 39.0d0*arg**3.0d0)/81.0d0/temp**4.0d0*dlog(arg)
     & + 2.0d0*arg**2.0d0*(21.0d0*arg
     &       - 10.0d0)/9.0d0/temp**4*dlog(arg)**2.0d0
      endif
    

      return
      end

      real*8 function G7_2chi(arg)
c_______________________________________________________________________
c  function in giudice et al, hep-ph/9806308
c  author: roberto ruiz
c=======================================================================
      implicit none
      
 
      real*8 arg,temp
c---- function
      real*8 RLI2, F7_3, Delta1_td, Delta2_td    

      temp = arg-1.0d0

      If(arg .eq. 1.0d0) then
        G7_2chi =
     & - 4.0d0/3.0d0*F7_3(arg)*(Delta1_td(1,4)+Delta1_td(0,6)
     &        + Delta2_td(0,6)-2.0d0) 
     & - 104.0d0/81.0d0 !From Limit     
      else 
        G7_2chi =
     & - 4.0d0/3.0d0*F7_3(arg)*(Delta1_td(1,4)+Delta1_td(0,6)
     &        + Delta2_td(0,6)-2.0d0)
      endif

      return
      end

      real*8 function G7_W(x)
c_______________________________________________________________________
c  function in giudice et al, hep-ph/9806308
c  author: roberto ruiz
c=======================================================================
      implicit none
      
      real*8 x,y
c---- function
      real*8 RLI2    

      y = x-1.0d0

      If(x .eq. 1.0d0) then
       G7_W = 3.0d0/8.0d0
      else
       G7_W =
     &  - (23.0d0-67.0d0*x+50.0d0*x**2.0d0)/36.0d0/y**3.0d0
     &  + x*(2.0d0-7.0d0*x+6.0d0*x**2.0d0)/6.0d0/y**4.0d0*dlog(x)
      endif 

      return
      end





