      complex*16 function epsilon_b(gu)
c_______________________________________________________________________
c  function in giudice et al, hep-ph/9710335
c  author: roberto ruiz
c=======================================================================
      implicit none
      include 'dssusy.h'


      integer gu
      
      integer i, lsu1,lsu2, index
      real*8 mtilde1, mtilde2, mtilde,mas_sb2, mas_sb1, mas_su2, mas_su1
     &   , r_sb1g, r_sb2g, r_su1g, r_su2g
     &   , r_sb1n(4), r_sb2n(4), r_su1n(4), r_su2n(4)
     &   , sinthu, costhu, sinthb, costhb
     &   , c2uc2b, c2us2b, s2uc2b, s2us2b 
     &   , epsilon1, epsilon2

      real*8 alfs, H_2
     
     
      mtilde1 = 0.0d0
      mtilde2 = 0.0d0
      do i=1,2
       mtilde1 = mtilde1 
     &   + (mass(ksqu(i))+mass(ksqd(i)))/4.0d0
       mtilde2 = mtilde2
     &   + (mass(ksqu(i+3))+mass(ksqd(i+3)))/4.0d0
      enddo
      mtilde = (mtilde1+mtilde2)/2.0d0  

 
      lsu1 = 2*gu+28
      lsu2 = lsu1+1      
     
     
      mas_sb2 = dmin1(mass(ksqd(3)),mass(ksqd(6)))
      mas_sb1 = dmax1(mass(ksqd(3)),mass(ksqd(6)))
      mas_su2 = dmin1(mass(lsu2),mass(lsu1))
      mas_su1 = dmax1(mass(lsu2),mass(lsu1))

      r_sb1g = (mas_sb1/mass(kgluin))**2.0d0
      r_sb2g = (mas_sb2/mass(kgluin))**2.0d0
      r_su1g = (mas_su1/mass(kgluin))**2.0d0
      r_su2g = (mas_su2/mass(kgluin))**2.0d0
       
      do i=1,4
       r_sb1n(i) = (mas_sb1/mass(kn(i)))**2.0d0
       r_sb2n(i) = (mas_sb2/mass(kn(i)))**2.0d0
       r_su1n(i) = (mas_su1/mass(kn(i)))**2.0d0
       r_su2n(i) = (mas_su2/mass(kn(i)))**2.0d0
      enddo 
 

      index = Int(1.0d0/2.0d0*(1.0d0+gu))


      sinthu = squrmx(index,index)
      costhu = squlmx(index,index)  
      sinthb = sqdrmx(3,3)
      costhb = sqdlmx(3,3)  

      c2uc2b = costhu**2.0d0*costhb**2.0d0
      c2us2b = costhu**2.0d0*sinthb**2.0d0
      s2uc2b = sinthu**2.0d0*costhb**2.0d0
      s2us2b = sinthu**2.0d0*sinthb**2.0d0
      
      epsilon1 = c2uc2b*H_2(r_su1g,r_sb2g)+c2us2b*H_2(r_su1g,r_sb1g)
     &          + s2uc2b*H_2(r_su2g,r_sb2g)+s2us2b*H_2(r_su2g,r_sb1g)
      epsilon2 = 0.0d0
       do i= 1,4
         epsilon2 = epsilon2 
     &    + neunmx(4,i)/mass(kn(i))
     &      *( c2uc2b*H_2(r_su2n(i),r_sb1n(i))
     &         + c2us2b*H_2(r_su2n(i),r_sb2n(i))
     &         + s2uc2b*H_2(r_su1n(i),r_sb1n(i))
     &          + s2us2b*H_2(r_su1n(i),r_sb2n(i)))*dconjg(neunmx(3,i))
      enddo
      epsilon_b = -2.0d0/3.0d0*alfs(mtilde)/pi
     &               *mu/mass(kgluin)*epsilon1
     &  - yukawa(gu+6)**2.0d0/16.0d0/pi**2.0d0*asoftu(index)*epsilon2



      return
      end

      complex*16 function epsilon_t(gd)
c_______________________________________________________________________
c  function in giudice et al, hep-ph/9710335
c  author: roberto ruiz
c=======================================================================
      implicit none
      include 'dssusy.h'


      integer gd
      
      integer i, lsd1, lsd2, index
      real*8 mtilde1, mtilde2, mtilde,mas_sd2, mas_sd1, mas_st2, mas_st1
     &   , r_sd1g, r_sd2g, r_st1g, r_st2g
     &   , r_sd1n(4), r_sd2n(4), r_st1n(4), r_st2n(4)
     &   , sintht, costht, sinthd, costhd
     &   , c2tc2d, c2ts2d, s2tc2d, s2ts2d 
     &   , epsilon1, epsilon2

      real*8 alfs, H_2


      mtilde1 = 0.0d0
      mtilde2 = 0.0d0
      do i=1,2
       mtilde1 = mtilde1 
     &   + (mass(ksqu(i))+mass(ksqd(i)))/4.0d0
       mtilde2 = mtilde2
     &   + (mass(ksqu(i+3))+mass(ksqd(i+3)))/4.0d0
      enddo
      mtilde = (mtilde1+mtilde2)/2.0d0  



      lsd1 = 2*gd+28
      lsd2 = lsd1+1      
     
     
      mas_st2 = dmin1(mass(ksqu(3)),mass(ksqu(6)))
      mas_st1 = dmax1(mass(ksqu(3)),mass(ksqu(6)))
      mas_sd2 = dmin1(mass(lsd2),mass(lsd1))
      mas_sd1 = dmax1(mass(lsd2),mass(lsd1))

      r_st1g = (mas_st1/mass(kgluin))**2.0d0
      r_st2g = (mas_st2/mass(kgluin))**2.0d0
      r_sd1g = (mas_sd1/mass(kgluin))**2.0d0
      r_sd2g = (mas_sd2/mass(kgluin))**2.0d0
       
      do i=1,4
       r_st1n(i) = (mas_st1/mass(kn(i)))**2.0d0
       r_st2n(i) = (mas_st2/mass(kn(i)))**2.0d0
       r_sd1n(i) = (mas_sd1/mass(kn(i)))**2.0d0
       r_sd2n(i) = (mas_sd2/mass(kn(i)))**2.0d0
      enddo  
      index = Int(1.0d0/2.0d0*(1.0d0+gd))

      sintht = squrmx(3,3)
      costht = squlmx(3,3)
      sinthd = sqdrmx(index,index)
      costhd = sqdlmx(index,index)


      c2tc2d = costht**2.0d0*costhd**2.0d0
      c2ts2d = costht**2.0d0*sinthd**2.0d0
      s2tc2d = sintht**2.0d0*costhd**2.0d0
      s2ts2d = sintht**2.0d0*sinthd**2.0d0
      
      epsilon1 = c2tc2d*H_2(r_st2g,r_sd1g)+c2ts2d*H_2(r_st2g,r_sd2g)
     &          + s2tc2d*H_2(r_st1g,r_sd1g)+s2ts2d*H_2(r_st1g,r_sd2g)
      epsilon2 = 0.0d0
       do i= 1,4
         epsilon2 = epsilon2 
     &    + dconjg(neunmx(4,i))/mass(kn(i))
     &      *( c2tc2d*H_2(r_st1n(i),r_sd2n(i))
     &         + c2ts2d*H_2(r_st1n(i),r_sd1n(i))
     &         + s2tc2d*H_2(r_st2n(i),r_sd2n(i))
     &          + s2ts2d*H_2(r_st2n(i),r_sd1n(i)))*neunmx(3,i)
      enddo
      epsilon_t = -2.0d0/3.0d0*alfs(mtilde)/pi
     &               *mu/mass(kgluin)*epsilon1
     &  - yukawa(gd+6)**2.0d0/16.0d0/pi**2.0d0*asoftd(index)*epsilon2



      return
      end






