      real*8 function W_ud(gu,gd)
c_______________________________________________________________________
c  function in giudice et al, hep-ph/9606308
c  author: roberto ruiz
c=======================================================================
      implicit none
      include 'dssusy.h'

      integer gu,gd

      real*8 W
     
c ------------- local --------------

      integer lsu1, lsu2, lsd1, lsd2, index
      real*8 mas_sd1,  mas_sd2, mas_su1, mas_su2, x1 
     & ,w1, w2, cos2thu, sin2thu

c ---------------------------------

      

      lsu1 = 2*gu+28
      lsu2 = lsu1+1      
      lsd1 = 2*gd+28
      lsd2 = lsd1+1

      index = Int(1.0d0/2.0d0*(1.0d0+gu))

      mas_sd1 = dmax1(mass(lsd1),mass(lsd2))
      mas_su1 = dmax1(mass(lsu1),mass(lsu2))
      mas_su2 = dmin1(mass(lsu1),mass(lsu2))   


      x1 = (mas_sd1/mass(kgluin))**2.0d0
      w1 = (mas_su1/mass(kgluin))**2.0d0   
      w2 = (mas_su2/mass(kgluin))**2.0d0 


      cos2thu = squlmx(index,index)*dconjg(squlmx(index,index))
      sin2thu = squrmx(index,index)*dconjg(squrmx(index,index))
    
      W_ud = 1.0d0/2.0d0*(cos2thu*W(x1,w1)+ sin2thu*W(x1,w2))

      return
      end
c
      real*8 function W(x,y)
      
      implicit none
      
      real*8 x,y

      If (x.eq.1 .and. y.ne.1) then
        W = (1.0d0+4.0d0*y-5.0d0*y**2.0d0
     &        +2.0d0*(2.0d0+y)*dlog(y))/2.0d0/(y-1)**2.0d0
      else if (x.ne.1 .and. y.eq.1) then
        W = (1.0d0+4.0d0*x-5.0d0*x**2.0d0
     &        +2.0d0*(2.0d0+x)*dlog(x))/2.0d0/(x-1)**2.0d0
      else if (x.eq.y) then
        W = 0.0d0
      else       
        W = (x+y-2.0d0*x*y)/(x-1)/(y-1)
     &     + (x**3.0d0-2.0d0*x*y
     &         + x**2.0d0*y)/(x-1)**2.0d0/(x-y)*dlog(x)
     &     + (2.0d0*x*y-x*y**2.0d0
     &         - y**3.0d0)/(y-1)**2.0d0/(x-y)*dlog(y)
      endif

      return
      end

      real*8 function H_td(t,gd)
c_______________________________________________________________________
c  function in giudice et al, hep-ph/9806308
c  author: roberto ruiz
c=======================================================================
      implicit none
      include 'dssusy.h'

      integer t,gd

      real*8 H_1,H_2
     
c ------------- local --------------

      integer lsu1, lsu2, lsd1, lsd2
      real*8 mas_sd1, mas_sd2, mas_st1, mas_st2, x1, x2
     & , u1, u2, cos2thu, sin2thu

c ---------------------------------

      

  
  
      lsd1 = 2*gd+28
      lsd2 = lsd1+1


      mas_sd1 = dmax1(mass(lsd1),mass(lsd2))
      mas_sd2 = dmin1(mass(lsd1),mass(lsd2))
      mas_st1 = dmax1(mass(ksqu(3)),mass(ksqu(6)))
      mas_st2 = dmin1(mass(ksqu(3)),mass(ksqu(6)))   

      x1 = (mas_sd1/mass(kgluin))**2.0d0
      x2 = (mas_sd2/mass(kgluin))**2.0d0
      u1 = (mas_st1/mass(kgluin))**2.0d0   
      u2 = (mas_st2/mass(kgluin))**2.0d0 

      cos2thu = squlmx(3,3)*dconjg(squlmx(3,3))
      sin2thu = squrmx(3,3)*dconjg(squrmx(3,3))
     

      If (t.eq.0) then
        H_td = 1.0d0/2.0d0*(H_1(x1)-cos2thu*H_1(u1)
     &                -sin2thu*H_1(u2))
     &    - 2.0d0*(asoftd(gd/2)-mu*tanbe)/mass(kgluin)*H_2(x1,x2) 
     &    + 2.0d0*(asoftd(gd/2)+mu/tanbe)/mass(kgluin)
     &            *(cos2thu*H_2(u1,x2)+sin2thu*H_2(u2,x2)) 
      else
        H_td = - 1.0d0/2.0d0*(H_1(x1)-cos2thu*H_1(u1)
     &                -sin2thu*H_1(u2))
     &    - 2.0d0*(asoftu(3)-mu/tanbe)/mass(kgluin)*H_2(u1,u2) 
     &    + 2.0d0*(asoftu(3)+mu*tanbe)/mass(kgluin)
     &            *(cos2thu*H_2(u2,x1)+sin2thu*H_2(u1,x1)) 
      endif

      return
      end

      real*8 function U_td(t,gd)
c_______________________________________________________________________
c  function in giudice et al, hep-ph/8106308
c  author: roberto ruiz
c=======================================================================
      implicit none
      include 'dssusy.h'

      integer t,gd

      real*8 H_1,H_2
     
c ------------- local --------------

      integer lsu1, lsu2, lsd1, lsd2
      real*8 mas_sd1,  mas_sd2, mas_st1, mas_st2, x1, x2
     & , u1, u2, cos2thu, sin2thu


      lsd1 = 2*gd+28
      lsd2 = lsd1+1

      mas_sd1 = dmax1(mass(lsd1),mass(lsd2))
      mas_sd2 = dmin1(mass(lsd1),mass(lsd2))
      mas_st1 = dmax1(mass(ksqu(3)),mass(ksqu(6)))
      mas_st2 = dmin1(mass(ksqu(3)),mass(ksqu(6)))   

      x1 = (mas_sd1/mass(kgluin))**2.0d0
      x2 = (mas_sd2/mass(kgluin))**2.0d0
      u1 = (mas_st1/mass(kgluin))**2.0d0   
      u2 = (mas_st2/mass(kgluin))**2.0d0 

      cos2thu = squlmx(3,3)*dconjg(squlmx(3,3))
      sin2thu = squrmx(3,3)*dconjg(squrmx(3,3))

      If (t.eq.0) then
        U_td = 1.0d0/2.0d0*(H_1(x1)-cos2thu*H_1(u1)
     &                - sin2thu*H_1(u2))
     &    - 2.0d0*(asoftd(gd/2)-mu*tanbe)/mass(kgluin)*H_2(x1,x2) 
     &    + 2.0d0*(asoftd(gd/2)-mu*tanbe)/mass(kgluin)
     &            *(cos2thu*H_2(u1,x2)+sin2thu*H_2(u2,x2)) 
      else
         U_td = - 1.0d0/2.0d0*(H_1(x1)-cos2thu*H_1(u1)
     &                - sin2thu*H_1(u2))
     &    - 2.0d0*(asoftu(3)-mu/tanbe)/mass(kgluin)*H_2(u1,u2) 
     &    + 2.0d0*(asoftu(3)-mu/tanbe)/mass(kgluin)
     &            *(cos2thu*H_2(u2,x1)+sin2thu*H_2(u1,x1)) 
      endif

      return
      end

      real*8 function H_1(x)
      
      implicit none
      
      real*8 x
 
      If (x .eq. 1.0d0 ) then
        H_1 = -1.0d0/2.0d0
      else
        H_1 = 1.0d0/(1.0d0-x)
     &        +(2.0d0*x-x**2.0d0)/(1-x)**2.0d0*dlog(x)
      end if 

      return
      end

      real*8 function H_2(x,y)
      
      implicit none
      
      real*8 x,y
  
      If (x .eq. 1.0d0 .and. y .ne. 1.0d0 ) then
        H_2 = (-1.0d0+y-y*dlog(y))/(-1.0d0+y)**2.0d0
      else if (x .ne. 1.0d0 .and. y .eq. 1.0d0 ) then
        H_2 = (-1.0d0+x-x*dlog(x))/(-1.0d0+x)**2.0d0
      else if (x .eq. 1.0d0 .and. y .eq. 1.0d0 ) then
        H_2 = -1.0d0/2.0d0
      else if (x .eq. y .and. x .ne. 1 .and. y .ne. 1) then 
        H_2 = (1.0d0-x+dlog(x))/(-1.0d0+x)**2.0d0
      else
        H_2 = x/(1.0d0-x)/(x-y)*dlog(x)
     &        +y/(1.0d0-y)/(y-x)*dlog(y)
      end if
  

      return
      end

      real*8 function R_td(gd)
c_______________________________________________________________________
c  function in giudice et al, hep-ph/9806308
c  author: roberto ruiz
c=======================================================================
      implicit none
      include 'dssusy.h'

      integer gd

      real*8 Delta2_td
     

      R_td = Delta2_td(1,gd)-1.0d0
c     &      +6.0d0*dlog(mass(kw)/mass(kgluin))


      return
      end






