      subroutine sheffbsgamma(rbsg,sgn_MSSMoSM,flag)
c_______________________________________________________________________
c  b -> s + gamma branching ratio
c  common:
c    'dssusy.h' - file with susy common blocks
c  input:
c    flag : 0 LO QCD calculation -- 1 NLO QCD computation
c  output:
c    ratio : branching ratio
c  author: roberto ruiz
c     formulas given in hep-ph/9710335
c=======================================================================
      implicit none
      include 'dssusy.h'
      include 'sheffaccom.h'

      integer sgn_MSSMoSM
      real*8 rbsg(2) !rbsg
      integer flag


c ------- local variables -------------------

      integer i,j,swicth
      real*8  factor, A, A1, hqet
      complex*16 D, D1, rquark    
      
c variables according to Gambino code:

      complex*16 D_eff,C_qed, box
      real*8 hqb,hqc,cb,hqetnlo,cqed1, D_a(2)

c ------ external functions

      real*8 f, h, k, alfs

c ------- The first step is calculating relevant parameters, as
c Wilson coeff. and numerical parameters  as well.


      do swicth=1,2

       call coeff(swicth-1)
       D_a(swicth) = C70b_EW+alfs(mass(kb))/4.0d0/pi*C1b(7)

      enddo

      sgn_MSSMoSM = 1

      if(D_a(2)/D_a(1) .lt. 0.d0) sgn_MSSMoSM= 0

      do swicth=1,2

       call coeff(swicth-1) 

c --- calculation of "D" term:

      hqb= -6.0d0*lambda*(1.0d0
     &        -(1-z)**4.0d0/f(z))
      hqc= -1.0d0/9.0d0*lambda/C0b(7)
     &          *(C0b(2)-C0b(1)/6.0d0)

      hqet= 1+hqb/mass(kb)**2.0d0+hqc/mass(kc)**2.0d0

c vkm from input is the result of a SM fit here we change to other models

      box= 1.d0+(1.04884-CKMfactor)*(1.d0-1.d0/dsqrt(bbox))/CKMfactor
c     box=1.d0   !in case we don't want that 
   
c      write(*,*) 'hqet',hqet
    
      rquark = 6.0d0/pi*CKMfactor*alphae_w/f(z) !alphae_w=1/130.4
     &    *(cdabs(C0b(7))**2.0d0)    
         
      rbsg(swicth) = rbce*rquark*hqet*box ! I have added HQET effects 

c      write(*,*) 'rbsg1',rbsg
 


      if (flag.eq.0) then
        rbsg(swicth) = rbce*rquark*hqet*box 
      else if (flag.eq.1) then
       factor=dlog(delta)*(7.0d0+2.0d0*dlog(delta))/3.0d0/pi 
       A1 = 0.0d0
       do i = 1,8
        do j= i,8
          A1 = A1 + C0b(i)*C0b(j)*f_ij(i,j)
        enddo
       enddo


      A = 
     &  (dexp(-alfs(mass(kb))*factor)
     &        - 1.0d0)*cdabs(C0b(7))**2.0d0
     &  + alfs(mass(kb))/pi*A1 ! take care about C0b(7) 


       D1 = 0.0d0
       do i = 1,8
         D1 = D1 + C0b(i)*r(i)
       enddo
       D = C70b_EW+alfs(mass(kb))/4.0d0/pi*(C1b(7)+D1) 


c       write(*,*) 'D= ',D
c       write(*,*) 'A ',A

c      
       cb=-8.*alfs(mass(kb))/(3*pi) !-18.6d0*(asf(scb)/pi)**2
c 
       C_qed=2.d0*alphae_w
     &           /alfs(mass(kb))*dreal(C7b_EM*dconjg(C0b(7)))

c      

c  Amplitude taken from  Kagan-Neubert (hep-ph/9805303).

       D_eff= cdabs(D)**2+A+C_qed+(1+cb-k(z))*cdabs(C0b(7))**2

c       write(*,*) 'd_eff',sqrt(d_eff)
c
       hqc= lambda*(C0b(1)/54.d0-C0b(2)/9.d0)*c0b(7)/D_eff 
                        !corrected according to NPB version 

c       write(*,*) 'hqc',hqc     
    
       hqetnlo=1+hqb/mass(kb)**2.0d0+hqc/mass(kc)**2.0d0 

c
c       write(*,*) 'rbsg',rbsg   
       rbsg(swicth)=rbsg(swicth)*D_eff/cdabs(C0b(7))**2.0d0*hqetnlo/hqet 

c       write(*,*) 'rbsg',rbsg  
c semileptonic qed corr
       cqed1= (1- 2.d0*alphae_w*dlog(mass(kz)/mass(kb))/pi) ! -
c
       rbsg(swicth) = rbsg(swicth)*alpha_em/alphae_w*cqed1
       
      else
       write(*,*) 'error choosing flag option'
       stop
      end if


      enddo

      return 
      end



























