       subroutine coeff(swicth)
c_______________________________________________________________________
c  Wilson "C" coefficients
c  common:
c    'dssusy.h' - file with susy common blocks
c    'dsddloops.h' - file with common blocks used in calculating
c     netralino-proton cross section including QCD corrections.
c  output:
c    Wilson coeff. to "b" scale including NLO QCD corrections
c  author: roberto ruiz
c=======================================================================
      implicit none

      include 'dssusy.h'
      include 'sheffaccom.h'


      integer swicth
      real*8 F7_1, F7_2, F7_3, F8_1, F8_2, F8_3, E_SM 
     &  , G7_SM, G8_SM
      complex*16  epsilon_t, epsilon_b
      real*8 E_H, G7_H, G8_H, Delta7_H, Delta8_H
      real*8 E_chi, G7_1chi, G7_2chi, Delta7_1chi, Delta7_2chi 
     &    , G8_1chi, G8_2chi, Delta8_1chi, Delta8_2chi, G7_W
     &    , G8_W, W_ud, H_td, U_td, R_td
      

c ------- local variables ----------------------
     
      integer i
      complex*16 C0w_SM(8), C0w_H(8), C0w_MSSM(8), C0w(8), C1w_SM(8)
     &       , C1w_H(8), C1w_MSSM(8), C1w(8), C0w_EW(8) 
      real*8  C1w_chi7, C1w_chi8, C1w_W7, C1w_W8, C1w_chi17 
     &       , C1w_chi18, C1w_chi27, C1w_chi28, C1w_ph17
     &       , C1w_ph18, C1w_ph27, C1w_ph28
      complex*16  C0susy_MSSM(8),  C0susy1_MSSM7,  C0susy2_MSSM7
     &  , C0susy3_MSSM7, C0susy4_MSSM7, C0susy1_MSSM8 
     &  , C0susy2_MSSM8, C0susy3_MSSM8
    
      real*8 alfs

c ----------------------------------------------

c ---- Now I init. some useful parameters -----


      call init('default','model2')



c ---- I introducce the definition of Wilson coeff. to LO for weak
c scale and at LO. Let me start with SM and Higgs models.

      do i = 1,6
       C0w_SM(i) = 0.0d0
      enddo 
      C0w_SM(2) = 1.0d0
      C0w_SM(7) = F7_1(x) ! I add leading tanbe higher order ...
      C0w_SM(8) = F8_1(x) ! I add leading tanbe higher order ...

c      write(*,*) epsilon_b(5),epsilon_t(4)


      do i = 1,6
       C0w_H(i) = 0.0d0
      enddo
      C0w_H(7) = Au**2.0d0/3.0d0*F7_1(y)-Au*Ad*F7_2(y)
      C0w_H(8) = Au**2.0d0/3.0d0*F8_1(y)-Au*Ad*F8_2(y)

c      write(*,*) C0w_SM(7)+C0w_H(7),C0w_SM(8)+C0w_H(8)

      do i = 1,6
       C0w_MSSM(i) = 0.0d0
      enddo

c -------- I have to consider results in paper hep-ph/0009337

      do i=1,6
       C0susy_MSSM(i) = 0.0d0
      enddo 

c --- to check with Giudice et al.(hep-ph/9710335) ------------
c      scenario1= .true.
c      K_tanbe = 1.0d0
c-----------------------------------------------

      If (scenario1) then 
       C0susy_MSSM(7) = 0.0d0
       do i=1,2
        C0susy_MSSM(7) = C0susy_MSSM(7) 
     & + 2.0d0/3.0d0*r_wsq*chavmx(i,1)**2.0d0*F7_1(z_i(i))
     & + 1/sqrt(2.0d0)/cosbe*dsqrt(r_wc(i))*K_tanbe*chaumx(i,2)
     &              *chavmx(i,1)*F7_3(z_i(i))
     & - 2.0d0/3.0d0*r_wst1*t1(i)**2.0d0*F7_1(y1(i))
     & - 1/sqrt(2.0d0)/cosbe*dsqrt(r_wc(i))*t1(i)
     &               *costht*K_tanbe*chaumx(i,2)*F7_3(y1(i))
     & - 2.0d0/3.0d0*r_wst2*t2(i)**2.0d0*F7_1(y2(i))
     & - 1/sqrt(2.0d0)/cosbe*dsqrt(r_wc(i))*t2(i)
     &               *sintht*K_tanbe*chaumx(i,2)*F7_3(y2(i))
       enddo


       C0susy_MSSM(8) = 0.0d0      
       do i=1,2
        C0susy_MSSM(8) = C0susy_MSSM(8) 
     & + 2.0d0/3.0d0*r_wsq*chavmx(i,1)**2.0d0*F8_1(z_i(i))
     & + 1/sqrt(2.0d0)/cosbe*dsqrt(r_wc(i))*K_tanbe*chaumx(i,2)
     &               *chavmx(i,1)*F8_3(z_i(i))
     & - 2.0d0/3.0d0*r_wst1*t1(i)**2.0d0*F8_1(y1(i))
     & - 1/sqrt(2.0d0)/cosbe*dsqrt(r_wc(i))*t1(i)
     &               *costht*K_tanbe*chaumx(i,2)*F8_3(y1(i))
     & - 2.0d0/3.0d0*r_wst2*t2(i)**2.0d0*F8_1(y2(i))
     & - 1/sqrt(2.0d0)/cosbe*dsqrt(r_wc(i))*t2(i)
     &               *sintht*K_tanbe*chaumx(i,2)*F8_3(y2(i))
       enddo       
  
c       write(*,*) 'C0susy_MSSM(8)',C0susy_MSSM(7),C0susy_MSSM(8)        


       C0w_MSSM(7) = eta_susy**(16.0d0/21.0d0)*C0susy_MSSM(7)
     &   + 8.0d0/3.0d0*(eta_susy**(14.0d0/21.0d0)
     &     - eta_susy**(16.0d0/21.0d0))*C0susy_MSSM(8) !now six active flavor
       
       C0w_MSSM(8) = eta_susy**(14.0d0/21.0d0)*C0susy_MSSM(8)  

c       write(*,*)  'C0w_MSSM(8)',C0w_MSSM(7),C0w_MSSM(8)


      else if(scenario2) then ! mass gluino >> mass stop2 and chargino
   

       C0susy1_MSSM7 = 0.0d0
       C0susy2_MSSM7 = 0.0d0 
       C0susy3_MSSM7 = 0.0d0
       C0susy4_MSSM7 = 0.0d0         

       do i=1,2 
        C0susy1_MSSM7 =  C0susy1_MSSM7  
     &    + 2.0d0/3.0d0*r_wsq*chavmx(i,1)**2.0d0*F7_1(z_i(i))
     & + 1/sqrt(2.0d0)/cosbe*dsqrt(r_wc(i))*K_tanbe*chaumx(i,2)
     &             *chavmx(i,1)*F7_3(z_i(i))
     & - 2.0d0/3.0d0*r_wst1*t1(i)**2.0d0*F7_1(y1(i))
     & - 1/sqrt(2.0d0)/cosbe*dsqrt(r_wc(i))*t1(i)
     &               *costht*K_tanbe*chaumx(i,2)*F7_3(y1(i))
        C0susy2_MSSM7 =  C0susy2_MSSM7  
     &    + 2.0d0/3.0d0*r_wsq*chavmx(i,1)**2.0d0*F8_1(z_i(i))
     & + 1/sqrt(2.0d0)/cosbe*dsqrt(r_wc(i))*K_tanbe*chaumx(i,2)
     &               *chavmx(i,1)*F8_3(z_i(i))
     & - 2.0d0/3.0d0*r_wst1*t1(i)**2.0d0*F8_1(y1(i))
     & - 1/sqrt(2.0d0)/cosbe*dsqrt(r_wc(i))*t1(i)
     &               *costht*K_tanbe*chaumx(i,2)*F8_3(y1(i))
        C0susy3_MSSM7 = C0susy3_MSSM7
     &    -2.0d0/3.0d0*r_wst2*t2(i)**2.0d0*F7_1(y2(i))
        C0susy4_MSSM7 = C0susy4_MSSM7
     &    - 1/sqrt(2.0d0)/cosbe*dsqrt(r_wc(i))*t2_correc(i)
     &               *sintht*K_tanbe*chaumx(i,2)*F7_3(y2(i))
        enddo


        C0w_MSSM(7) = 
     &      eta_susy**(32.0d0/41.0d0)*C0susy1_MSSM7
     &     + 8.0d0/3.0d0*(eta_susy**(28.0d0/41.0d0)
     &          - eta_susy**(32.0d0/41.0d0))*C0susy2_MSSM7
     &     + eta_susy**(-24.0d0/41.0d0)* C0susy3_MSSM7
     &     + C0susy4_MSSM7
 
        
       C0susy1_MSSM8 = 0.0d0
       C0susy2_MSSM8 = 0.0d0 
       C0susy3_MSSM8 = 0.0d0

        do i=1,2 
        C0susy1_MSSM8 =  C0susy1_MSSM8  
     &    + 2.0d0/3.0d0*r_wsq*chavmx(i,1)**2.0d0*F8_1(z_i(i))
     & + 1/sqrt(2.0d0)/cosbe*dsqrt(r_wc(i))*K_tanbe*chaumx(i,2)
     &              *chavmx(i,1)*F8_3(z_i(i))
     & - 2.0d0/3.0d0*r_wst1*t1(i)**2.0d0*F8_1(y1(i))
     & - 1/sqrt(2.0d0)/cosbe*dsqrt(r_wc(i))*t1(i)
     &               *costht*K_tanbe*chaumx(i,2)*F8_3(y1(i))
        C0susy2_MSSM8 = C0susy2_MSSM8
     &    -2.0d0/3.0d0*r_wst2*t2(i)**2.0d0*F8_1(y2(i))
        C0susy3_MSSM8 = C0susy3_MSSM8
     &    - 1/sqrt(2.0d0)/cosbe*dsqrt(r_wc(i))*t2_correc(i)
     &               *sintht*K_tanbe*chaumx(i,2)*F8_3(y2(i))
        enddo

        C0w_MSSM(8) = 
     &      eta_susy**(28.0d0/41.0d0)*C0susy1_MSSM8
     &     + eta_susy**(-24.0d0/41.0d0)* C0susy2_MSSM8
     &     + C0susy3_MSSM8       

      endif        
  

c ----- I introducce the definition of Wilson coeff. to NLO for weak
c scale . Let me start with SM and Higgs models, asuming 
c mu_W/mW = 1.
    
 
      C1w_SM(1) = 15.0d0
      do i= 2,6
       C1w_SM(i) = 0.0d0
      enddo
      C1w_SM(4) = E_SM(x)-2.0d0/3.0d0
      C1w_SM(7) = G7_SM(x)
     & +swicth*tanbe*(epsilonb-epsilon_b(5))*K_tanbe*F7_2(x)
     &                                        /(alfs(mtilde)/4.d0/pi)
      C1w_SM(8) = G8_SM(x)
     & +swicth*tanbe*(epsilonb-epsilon_b(5))*K_tanbe*F8_2(x)
     &                                        /(alfs(mtilde)/4.d0/pi)     
 

      do i = 1,6
       C1w_H(i) = 0.0d0
      enddo
      C1w_H(4) = E_H(y)
      C1w_H(7) = G7_H(y)+Delta7_H(y)*dlog(u)-4.0d0/9.0d0*E_H(y)
     & - (epsilon_t(4)+epsilonb)*tanbe/(1.0d0+epsilonb*tanbe)*F7_2(y)
     &                                         /(alfs(mtilde)/4.d0/pi)
      C1w_H(8) = G8_H(y)+Delta8_H(y)*dlog(u)-1.0d0/6.0d0*E_H(y)
     & - (epsilon_t(4)+epsilonb)*tanbe/(1.0d0+epsilonb*tanbe)*F8_2(y)
     &                                         /(alfs(mtilde)/4.d0/pi)

      
      do i=1,8
       C1w_MSSM(i) = 0.0d0
      enddo

       do i=1,2
         C1w_MSSM(4) = C1w_MSSM(4)+t2(i)**2.0d0*E_chi(y2(i))
       enddo
       C1w_MSSM(4) = r_wst2*C1w_MSSM(4)      

c ----------- to check -------------
c      scenario2 = .true.
c----------------------------------
      
      if (scenario2) then 


c ------ here start the story -----------------

       C1w_chi7 = 0.0d0
       do i=1,2
          C1w_chi7= C1w_chi7
     &   + t2(i)**2.0d0*(r_wst2)*(G7_1chi(y2(i),i)
     &       +Delta7_1chi(y2(i))*dlog(r_wc(i))
     &           - 4.0d0/9.0d0*E_chi(y2(i)))
     &   + sintht/dsqrt(2.0d0)/cosbe*dsqrt(r_wc(i))*chaumx(i,2)
     &        *(t2(i)*G7_2chi(y2(i))
     &           + t2(i)*Delta7_2chi(y2(i))*dlog(r_wc(i))
     &           - 4.0d0/3.0d0*Y_i(i)*R_td(4)*F7_3(y2(i)))
     &   - 8.0d0/9.0d0*Y_i(i)*r_wst2*t2(i)*(R_td(4)
     &            + R_td(6))*F7_1(y2(i))
       enddo

       C1w_chi8 = 0.0d0
       do i=1,2
          C1w_chi8= C1w_chi8
     &   + t2(i)**2.0d0*(r_wst2)*(G8_1chi(y2(i),i)
     &       +Delta8_1chi(y2(i))*dlog(r_wc(i))
     &           - 1.0d0/6.0d0*E_chi(y2(i)))
     &   + sintht/dsqrt(2.0d0)/cosbe*dsqrt(r_wc(i))*chaumx(i,2)
     &        *(t2(i)*G8_2chi(y2(i))
     &           + t2(i)*Delta8_2chi(y2(i))*dlog(r_wc(i))
     &           - 4.0d0/3.0d0*Y_i(i)*R_td(4)*F8_3(y2(i)))
     &   - 8.0d0/9.0d0*Y_i(i)*r_wst2*t2(i)*(R_td(4)
     &            + R_td(6))*F8_1(y2(i))
       enddo      


       C1w_W7 = 4.0d0/3.0d0*(W_ud(5,6)+W_ud(5,4))*G7_W(x)
     &          - 23.0d0/27.0d0*(W_ud(3,6)+W_ud(3,4))
       C1w_W8 = 4.0d0/3.0d0*(W_ud(5,6)+W_ud(5,4))*G8_W(x)
     &          - 4.0d0/9.0d0*(W_ud(3,6)+W_ud(3,4))

       C1w_ph17 = 4.0d0/9.0d0/tanbe**2.0d0*(H_td(1,4)
     &          + H_td(1,6))*F7_1(y)
     &          + 4.0d0/3.0d0*(H_td(1,4)+H_td(0,6))*F7_2(y)
       C1w_ph18 = 4.0d0/9.0d0/tanbe**2.0d0*(H_td(1,4)
     &           + H_td(1,6))*F8_1(y)
     &          + 4.0d0/3.0d0*(H_td(1,4)+H_td(0,6))*F8_2(y)
      
       C1w_ph27 = 4.0d0/9.0d0*(U_td(1,4)+U_td(1,6))*F7_1(x)
     &          - 4.0d0/3.0d0*(U_td(1,4)+U_td(0,6))*F7_2(x)
       C1w_ph28 = 4.0d0/9.0d0*(U_td(1,4)+U_td(1,6))*F8_1(x)
     &          - 4.0d0/3.0d0*(U_td(1,4)+U_td(0,6))*F8_2(x)


       C1w_MSSM(7) =  C1w_chi7+C1w_W7+C1w_ph17+C1w_ph27
       C1w_MSSM(8) =  C1w_chi8+C1w_W8+C1w_ph18+C1w_ph28      


      endif

    

c ---- Now I add the differents contributions to get the effective
c Wilson coeff. to weak scale.

      do i=1,8
       C0w(i) = C0w_SM(i) + swicth * C0w_H(i) + swicth * C0w_MSSM(i)
       C1w(i) = C1w_SM(i) + swicth * C1w_H(i) + swicth * C1w_MSSM(i)
      enddo 

      
c electroweak corrections only for the calculation of c70b.      
       
      do i=1,6
         C0w_EW(i)=0.0d0
      enddo

      C0w_EW(7)= C0w(7) *(0.974d0) !-0.005d0)
      C0w_EW(8)= C0w(8) *(0.993d0) ! -0.005d0) !I always consider ew. correc.
      

c       write(*,*) 'C0w(7)',C0w(7),C0w(8)  
c       write(*,*) 'C1w(7)',C1w(7),C1w(8)

c ----- Now I have to rescale the parameters to "b-scale". I used
c the expressions given in hep-ph/9612313.

c ---- LO coeff:


      C0b(1) = - eta**(-12.0d0/23.0d0)+eta**(6.0d0/23.0d0)
      C0b(2) = 1.0d0/3.0d0*eta**(-12.0d0/23.0d0)
     &         + 2.0d0/3.0d0*eta**(6.0d0/23.0d0)
      C0b(3) = - 1.0d0/27.0d0*eta**(-12.0d0/23.0d0)
     &         + 2.0d0/63.0d0*eta**(6.0d0/23.0d0)
     &         - 0.0659d0*eta**0.4086d0+0.0595d0*eta**-0.4230d0
     &         - 0.0218d0*eta**-0.8994d0+0.0335d0*eta**0.1456d0
      C0b(4) = - 1.0d0/9.0d0*eta**(-12.0d0/23.0d0)
     &         + 1.0d0/21.0d0*eta**(6.0d0/23.0d0)
     &         + 0.0237d0*eta**0.4086d0-0.0173d0*eta**-0.4230d0
     &         - 0.1336d0*eta**-0.8994d0-0.0316d0*eta**0.1456d0
      C0b(5) = 1.0d0/108.0d0*eta**(-12.0d0/23.0d0)
     &         - 1.0d0/126.0d0*eta**(6.0d0/23.0d0)
     &         + 0.0094d0*eta**0.4086d0-0.0100d0*eta**-0.4230d0
     &         + 0.0010d0*eta**-0.8994d0-0.0017d0*eta**0.1456d0
      C0b(6) = -1.0d0/36.0d0*eta**(-12.0d0/23.0d0)
     &         - 1.0d0/84.0d0*eta**(6.0d0/23.0d0)
     &         + 0.0108d0*eta**0.4086d0+0.0163d0*eta**-0.4230d0
     &         + 0.0103d0*eta**-0.8994d0+0.0023d0*eta**0.1456d0          
      C0b(7) = eta**(16.0d0/23.0d0)*C0w(7)
     &       + 8.0d0/3.0d0*(eta**(14.0d0/23.0d0)
     &                -eta**(16.0d0/23.0d0))*C0w(8)
     &       + C0w(2)*term1
      C0b(8) = (C0w(8)+313063.0d0/363036.0d0)*eta**(14.0d0/23.0d0)
     &        - 0.9135*eta**(0.4086d0)+0.0873*eta**(-0.4230d0)
     &        - 0.0571*eta**(-0.8994d0)+0.0209*eta**(0.1456d0)

c --- EW corrections are considered.

      C70b_EW=eta**(16./23.)*C0w_EW(7)+8./3.*(eta**(14./23.)
     &       -eta**(16./23.))*C0w_EW(8)+C0w(2)*term1 + 0.00054d0
          

c ---- NLO coeff:

      do i=1,8
       C1b(i) = 0.0d0 !I set this values to zero but it's not truth 
      enddo
      C1b(7) =eta**(39.0d0/23.0d0)*C1w(7)
     &      + 8.0d0/3.0d0*(eta**(37.0d0/23.0d0)
     &                -eta**(39.0d0/23.0d0))*C1w(8)
     &      + (297664.0d0/14283.0d0*eta**(16.0d0/23.0d0)
     &         - 7164416.0d0/357075.0d0*eta**(14.0d0/23.0d0)
     &         + 256868.0d0/14283.0d0*eta**(37.0d0/23.0d0)
     &         - 6698884.0d0/357075.0d0*eta**(39.0d0/23.0d0))*C0w(8)
     &      + 37208.0D0/4761.0D0*(eta**(39.0d0/23.0d0)
     &                -eta**(16.0d0/23.0d0))*C0w(7) 
     &       +(C1w(4)+2.0d0/3.0d0)*term2+term3+term4 ! my guess

c --- QED correction after eq 11 of Kagan-Neubert (hep-ph/9805303).

      C7b_EM= (32.0d0/75.0d0*eta**(-9.0d0/23.0d0) 
     &    - 40.0d0/69.0d0*eta**(-7.0d0/23.0d0)
     &    + 88.0d0/575.0d0*eta**(16.0d0/23.0d0))*C0w(7) 
     &  + (- 32.0d0/575.0d0*eta**(-9.0d0/23.0d0)
     &    + 32.0d0/1449.0d0*eta**(-7.0d0/23.0d0)
     &    + 640.0d0/1449.d0*eta**(14.0d0/23.0d0)
     &    - 704.0d0/1725.0d0*eta**(16.0d0/23.0d0))*C0w(8)
     &  - 190.0d0/8073.0d0*eta**(-35.0d0/23.0d0)
     &  - 359.0d0/3105.0d0*eta**(-17.0d0/23.0d0)
     &  + 4276.0d0/121095.0d0*eta**(-12.d0/23.)
     &  + 350531.0d0/1009125.0d0*eta**(-9.0d0/23.0d0)
     &  + 2.0d0/4347.0d0*eta**(-7.0d0/23.0d0)
     &  - 5956.0d0/15525.0d0*eta**(6.0d0/23.0d0)
     &  + 38380.0d0/169533.0d0*eta**(14.0d0/23.0d0)
     &  - 748.0d0/8625.0d0*eta**(16.0d0/23.0d0)


c      write(*,*) 'c0b(7)',c0b(7),c0b(8),c0w(7),c0w(8)
c      write(*,*) 'c1b(7)',c1b(7),C1w(7),C1w(8)

c ---------------------------------------------------------------

      return
      end









