       subroutine ddvertex
c
c_______________________________________________________________________
c  some extra couplings susing in  calculating neutralino-proton(neutron)
c  cross section when we include QCD correctins.  
c  common:
c    'dssusy.h' - file with susy common blocks
c    'dsddloops.h' - file with common blocks used in calculating
c     netralino-nucleon cross section including QCD corrections.
c  called by ddinit.
c  author: roberto ruiz
c=======================================================================
c          
       implicit none
       include 'dssusy.h'
       include 'sheffdd.h'
  
c ------------ local variables ------------------

       integer a, i, r
       real*8 ca, sa, beta, cb, sb, sbpa, cbpa
       real*8 T_3q(6), e_q(6), r_q(6,2), rr_q(6,2), s_q(2), a_q(6)
       complex*16 costh2(6,6), cos2th(6,6), sin2th(6,6), af(6)


c -------- I set the initial values for effective coupling --------------

     

       do r=1,2
         do i=1,6
           do a=1,6
             g_sfsfh(i,a,r) = 0.0d0
           enddo
         enddo
       enddo


c------- some useful parameters ----------------
        
       ca = cos(alpha)
       sa = sin(alpha)
       beta = atan(tanbe)
       cb = cos(beta)
       sb = sin(beta)
       cbpa = cos(beta+alpha)
       sbpa = sin(beta+alpha)
       do i=1,6
         if (i.le.3) then   !up-type
           T_3q(i) = 1.0d0/2.0d0
           e_q(i) = 2.0d0/3.0d0
           r_q(i,1) = -sa/sb
           r_q(i,2) = -ca/sb
           rr_q(i,1) = -ca/sb
           rr_q(i,2) = sa/sb
         else
           T_3q(i) = -1.0d0/2.0d0
           e_q(i) = -1.0d0/3.0d0
           r_q(i,1) = -ca/cb
           r_q(i,2) =  sa/cb
           rr_q(i,1) = -sa/cb
           rr_q(i,2) = -ca/cb
         end if
       enddo
c
       s_q(1) = -cbpa
       s_q(2) = sbpa

c
       do i=1,3
         do a=1,3
           costh2(i,a) = squlmx(a,i)*dconjg(squlmx(a,i))
           costh2(i,a+3) = squrmx(a+3,i)*dconjg(squrmx(a+3,i))
           costh2(i+3,a) = sqdlmx(a,i)*dconjg(sqdlmx(a,i))
           costh2(i+3,a+3) = sqdrmx(a+3,i)*dconjg(sqdrmx(a+3,i))
           cos2th(i,a) = squlmx(a,i)*dconjg(squlmx(a,i))
     &                - squrmx(a,i)*dconjg(squrmx(a,i))
           cos2th(i,a+3) = squlmx(a+3,i)*dconjg(squlmx(a+3,i))
     &                - squrmx(a+3,i)*dconjg(squrmx(a+3,i))
           cos2th(i+3,a) = sqdlmx(a,i)*dconjg(sqdlmx(a,i))
     &                - sqdrmx(a,i)*dconjg(sqdrmx(a,i))
           cos2th(i+3,a+3) = sqdlmx(a+3,i)*dconjg(sqdlmx(a+3,i))
     &                - sqdrmx(a+3,i)*dconjg(sqdrmx(a+3,i)) 
           sin2th(i,a) = squlmx(a,i)*dconjg(squrmx(a,i))
     &                +squrmx(a,i)*dconjg(squlmx(a,i))
           sin2th(i,a+3) = squlmx(a+3,i)*dconjg(squrmx(a+3,i))
     &                 +squrmx(a+3,i)*dconjg(squlmx(a+3,i))
           sin2th(i+3,a) = sqdlmx(a,i)*dconjg(sqdrmx(a,i))
     &                +sqdrmx(a,i)*dconjg(sqdlmx(a,i))
           sin2th(i+3,a+3) = sqdlmx(a+3,i)*dconjg(sqdrmx(a+3,i))
     &                 +sqdrmx(a+3,i)*dconjg(sqdlmx(a+3,i))      
         enddo     
       enddo

c
     
      do i=1,3
         a_q(i) = asoftu(i)
         a_q(i+3) = asoftd(i)
      enddo


c

      do r=1,2
        do i=1,6
          do a=1,6
            g_sfsfh(i,a,r) =
     &         g2weak*mass(kz)/costhw*s_q(r)
     &           *(T_3q(i)*costh2(i,a)-e_q(i)*s2thw*cos2th(i,a))
     &          + g2weak*mass(kq(i))**2.0d0/mass(kw)*r_q(i,r)
     &          - g2weak*mass(kq(i))/2.0d0/mass(kw)*sin2th(i,a)
     &                        *(mu*rr_q(i,r)-a_q(i)*r_q(i,r))
          enddo
        enddo     
      enddo

 
      return
      end




















