* auxillary functions used by the two-point integrals

	subroutine roots(p, m1, m2, x1, x2, y1, y2, r)

	implicit none
 
        include 'sheffewpo.h'

	real*8 p, m1, m2
	complex*16 x1, x2, y1, y2, r

	double precision q

	r = sqrt(DCMPLX(p*(p - 2*(m1 + m2)) + (m1 - m2)**2))
	q = p + m1 - m2
	x1 = (q + r)/2D0/p
	x2 = (q - r)/2D0/p
	if( abs(x2) .gt. abs(x1) ) then
	  x1 = m1/p/x2
	else if( abs(x1) .gt. abs(x2) ) then
	  x2 = m1/p/x1
	endif
	x1 = x1 + abs(p*x1)/p*Ieps
	x2 = x2 - abs(p*x2)/p*Ieps

	q = p - m1 + m2
	y2 = (q + r)/2D0/p
	y1 = (q - r)/2D0/p
	if( abs(y2) .gt. abs(y1) ) then
	  y1 = m2/p/y2
	else if( abs(y1) .gt. abs(y2) ) then
	  y2 = m2/p/y1
	endif
	y1 = y1 - abs(p*y1)/p*Ieps
	y2 = y2 + abs(p*y2)/p*Ieps
	end

************************************************************************

	complex*16 function fpv(n, x, y)

	implicit none

        include 'sheffewpo.h'

	integer n
	complex*16 x, y

	integer m
	complex*16 xm

	if( abs(x) .lt. 10 ) then
	  if( n .eq. 0 ) then
	    fpv = -log(-y/x)
	  else if( abs(x) .lt. acc ) then
	    fpv = -1D0/n
	  else
	    fpv = 0
	    xm = 1
	    do m = 0, n - 1
	      fpv = fpv - xm/(n - m)
	      xm = xm*x
	    enddo
	    fpv = fpv - xm*log(-y/x)
	  endif
	else
	  fpv = 0
	  xm = 1
	  do m = 1, 30
	    xm = xm/x
	    fpv = fpv + xm/(m + n)
	    if( abs(xm/fpv) .lt. acc**2 ) return
	  enddo
	endif
	end

************************************************************************

	complex*16 function yfpv(n, x, y)

	implicit none

	integer n
	complex*16 x, y

	complex*16 fpv
	external fpv

	if( abs(y) .eq. 0 ) then
	  yfpv = 0
	else
	  yfpv = y*fpv(n, x, y)
	endif
	end

************************************************************************

	complex*16 function xlogx(x)

	implicit none
	complex*16 x

	if( abs(x) .eq. 0 ) then
	  xlogx = 0
	else
	  xlogx = x*log(x)
	endif
	end

