      REAL FUNCTION POLE(MGMS,Q)
C*********************************************************************
C* Computes the on-shell (pole) gluino mass for given running (MSbar)*
C* gluino mass, defined at scale MUSQ, and given alpha_s (AS). The   *
C* squark masses are stored in the SQUARK COMMON block.              *
C* This function needs the complex functions B0 and B1.              *
C* Contributed by M. Drees; modified by H. Baer                      *
C                                                                    *
C  Version 7.30: Cast COMPLEX*16 to REAL*8 in standard way. :-(      *
C*********************************************************************

      IMPLICIT NONE
      INCLUDE 'dssusy.h'

      REAL*8 MGMS,Q
      REAL*8 ALFS
      COMPLEX*16 BSH1

      REAL*8 MGSQ,QSQ
      REAL*8 MTP,LAM,FAC,AS
      REAL*8 MST1,MST2,MSB1,MSB2,MSU   
      

      MTP=mass(kt)

      MGSQ = MGMS*MGMS
      QSQ = Q*Q
      LAM = LOG(QSQ)

      MST1=MASS(KSQU(3))
      MST2=MASS(KSQU(6))
      MSB1=MASS(KSQD(3))
      MSB2=MASS(KSQD(6))
      MSU=MASS(KSQU(1))

      AS=ALFS(MGMS)

C
C          Cast COMPLEX*16 to REAL*8:
C
      FAC = -8*BSH1(MGSQ,0.D0,MSU,LAM) - (BSH1(MGSQ,MTP,MST1,LAM)+
     $BSH1(MGSQ,MTP,MST2,LAM)+BSH1(MGSQ,4.0D0,MSB1,LAM)+
     $BSH1(MGSQ,4.0D0,MSB2,LAM))
      FAC = FAC + 12.D0 + 9.D0*LOG(QSQ/MGSQ)
      POLE = MGMS*(1.0 + .0796*AS*FAC )
 

      RETURN
      END




