**********************************************************************
*** function dssigmav returns the annihilation cross section
*** sigma v at p=0 for neutralino-neutralino annihilation.
*** if partch=0, the full sigma v is obtained and if partch>0, the
*** cross section to channel partch is obtained.
*** units: cm^-3 s^-1
**********************************************************************

      function dssigmav(partch)
      implicit none
      real*8 dssigmav
      integer partch
      include 'dssusy.h'
      include 'dshacom.h'
      include 'dsidtag.h'
      include 'dsprep.h'
      real*8 dsandwdcosnn
      integer i
      
      if (newmodelsigmav) then
         wtot=dsandwdcosnn(0.0d0,0.0d0,kn(1),kn(1))
         abr(1) = prtial(22)/wtot ! cc-bar
         abr(2) = prtial(25)/wtot ! bb-bar
         abr(3) = prtial(24)/wtot ! tt-bar
         abr(4) = prtial(19)/wtot ! tau+ tau-
         abr(5) = prtial(13)/wtot ! w+ w-
         abr(6) = prtial(12)/wtot ! z0 z0
         abr(7) = prtial(5)/wtot ! h10 h30
         abr(8) = prtial(8)/wtot ! z0 h10
         abr(9) = prtial(9)/wtot ! z0 h20
         abr(10)= prtial(11)/wtot ! w+ h- / w- h+
         abr(11)= prtial(6)/wtot ! h20 h30
         abr(12)= prtial(26)/wtot ! gluon gluon
         abr(13)= prtial(17)/wtot ! mu+ mu-
         abr(14)= prtial(29)/wtot ! z gamma
         mx=mass(kn(1))
c... sigma v = w / (4*E_1^2) = wtot / (2*mx**2) since integration
c... over cos theta gives factor of 2.
         sigmav = 0.38937966d-27*3.d10*wtot/(2.d0*mx**2) ! in cm^3/s
         do i=1,29
            sigv(i) = prtial(i)/wtot*sigmav
         enddo
         newmodelsigmav=.false.
      endif
      
      dssigmav=sigmav
      if (partch.gt.0) dssigmav=sigv(partch)
      return

      end
