c...This subroutine is automatically generated from form output by
c...parsing it through form2f (version 1.35, May 23, 2002, edsjo@physto.se)
c....Template file for dsashbhb begins here

**************************************************************
*** SUBROUTINE dsashbhb                                    ***
*** computes dW_{ij}/dcostheta                             ***
***                                                        ***
*** sfermion(i) + anti-sfermion(j)                         ***
*** -> higgs-boson + higgs-boson                           ***
***                                                        ***
*** The first mentioned particle (kp1) will be taken as    ***
*** a sfermion and the second particle (kp2) as an         ***
*** anti-sfermion -- not the opposite.                     ***
***                                                        ***
*** When kp1 and kp2 have different                        ***
*** weak isospin (T^3=+,-1/2), then kp1 must be an         ***
*** up-type-sfermion and kp2 a down-type-anti-sfermion.    ***
***                                                        ***
*** For the cases with one charged and one neutral higgs   ***
*** in the final state, the charged higgs must be          ***
*** mentioned first (i.e. kp3) and next the neutral        ***
*** higgs-boson (kp4) -- not the opposite.                 *** 
***                                                        ***
***                                                        ***
*** Author:Mia Schelke, schelke@physto.se                  ***
*** Date: 01-10-19                                         ***
*** Rewritten: 02-07-03 (because FORM input file now       ***
***  only gives the amplitude)                             ***
**************************************************************
***                                                        ***
*** NOTE: The FORM input file only gives the amplitude     ***
***       not the amplitude squared                        ***
*** THE FOLLOWING THEREFORE HAS TO BE CHANGED BY HAND      ***
*** after running of the PERL script                       ***
***                                                        ***
*** the form result should be denoted amplitude instead    ***
*** of dsashbhbas                                          ***
*** the amplitude squared calculation should be added      ***
*** -- the lines are written in the end of                 *** 
*** the template file                                      ***
**************************************************************



      subroutine dsashbhb(kp1,kp2,kp3,kp4,par)
      implicit none
      include 'dssusy.h'
      include 'dsascom.h'
      include 'dsidtag.h'
      integer kp1,kp2,kp3,kp4
      real*8 par,s,t,u
      complex*16 dsasdepro
      integer ksfer1,ksfer2
      
      complex*16  amplitude
      complex*16  g4p
      complex*16  tsf,usf,sgba
      complex*16  sgbb,shb,point
      real*8      dsashbhbas
      real*8      dsabsq
      real*8      msferi2,msferj2,mhb12,mhb22
      real*8      morga(2)
      real*8      col
      integer     k
      integer     ksfer3,ksfer4,kfer
      integer     khb1,khb2
      integer     ksfert(2),ksferu(2),khbs(2),kgbs(2)
      integer     nsfert,nsferu,nhbs,ngbs,npoint
      integer     iaux1,iaux2
      character*4 type


c....check if the final state is kinematically allowed
      if((Svar-(mass(kp3)+mass(kp4))**2)/Svar.lt.thstep) then
        par=0.d0
        return
      endif      

***** check initial state is ok and set type  
      if(iifam(1).ne.0.and.iifam(2).ne.0) then
         call dsassfercode('same',iifam(1),ksfer1,ksfer2)  
         call dsassfercode('diff',iifam(1),ksfer3,ksfer4)           
         if(kp2.eq.ksfer1.or.kp2.eq.ksfer2) then
            type='same' 
         elseif(kp2.eq.ksfer3.or.kp2.eq.ksfer4) then
            type='diff'
         endif
      else
        write(*,*) 'dsashbhb called with wrong particles'   
        write(*,*) 'in the initial state :'  
        write(*,*) pname(kp1),pname(kp2)  
        stop  
      endif    

***** set and check particles in the final state:
      khb1=kp3
      khb2=kp4
      if(khb1.ne.kh1.and.khb1.ne.kh2.and.khb1.ne.kh3.and.
     &   khb1.ne.khc) then
         write(*,*) 'dsashbhb called with kp3 ='   
         write(*,*) pname(khb1)  
         write(*,*) 'instead of a higgs-boson'
        stop
      endif 
      if(khb2.ne.kh1.and.khb2.ne.kh2.and.khb2.ne.kh3.and.
     &   khb2.ne.khc) then
         write(*,*) 'dsashbhb called with kp4 ='   
         write(*,*) pname(khb2)  
         write(*,*) 'instead of a higgs-boson'
        stop
      endif 

***** masses in final state:  
      mass3=mass(khb1)  
      mass4=mass(khb2)  
***** define the kinematic variables  
      call dsaskinset2

c....mass symbols used in form-code
      msferi2=mass(kp1)**2
      msferj2=mass(kp2)**2
      mhb12=mass(khb1)**2
      mhb22=mass(khb2)**2
      s=Svar
      t=Tvar
      u=Uvar


***** now look at the different initial/final state cases
***** first define some numbers that can be used to check
***** if the sfermions are up- or down-type
      iaux1=iifam(1)/10
      iaux2=iifam(1)-iaux1*10
***** iaux2 will be 1 when kp1 is an up-type-sfermions
***** and 2 when it is a down-type-sfermions
*****       
***** 
***** the first case    
***** up-type-sfermion(i) + anti-down-type-sfermion(j) 
***** -> H^+ + H^0_1/H^0_2
      if(type.eq.'diff'.and.iaux2.eq.1.and.khb1.eq.khc.and.
     &   khb2.ne.kh3.and.khb2.ne.khc) then 
***** symmetry factor, for non-identical final state particles
        s34=1.d0  
***** now set particles in the intermediate states 
***** in the t-channel (2 sfermions):  
***** ksfer3 and ksfer4 were found above
        ksfert(1)=ksfer3
        ksfert(2)=ksfer4
        nsfert=2 
***** in the u-channel (1 or 2 sfermions):  
***** ksfer1 and ksfer2 were found above
        ksferu(1)=ksfer1
        if(ksfer2.ne.0) then
          ksferu(2)=ksfer2
          nsferu=2 
        else
          ksferu(2)=0
          nsferu=1
        endif
***** in the s-channel with gauge-boson exchange:
        kgbs(1)=kw
        kgbs(2)=0 
        ngbs=1
        morga(1)=1.d0/mass(kw)**2 
        morga(2)=0.d0
***** in the propagator, morga(k) is a factor that we have
***** defined for the term that is inversely proportional 
***** to the mass squared
***** morga(k) is mass(k)**-2 for a massive gauge boson in the 
***** exchange and 0 for the photon (or no exchange)
*****
***** in the s-channel with higgs exchange:
        khbs(1)=khc
        khbs(2)=0
        nhbs=1  
***** for the point interaction
        npoint=1
***** Below, we will call the function g4p with the following argument
***** g4p(kp2,kp1,khb1,khb2)=g4p(f~_d,f~_u,H^+,H^0_1,2)
***** g4p interpretes g4p(1,2,3,4) as g4p(out,in,out,in)
***** (and it takes H^+ (not H^-) to give the direction of khc)
***** The vertex factor we want is constructed in g4p in  
***** the following way:
***** g4p(H^0_1,2,H^+,f~_u,f~_d) is defined in dsvertx3.f, 
***** the hermitian conjugated of this is 
***** g4p(H^+,H^0_1,2,f~_d,f~_u), i.e. (1<->2,3<->4)
***** which is identical to what we want (1<->3)+(2<->4)
***** i.e. interchanging the order in which the two outgoing particles
***** are mentioned, and likewise for the two incoming particles 
*****
        goto 777
      endif  
***** the second case
***** up-type-sfermion(i) + anti-down-type-sfermion(j) 
***** -> H^+ + H^0_3
      if(type.eq.'diff'.and.iaux2.eq.1.and.
     &   khb1.eq.khc.and.khb2.eq.kh3) then 
***** symmetry factor, for non-identical final state particles
        s34=1.d0  
***** now set particles in the intermediate states 
***** in the t-channel (2 sfermions):  
***** ksfer3 and ksfer4 were found above
        ksfert(1)=ksfer3
        ksfert(2)=ksfer4
        nsfert=2 
***** in the u-channel (2 sfermions or none):
***** (H^0_3 can not couple to a pair of sneutrinos as far as there 
*****  are no right-handed sneutrinos)  
***** ksfer1 and ksfer2 were found above
        if(ksfer2.ne.0) then
          ksferu(1)=ksfer1
          ksferu(2)=ksfer2
          nsferu=2 
        else
          ksferu(1)=0
          ksferu(2)=0
          nsferu=0
        endif
***** in the s-channel with gauge-boson exchange:
        kgbs(1)=kw
        kgbs(2)=0 
        ngbs=1
        morga(1)=1.d0/mass(kw)**2 
        morga(2)=0.d0
***** no s-channel with higgs exchange:
        khbs(1)=0
        khbs(2)=0
        nhbs=0
***** for the point interaction
        npoint=1
***** for g4p, a comment similar to the one for 
***** the previous case applies
*****
        goto 777
      endif  
***** the third case
***** sfermion(i) + anti-sfermion(j) 
***** -> H^0_1+H^0_1,H^0_2+H^0_2,H^0_1+H^0_2
      if(type.eq.'same'.and.
     &       khb1.ne.kh3.and.khb1.ne.khc.and.
     &       khb2.ne.kh3.and.khb2.ne.khc) then 
***** symmetry factor, for identical or non-identical
***** final state particles
        if(khb1.eq.khb2) then
          s34=2.d0
        else
          s34=1.d0
        endif  
***** now set particles in the intermediate states 
***** in the t-channel (1 or 2 sfermions):  
***** ksfer1 and ksfer2 were found above
        ksfert(1)=ksfer1
        if(ksfer2.ne.0) then
          ksfert(2)=ksfer2
          nsfert=2 
        else
          ksfert(2)=0
          nsfert=1
        endif  
***** in the u-channel (1 or 2 sfermions):  
***** ksfer1 and ksfer2 were found above
        ksferu(1)=ksfer1
        if(ksfer2.ne.0) then
          ksferu(2)=ksfer2
          nsferu=2 
        else
          ksferu(2)=0
          nsferu=1
        endif
***** no s-channel with gauge-boson exchange:
        kgbs(1)=0
        kgbs(2)=0 
        ngbs=0
        morga(1)=0.d0 
        morga(2)=0.d0
***** in the s-channel with higgs exchange:
        khbs(1)=kh1
        khbs(2)=kh2
        nhbs=2
***** for the point interaction
        npoint=1
***** Below, we will call the function g4p with the following argument
***** g4p(kp2,kp1,khb1,khb2)=g4p(f~,f~,H^0_1,2,H^0_1,2)
***** These vertex factors are identical to the one set in dsvertx3.f:
***** for two identical higgs's we have g4p(H^0_i,H^0_i,f~,f~), which
***** is connected to what we have by (1<->3)+(2<->4)
***** for the case of two different higgs's, 
***** g4p(H^0_1,H^0_2,f~,f~) is set, and it must have identical 
***** vertex factor to g4p(H^0_2,H^0_1,f~,f~), since the two
***** higgs's are there own anti-particles
*****
        goto 777
      endif  
***** the fourth case
***** sfermion(i) + anti-sfermion(j) 
***** -> H^0_1+H^0_3, H^0_2+H^0_3
      if(type.eq.'same'.and.khb1.ne.khb2.and.
     &       khb1.ne.khc.and.khb2.ne.khc.and.
     &       (khb1.eq.kh3.or.khb2.eq.kh3)) then 
***** symmetry factor, for non-identical final state particles
        s34=1.d0  
***** now set particles in the intermediate states 
***** in the t-channel (2 sfermions or none):
***** (H^0_3 can not couple to a pair of sneutrinos as far as there 
*****  are no right-handed sneutrinos)  
***** ksfer1 and ksfer2 were found above
        if(ksfer2.ne.0) then
          ksfert(1)=ksfer1
          ksfert(2)=ksfer2
          nsfert=2 
        else
          ksfert(1)=0
          ksfert(2)=0
          nsfert=0
        endif  
***** in the u-channel (2 sfermions or none):  
***** (H^0_3 can not couple to a pair of sneutrinos as far as there 
*****  are no right-handed sneutrinos)  
***** ksfer1 and ksfer2 were found above
        if(ksfer2.ne.0) then
          ksferu(1)=ksfer1
          ksferu(2)=ksfer2
          nsferu=2 
        else
          ksferu(1)=0
          ksferu(2)=0
          nsferu=0
        endif
***** in the s-channel with gauge-boson exchange:
        kgbs(1)=kz
        kgbs(2)=0 
        ngbs=1
        morga(1)=1.d0/mass(kz)**2
        morga(2)=0.d0
***** in the s-channel with higgs exchange:
        call dsasfercode('same',iifam(1),kfer)         
***** kfer is the fermion corresponding to the sfermion
        if(dabs(echarg(kfer)).gt.1.d-16) then
         khbs(1)=kh3
         nhbs=1
        else
***** (H^0_3 can not couple to a pair of sneutrinos as far as there 
*****  are no right-handed sneutrinos)
         khbs(1)=0
         nhbs=0
        endif
        khbs(2)=0
***** no point interaction
        npoint=0
*****
        goto 777
      endif 
***** the fifth case
***** sfermion(i) + anti-sfermion(j) 
***** -> H^0_3+H^0_3
      if(type.eq.'same'.and.khb1.eq.kh3.and.
     &   khb2.eq.kh3) then
***** symmetry factor, for identical final state particles
        s34=2.d0  
***** now set particles in the intermediate states 
***** in the t-channel (2 sfermions or none):
***** (H^0_3 can not couple to a pair of sneutrinos as far as there 
*****  are no right-handed sneutrinos)
***** ksfer1 and ksfer2 were found above
        if(ksfer2.ne.0) then
          ksfert(1)=ksfer1
          ksfert(2)=ksfer2
          nsfert=2 
        else
          ksfert(1)=0
          ksfert(2)=0
          nsfert=0
        endif  
***** in the u-channel (2 sfermions or none):  
***** (H^0_3 can not couple to a pair of sneutrinos as far as there 
*****  are no right-handed sneutrinos)
***** ksfer1 and ksfer2 were found above
        if(ksfer2.ne.0) then
          ksferu(1)=ksfer1
          ksferu(2)=ksfer2
          nsferu=2 
        else
          ksferu(1)=0
          ksferu(2)=0
          nsferu=0
        endif
***** no s-channel with gauge-boson exchange:
        kgbs(1)=0
        kgbs(2)=0 
        ngbs=0
        morga(1)=0.d0 
        morga(2)=0.d0
***** in the s-channel with higgs exchange:
        khbs(1)=kh1
        khbs(2)=kh2
        nhbs=2
***** for the point interaction
        npoint=1
***** Below, we will call the function g4p with the following argument
***** g4p(kp2,kp1,khb1,khb2)=g4p(f~,f~,H^0_3,H^0_3)
***** The vertex factor we want is constructed in g4p in  
***** the following way:
***** g4p(H^0_3,H^0_3,f~,f~) is defined in dsvertx3.f,
***** and it is identical to the one we want, which is  
***** obtained by the particle interchange (1<->3)+(2<->4)
***** i.e. interchanging the order in which the two outgoing particles
***** are mentioned, and likewise for the two incoming particles
***** 
        goto 777
      endif 
***** the sixth case 
***** up-type-sfermion(i) + anti-up-type-sfermion(j) 
***** -> H^+ + H^-
***** we take the first higgs boson 
***** (kp3, with four-momentum k1 in the form code) 
***** to be H^+ and the other one is then H^-
      if(type.eq.'same'.and.iaux2.eq.1.and.
     &       khb1.eq.khc.and.khb2.eq.khc) then
***** symmetry factor, for non-identical final state particles
        s34=1.d0  
***** now set particles in the intermediate states 
***** in the t-channel(2 sfermions):
***** ksfer3 and ksfer4 were found above
        ksfert(1)=ksfer3
        ksfert(2)=ksfer4
        nsfert=2
***** no u-channel:  
        ksferu(1)=0
        ksferu(2)=0
        nsferu=0
***** in the s-channel with gauge-boson exchange:
        kgbs(1)=kz
        morga(1)=1.d0/mass(kz)**2
        call dsasfercode('same',iifam(1),kfer)         
***** kfer is the fermion corresponding to the sfermion
        if(dabs(echarg(kfer)).gt.1.d-16) then         
          kgbs(2)=kgamma 
          morga(2)=0.d0
          ngbs=2
        else
          kgbs(2)=0 
          morga(2)=0.d0
          ngbs=1
        endif
***** in the propagator, morga(k) is a factor that we have
***** defined for the term that is inversely proportional 
***** to the mass squared
***** morga(k) is mass(k)**-2 for a massive gauge boson in the 
***** exchange and 0 for the photon (or no exchange)
*****
***** in the s-channel with higgs exchange:
        khbs(1)=kh1
        khbs(2)=kh2
        nhbs=2
***** for the point interaction
        npoint=1
***** Below, we will call the function g4p with the following argument
***** g4p(kp2,kp1,khb1,khb2)=g4p(f~_u,f~_u,H^+_out,H^+_in)
***** =g4p(f~_u,f~_u,khc,khc)
***** g4p interpretes g4p(1,2,3,4) as g4p(out,in,out,in),
***** and it takes H^+ (not H^-) to give the direction of khc
***** so we have got it correct in this case
*****
        goto 777
      endif 
***** the seventh case
***** down-type-sfermion(i) + anti-down-type-sfermion(j) 
***** -> H^+ + H^-
***** we take the first higgs boson 
***** (kp3, with four-momentum k1 in the form code) 
***** to be H^+ and the other one is then H^-
      if(type.eq.'same'.and.iaux2.eq.2.and.
     &       khb1.eq.khc.and.khb2.eq.khc) then
***** symmetry factor, for non-identical final state particles
        s34=1.d0  
***** now set particles in the intermediate states 
***** no t-channel:
        ksfert(1)=0
        ksfert(2)=0
        nsfert=0 
***** in the u-channel(1 or 2 sfermions):
***** ksfer3 and ksfer4 were found above
        ksferu(1)=ksfer3
        if(ksfer4.ne.0) then
          ksferu(2)=ksfer4
          nsferu=2 
        else
          ksferu(2)=0
          nsferu=1
        endif      
***** in the s-channel with gauge-boson exchange:
        kgbs(1)=kz
        morga(1)=1.d0/mass(kz)**2
        kgbs(2)=kgamma 
        morga(2)=0.d0
        ngbs=2
***** in the propagator, morga(k) is a factor that we have
***** defined for the term that is inversely proportional 
***** to the mass squared
***** morga(k) is mass(k)**-2 for a massive gauge boson in the 
***** exchange and 0 for the photon (or no exchange)
*****
***** in the s-channel with higgs exchange:
        khbs(1)=kh1
        khbs(2)=kh2
        nhbs=2
***** for the point interaction
        npoint=1
***** for the point interaction, a comment similar to the one 
***** for the sixth case applies
        goto 777
      endif 

        write(*,*) 'dsashbhb called with wrong '   
        write(*,*) 'initial or final state'  
        write(*,*) pname(kp1),pname(kp2),' -> ',
     &             pname(kp3),pname(kp4)   
        stop  

 777  continue        


c....specify the coefficients used in the form-code
c....first for the t-channel(sfermion exchange)
      tsf=dcmplx(0.d0,0.d0)
      if(nsfert.gt.0) then
       do k=1,nsfert
        tsf=tsf+gl(khb1,ksfert(k),kp1)
     &    *(-dsasdepro(t,ksfert(k)))
     &    *gl(khb2,kp2,ksfert(k))
       enddo
      endif

c....then for the u-channel(sfermion exchange)
      usf=dcmplx(0.d0,0.d0)
      if(nsferu.gt.0) then
       do k=1,nsferu
        usf=usf+gl(khb2,ksferu(k),kp1)
     &    *(-dsasdepro(u,ksferu(k)))
     &    *gl(khb1,kp2,ksferu(k))
       enddo
      endif

c....then the s-channel with gauge-boson exchange
      sgba=dcmplx(0.d0,0.d0)
      sgbb=dcmplx(0.d0,0.d0)
      if(ngbs.gt.0) then
       do k=1,ngbs
        sgba=sgba+gl(kgbs(k),kp2,kp1)*dsasdepro(s,kgbs(k))
     &     *gl(kgbs(k),khb1,khb2)
        sgbb=sgbb+morga(k)*
     &     gl(kgbs(k),kp2,kp1)*(-dsasdepro(s,kgbs(k)))
     &     *gl(kgbs(k),khb1,khb2)
       enddo
      endif   

c....then the s-channel with higgs exchange
      shb=dcmplx(0.d0,0.d0)
      if(nhbs.gt.0) then
       do k=1,nhbs
        shb=shb+gl(khbs(k),kp2,kp1)
     &    *(-dsasdepro(s,khbs(k)))
     &    *mass(kw)*gl(khb2,khb1,khbs(k))
       enddo
      endif

c....then the point interaction
      point=dcmplx(0.d0,0.d0)
      if(npoint.gt.0) then
       point=g4p(kp2,kp1,khb1,khb2)
      endif     

***** now set the color factors to 1 for two sleptons in
***** the initial state and to 3 for two squarks in
***** the initial state  

      col=1.d0

      if(iifam(1).ge.ivfam(ksu1).and.iifam(1).le.ivfam(ksb2)) then   
        col=3.d0     
      endif

***** After the template file follows the form expression of the
***** amplitude: called amplitude
***** NOTE: THE NAME HAS BEEN CHANGED  
***** from dsashbhbas to amplitude 
***** after running the PERL script
***** NOTE: this is NOT THE AMPLITUDE SQUARED 
***** JUST THE AMPLITUDE

***** Then we calculate the amplitude SQUARED 
***** and multiply it by the color factor
***** This is done by the following lines
***** which have to be PUT IN BY HAND
***** after running the PERL script

*      dsashbhbas=col*dsabsq(amplitude)
**    dsabsq is a function that calculates the 
**    absolute squared of a complex number
c....Template file for dsashbhb ends here



      amplitude =
     &  + msferi2*mhb12*sgbb
     &  - msferi2*mhb22*sgbb
     &  + msferi2*sgba
     &  - msferj2*mhb12*sgbb
     &  + msferj2*mhb22*sgbb
     &  + msferj2*sgba
     &  + mhb12*sgba
     &  + mhb22*sgba
     &  - s*sgba
     &  - 2.d0*t*sgba
     &  + tsf
     &  + usf
     &  + shb
     &  + point

      dsashbhbas=col*dsabsq(amplitude)
**    dsabsq is a function that calculates the 
**    absolute squared of a complex number

      if (dsashbhbas.lt.0.0d0) then
        write(*,*) ' '
        write(*,*) 'ERROR IN dsashbhb with negative cross section:'
        write(*,*) 'kp1=',kp1,'  ',pname(kp1)
        write(*,*) 'kp2=',kp2,'  ',pname(kp2)
        write(*,*) 'kp3=',kp3,'  ',pname(kp3)
        write(*,*) 'kp4=',kp4,'  ',pname(kp4)
        write(*,*) 'dsashbhbas=',dsashbhbas
        
        write(*,*) 'mass1=',mass1
        write(*,*) 'mass2=',mass2
        write(*,*) 'mass3=',mass3
        write(*,*) 'mass4=',mass4
        write(*,*) 's=',s
        write(*,*) 't=',t
        write(*,*) 'u=',u
        write(*,*) 'p12=',p12
        write(*,*) 'costheta=',costheta
        dsashbhbas=0.0d0
      endif

c...Convert to dW_eff/dcos(theta)
      par=dble(dsashbhbas)*k34/(8.0d0*pi*gg1*gg2*s34*dsqrt(s))
      return
      end


