c...This subroutine is automatically generated from form output by
c...parsing it through form2f (version 1.35, May 23, 2002, edsjo@physto.se)
c....Template file for dsasphghb begins here           

      subroutine dsasphghb(kp1,kp2,kp3,kp4,par)
      implicit none
      include 'dssusy.h'
      include 'dsascom.h'
      integer kp1,kp2,kp3,kp4
      real*8 par,s,t,u
      complex*16 dsasdepro
      integer ksfer1,ksfer2
      real*8      dsasphghbas
      real*8      msferi2,msferj2,mhb2
      complex*16  tsf,usf,shb
      complex*16  ctsf,cusf,cshb
      real*8      tsfctsf,usfcusf,shbcshb,
     &            tsfcusf2r,tsfcshb2r,usfcshb2r
      real*8      ctt,cuu,cshbshb,ctu,ctshb,cushb           
      integer     k
      integer     ksfer3,ksfer4,kfer,kgb,khb
      integer     ksfert(2),ksferu(2),khbs(3)
      integer     nsfert,nsferu,nhbs
      integer     iaux1,iaux2
      character*4 type                   


***** check initial state is ok and set type
      if(iifam(1).ne.0.and.iifam(2).ne.0) then
         call dsassfercode('same',iifam(1),ksfer1,ksfer2)
         call dsassfercode('diff',iifam(1),ksfer3,ksfer4)
         if(kp2.eq.ksfer1.or.kp2.eq.ksfer2) then
            type='same'
         elseif(kp2.eq.ksfer3.or.kp2.eq.ksfer4) then
            type='diff'
         endif
      else
        write(*,*) 'dsasphghb called with wrong particles'
        write(*,*) 'in the initial state :'
        write(*,*) pname(kp1),pname(kp2)
        stop
      endif

***** set and check particles in the final state:
      kgb=kp3
      khb=kp4
      if(kgb.ne.kgamma.and.kgb.ne.kgluon) then
        write(*,*) 'dsasphghb called with kp3 ='
        write(*,*) pname(kgb)
        write(*,*) 'instead of a photon/gluon'
        stop
      endif
      if(khb.ne.kh1.and.khb.ne.kh2.and.khb.ne.kh3.and.
     &   khb.ne.khc) then  
         write(*,*) 'dsasphghb called with kp4 ='
         write(*,*) pname(khb)
         write(*,*) 'instead of a higgs-boson'
        stop
      endif          

***** masses in final state:
      mass3=mass(kgb)
      mass4=mass(khb)
***** define the askinder variables
      call dsaskinset

c....symmetry factor, for non-identical final state particles
      s34=1.d0

c....mass symbols used in form-code
      msferi2=mass(kp1)**2
      msferj2=mass(kp2)**2
*      mgb2=mass(kgb)**2
      mhb2=mass(khb)**2
      s=Svar
      t=Tvar
      u=Uvar

c....check if the final state is allowed
      if(s.lt.(mass(kgb)+mass(khb))**2) then
        par=0.d0
        return
      endif
              
***** now set the color factors to 1.d0 for two sleptons in
***** the initial state and to 3.d0 for two squarks in
***** the initial state
***** if the gauge boson in the final state is a gluon, then the
***** color factor is changed later

      ctt=1.d0
      cuu=1.d0
      cshbshb=1.d0
      ctu=1.d0
      ctshb=1.d0
      cushb=1.d0

      if(iifam(1).ge.ivfam(ksu1).and.iifam(1).le.ivfam(ksb2)) then
        ctt=3.d0
        cuu=3.d0
        cshbshb=3.d0
        ctu=3.d0
        ctshb=3.d0
        cushb=3.d0
      endif       
                          
***** now look at the different initial/final state cases
***** first define some numbers that can be used to check
***** if the sfermions are up- or down-type
      iaux1=iifam(1)/10
      iaux2=iifam(1)-iaux1*10
***** iaux2 will be 1 when kp1 is an up-type-sfermions
***** and 2 when it is a down-type-sfermions
*****                                                                

***** the first case (=case 2 in dsasgbhb)
***** up-type-sfermion(i) + anti-down-type-sfermion(j)
***** -> photon + H^+
      if(type.eq.'diff'.and.iaux2.eq.1.and.
     &   kgb.eq.kgamma.and.khb.eq.khc) then
***** in the t-channel (2 sfermions or none):
***** ksfer1 and ksfer2 were found above
        if(ksfer2.ne.0) then
          ksfert(1)=ksfer1
          ksfert(2)=ksfer2
          nsfert=2
        else
          ksfert(1)=0
          ksfert(2)=0
          nsfert=0
        endif
***** in the u-channel (2 sfermions):
***** ksfer3 and ksfer4 were found above
        ksferu(1)=ksfer3
        ksferu(2)=ksfer4
        nsferu=2
***** in the s-channel with higgs exchange:
        khbs(1)=khc
        khbs(2)=0
        khbs(3)=0
        nhbs=1
*****
***** the second case (=case 7 in dsasgbhb)
***** sfermion(i) + anti-sfermion(j)
***** -> photon + H^0_1/H^0_2/H^0_3
      elseif(type.eq.'same'.and.kgb.eq.kgamma.and.
     &       khb.ne.khc) then
***** in the t-channel(2 sfermions or none):
***** ksfer1 and ksfer2 were found above
        if(ksfer2.ne.0) then
          ksfert(1)=ksfer1
          ksfert(2)=ksfer2
          nsfert=2
        else
          ksfert(1)=0
          ksfert(2)=0
          nsfert=0
        endif
***** in the u-channel(2 sfermions or none):
***** ksfer1 and ksfer2 were found above
        if(ksfer2.ne.0) then
          ksferu(1)=ksfer1
          ksferu(2)=ksfer2
          nsferu=2
        else
          ksferu(1)=0
          ksferu(2)=0
          nsferu=0
        endif
***** no s-channel with higgs exchange:
        khbs(1)=0
        khbs(2)=0
        khbs(3)=0
        nhbs=0  
*****
***** the third case (=case 10 in dsasgbhb)
***** squark(i) + anti-squark(j)
***** -> gluon + H^0_{1,2,3}
      elseif(iifam(1).ge.ivfam(ksu1).and.iifam(1).le.ivfam(ksb2).and.
     &   type.eq.'same'.and.kgb.eq.kgluon.and.khb.ne.khc) then
*****  set the color factors
        ctt=4.d0
        cuu=4.d0
        cshbshb=0.d0
        ctu=4.d0
        ctshb=0.d0
        cushb=0.d0
***** in the t-channel(2 sfermions):
***** ksfer1 and ksfer2 were found above
        ksfert(1)=ksfer1
        ksfert(2)=ksfer2
        nsfert=2
***** in the u-channel(2 sfermions):
***** ksfer1 and ksfer2 were found above
        ksferu(1)=ksfer1
        ksferu(2)=ksfer2
        nsferu=2
***** no s-channel with higgs exchange:
        nhbs=0     
*****
***** the fourth case (=case 11 in dsasgbhb)
***** up-type-squark(i) + anti-down-type-squark(j)
***** -> gluon + H^+
      elseif(iifam(1).ge.ivfam(ksu1).and.iifam(1).le.ivfam(ksb2).and.
     &   type.eq.'diff'.and.iaux2.eq.1.and.
     &   kgb.eq.kgluon.and.khb.eq.khc) then
*****  set the color factors
        ctt=4.d0
        cuu=4.d0
        cshbshb=0.d0
        ctu=4.d0
        ctshb=0.d0
        cushb=0.d0
***** in the t-channel (2 sfermions):
***** ksfer1 and ksfer2 were found above
        ksfert(1)=ksfer1
        ksfert(2)=ksfer2
        nsfert=2
***** in the u-channel (2 sfermions):
***** ksfer3 and ksfer4 were found above
        ksferu(1)=ksfer3
        ksferu(2)=ksfer4
        nsferu=2
***** no s-channel with higgs exchange:
        nhbs=0   
      else
        write(*,*) 'dsasphghb called with wrong '
        write(*,*) 'initial or final state'
        write(*,*) pname(kp1),pname(kp2),' -> ',
     &             pname(kp3),pname(kp4)
        stop
      endif

*      if(nsfert.gt.0) then
*       do k=1,nsfert
*        width(ksfert(k))=0.d0
*       enddo
*      endif

*      if(nsferu.gt.0) then
*       do k=1,nsferu
*        width(ksferu(k))=0.d0
*       enddo
*      endif

*      if(nhbs.gt.0) then
*       do k=1,nhbs
*        width(khbs(k))=0.d0
*       enddo
*      endif

                    
c....specify the coefficients used in the form-code
c....first for the t-channel(sfermion exchange)
      tsf=dcmplx(0.d0,0.d0)
      if(nsfert.gt.0) then
       do k=1,nsfert
        tsf=tsf+gl(kgb,ksfert(k),kp1)
     &    *(-dsasdepro(t,ksfert(k)))
     &    *gl(khb,kp2,ksfert(k))
       enddo
      endif

c....then the u-channel(sfermion exchange)
      usf=dcmplx(0.d0,0.d0)
      if(nsferu.gt.0) then
       do k=1,nsferu
        usf=usf+gl(khb,ksferu(k),kp1)
     &     *(-dsasdepro(u,ksferu(k)))
     &     *gl(kgb,kp2,ksferu(k))
       enddo
      endif

c....then the s-channel with higgs exchange
      shb=dcmplx(0.d0,0.d0)
      if(nhbs.gt.0) then
       do k=1,nhbs
        shb=shb+gl(khbs(k),kp2,kp1)
     &    *(-dsasdepro(s,khbs(k)))
     &    *gl(kgb,khb,khbs(k))
       enddo
      endif                                     
c....then all the real combinations
c....used in the form code
c....color factors ctt,cuu etc. are included here        

*      tsf=dcmplx(0.d0,0.d0)
*      shb=dcmplx(0.d0,0.d0)

*      ctsf=conjg(tsf)
*      cusf=conjg(usf)
*      cshb=conjg(shb)

      tsfctsf=ctt*dble(tsf*conjg(tsf))
      usfcusf=cuu*dble(usf*conjg(usf))
      shbcshb=cshbshb*dble(shb*conjg(shb))
      tsfcusf2r=ctu*2*dble(tsf*conjg(usf))
      tsfcshb2r=ctshb*2*dble(tsf*conjg(shb))
      usfcshb2r=cushb*2*dble(usf*conjg(shb))

*      tsfctsf=0.d0
*      usfcusf=0.d0
*      shbcshb=0.d0

*      tsfcshb2r=0.d0
*      usfcshb2r=0.d0


***** After the template file follows the form expression of the
***** amplitude squared: dsasphghbas

c....Template file for dsasphghb ends here
                                                                
      dsasphghbas =
     &  - 4.d0*msferi2*tsfctsf
     &  - 2.d0*msferi2*usfcusf
     &  - 3.d0*msferi2*tsfcusf2r
     &  - msferi2*tsfcshb2r
     &  - msferi2*usfcshb2r
     &  - 4.d0*msferj2*usfcusf
     &  - 2.d0*msferj2*tsfcusf2r
     &  + 2.d0*msferj2*tsfcshb2r
     &  + 2.d0*msferj2*usfcshb2r
     &  - 2.d0*mhb2*usfcusf
     &  - 2.d0*mhb2*shbcshb
     &  + 2.d0*mhb2*usfcshb2r
     &  + 2.d0*s*usfcusf
     &  - 2.d0*s*shbcshb
     &  + 2.d0*s*tsfcusf2r
     &  - 2.d0*s*tsfcshb2r
     &  + 2.d0*t*usfcusf
     &  + t*tsfcusf2r
     &  - t*tsfcshb2r
     &  - t*usfcshb2r
     &  - 4.d0/( - mhb2 + s)*msferi2*msferj2*tsfctsf
     &  - 4.d0/( - mhb2 + s)*msferi2*msferj2*usfcusf
     &  - 4.d0/( - mhb2 + s)*msferi2*msferj2*tsfcusf2r
     &  + 2.d0/( - mhb2 + s)*msferi2*mhb2*usfcusf
     &  + 1.d0/( - mhb2 + s)*msferi2*mhb2*tsfcusf2r
     &  - 1.d0/( - mhb2 + s)*msferi2*mhb2*tsfcshb2r
     &  - 1.d0/( - mhb2 + s)*msferi2*mhb2*usfcshb2r
     &  + 4.d0/( - mhb2 + s)*msferi2*s*tsfctsf
     &  - 6.d0/( - mhb2 + s)*msferi2*s*usfcusf
     &  - 1.d0/( - mhb2 + s)*msferi2*s*tsfcusf2r
     &  + 5.d0/( - mhb2 + s)*msferi2*s*tsfcshb2r
     &  + 5.d0/( - mhb2 + s)*msferi2*s*usfcshb2r
     &  - 4.d0/( - mhb2 + s)*msferi2*t*tsfctsf
     &  - 4.d0/( - mhb2 + s)*msferi2*t*usfcusf
     &  - 4.d0/( - mhb2 + s)*msferi2*t*tsfcusf2r
     &  + 4.d0/( - mhb2 + s)*msferi2**2*tsfctsf
     &  + 4.d0/( - mhb2 + s)*msferi2**2*usfcusf
     &  + 4.d0/( - mhb2 + s)*msferi2**2*tsfcusf2r
     &  - 4.d0/( - mhb2 + s)*msferj2*mhb2*usfcusf
     &  - 2.d0/( - mhb2 + s)*msferj2*mhb2*tsfcusf2r
     &  + 2.d0/( - mhb2 + s)*msferj2*mhb2*tsfcshb2r
     &  + 2.d0/( - mhb2 + s)*msferj2*mhb2*usfcshb2r
     &  + 4.d0/( - mhb2 + s)*msferj2*s*usfcusf
     &  + 2.d0/( - mhb2 + s)*msferj2*s*tsfcusf2r
     &  - 2.d0/( - mhb2 + s)*msferj2*s*tsfcshb2r
     &  - 2.d0/( - mhb2 + s)*msferj2*s*usfcshb2r
     &  + 4.d0/( - mhb2 + s)*msferj2*t*tsfctsf
     &  + 4.d0/( - mhb2 + s)*msferj2*t*usfcusf
     &  + 4.d0/( - mhb2 + s)*msferj2*t*tsfcusf2r
     &  - 4.d0/( - mhb2 + s)*mhb2*s*shbcshb
     &  + 2.d0/( - mhb2 + s)*mhb2*s*tsfcusf2r
     &  - 2.d0/( - mhb2 + s)*mhb2*s*tsfcshb2r
     &  + 2.d0/( - mhb2 + s)*mhb2*s*usfcshb2r
     &  + 2.d0/( - mhb2 + s)*mhb2*t*usfcusf
     &  + 1.d0/( - mhb2 + s)*mhb2*t*tsfcusf2r
     &  - 1.d0/( - mhb2 + s)*mhb2*t*tsfcshb2r
     &  - 1.d0/( - mhb2 + s)*mhb2*t*usfcshb2r
     &  - 2.d0/( - mhb2 + s)*mhb2**2*usfcusf
     &  - 2.d0/( - mhb2 + s)*mhb2**2*shbcshb
     &  + 2.d0/( - mhb2 + s)*mhb2**2*usfcshb2r
     &  - 4.d0/( - mhb2 + s)*s*t*tsfctsf
     &  + 2.d0/( - mhb2 + s)*s*t*usfcusf
     &  - 1.d0/( - mhb2 + s)*s*t*tsfcusf2r
     &  - 3.d0/( - mhb2 + s)*s*t*tsfcshb2r
     &  - 3.d0/( - mhb2 + s)*s*t*usfcshb2r
     &  + 2.d0/( - mhb2 + s)*s**2*usfcusf
     &  + 6.d0/( - mhb2 + s)*s**2*shbcshb
     &  - 2.d0/( - mhb2 + s)*s**2*tsfcusf2r
     &  + 2.d0/( - mhb2 + s)*s**2*tsfcshb2r
     &  - 4.d0/( - mhb2 + s)*s**2*usfcshb2r
     &  - 8.d0/( - mhb2 + s)/( - mhb2 + s)*msferi2*mhb2*s*usfcusf
     &  - 4.d0/( - mhb2 + s)/( - mhb2 + s)*msferi2*mhb2*s*tsfcusf2r
     &  + 4.d0/( - mhb2 + s)/( - mhb2 + s)*msferi2*mhb2*s*tsfcshb2r
     &  + 4.d0/( - mhb2 + s)/( - mhb2 + s)*msferi2*mhb2*s*usfcshb2r
     &  + 8.d0/( - mhb2 + s)/( - mhb2 + s)*msferi2*s*t*tsfctsf
     &  + 8.d0/( - mhb2 + s)/( - mhb2 + s)*msferi2*s*t*usfcusf
     &  + 8.d0/( - mhb2 + s)/( - mhb2 + s)*msferi2*s*t*tsfcusf2r
     &  + 8.d0/( - mhb2 + s)/( - mhb2 + s)*msferi2*s**2*usfcusf
     &  + 4.d0/( - mhb2 + s)/( - mhb2 + s)*msferi2*s**2*tsfcusf2r
     &  - 4.d0/( - mhb2 + s)/( - mhb2 + s)*msferi2*s**2*tsfcshb2r
     &  - 4.d0/( - mhb2 + s)/( - mhb2 + s)*msferi2*s**2*usfcshb2r
     &  - 4.d0/( - mhb2 + s)/( - mhb2 + s)*msferi2**2*s*tsfctsf
     &  - 4.d0/( - mhb2 + s)/( - mhb2 + s)*msferi2**2*s*usfcusf
     &  - 4.d0/( - mhb2 + s)/( - mhb2 + s)*msferi2**2*s*tsfcusf2r
     &  + 8.d0/( - mhb2 + s)/( - mhb2 + s)*mhb2*s*t*usfcusf
     &  + 4.d0/( - mhb2 + s)/( - mhb2 + s)*mhb2*s*t*tsfcusf2r
     &  - 4.d0/( - mhb2 + s)/( - mhb2 + s)*mhb2*s*t*tsfcshb2r
     &  - 4.d0/( - mhb2 + s)/( - mhb2 + s)*mhb2*s*t*usfcshb2r
     &  + 8.d0/( - mhb2 + s)/( - mhb2 + s)*mhb2*s**2*usfcusf
     &  + 8.d0/( - mhb2 + s)/( - mhb2 + s)*mhb2*s**2*shbcshb
     &  - 8.d0/( - mhb2 + s)/( - mhb2 + s)*mhb2*s**2*usfcshb2r
     &  - 4.d0/( - mhb2 + s)/( - mhb2 + s)*mhb2**2*s*usfcusf
     &  - 4.d0/( - mhb2 + s)/( - mhb2 + s)*mhb2**2*s*shbcshb
     &  + 4.d0/( - mhb2 + s)/( - mhb2 + s)*mhb2**2*s*usfcshb2r
     &  - 4.d0/( - mhb2 + s)/( - mhb2 + s)*s*t**2*tsfctsf
     &  - 4.d0/( - mhb2 + s)/( - mhb2 + s)*s*t**2*usfcusf
     &  - 4.d0/( - mhb2 + s)/( - mhb2 + s)*s*t**2*tsfcusf2r
     &  - 8.d0/( - mhb2 + s)/( - mhb2 + s)*s**2*t*usfcusf
     &  - 4.d0/( - mhb2 + s)/( - mhb2 + s)*s**2*t*tsfcusf2r
     &  + 4.d0/( - mhb2 + s)/( - mhb2 + s)*s**2*t*tsfcshb2r
     &  + 4.d0/( - mhb2 + s)/( - mhb2 + s)*s**2*t*usfcshb2r
     &  - 4.d0/( - mhb2 + s)/( - mhb2 + s)*s**3*usfcusf
     &  - 4.d0/( - mhb2 + s)/( - mhb2 + s)*s**3*shbcshb
     &  + 4.d0/( - mhb2 + s)/( - mhb2 + s)*s**3*usfcshb2r


c...Convert to dW_eff/dcos(theta)
      par=dble(dsasphghbas)*k34/(8.0d0*pi*gg1*gg2*s34*dsqrt(s))
      return
      end
