**************************************************************
*** SUBROUTINE dsassfercode                                ***
*** finds sfermions ksfer1,ksfer2 in a given family iifamv ***
*** chow variable equal to                                 ***
*** 'same' : routine returns sfermion code for the         ***
***          particles with the same iifamv                ***
*** 'diff' : routine returns sfermion code for the         ***
***          particles with the same iifamv+1 or iifamv-1  ***
***                                                        *** 
*** AUTHOR: Piero Ullio, ullio@sissa.it                    ***
*** Date: 01-08-09                                         ***
**************************************************************

      subroutine dsassfercode(chow,iifamv,ksfer1,ksfer2)
      implicit none
      character*4 chow
      include 'dssusy.h'
      include 'dsascom.h'
      integer iifamv,ksfer1,ksfer2,iaux1,iaux2
*****      
      ksfer1=0
      ksfer2=0
      iaux1=iifamv/10
      iaux2=iifamv-iaux1*10
*****
      if(iaux1.eq.ivfam(knue)/10) then
        if((iaux2.eq.1.and.chow.eq.'same').or.
     &     (iaux2.eq.2.and.chow.eq.'diff')) then
          ksfer1=ksnue
          ksfer2=0
        elseif((iaux2.eq.2.and.chow.eq.'same').or.
     &     (iaux2.eq.1.and.chow.eq.'diff')) then
          ksfer1=kse1
          ksfer2=kse2
        else
          goto 100 
        endif
      elseif(iaux1.eq.ivfam(knumu)/10) then
        if((iaux2.eq.1.and.chow.eq.'same').or.
     &     (iaux2.eq.2.and.chow.eq.'diff')) then
          ksfer1=ksnumu
          ksfer2=0
        elseif((iaux2.eq.2.and.chow.eq.'same').or.
     &     (iaux2.eq.1.and.chow.eq.'diff')) then
          ksfer1=ksmu1
          ksfer2=ksmu2
        else
          goto 100 
        endif
      elseif(iaux1.eq.ivfam(knutau)/10) then
        if((iaux2.eq.1.and.chow.eq.'same').or.
     &     (iaux2.eq.2.and.chow.eq.'diff')) then
          ksfer1=ksnutau
          ksfer2=0
        elseif((iaux2.eq.2.and.chow.eq.'same').or.
     &     (iaux2.eq.1.and.chow.eq.'diff')) then
          ksfer1=kstau1
          ksfer2=kstau2
        else
          goto 100 
        endif
      elseif(iaux1.eq.ivfam(ku)/10) then
        if((iaux2.eq.1.and.chow.eq.'same').or.
     &     (iaux2.eq.2.and.chow.eq.'diff')) then
          ksfer1=ksu1
          ksfer2=ksu2
        elseif((iaux2.eq.2.and.chow.eq.'same').or.
     &     (iaux2.eq.1.and.chow.eq.'diff')) then
          ksfer1=ksd1
          ksfer2=ksd2
        endif
      elseif(iaux1.eq.ivfam(kc)/10) then
        if((iaux2.eq.1.and.chow.eq.'same').or.
     &     (iaux2.eq.2.and.chow.eq.'diff')) then
          ksfer1=ksc1
          ksfer2=ksc2
        elseif((iaux2.eq.2.and.chow.eq.'same').or.
     &     (iaux2.eq.1.and.chow.eq.'diff')) then
          ksfer1=kss1
          ksfer2=kss2
        else
          goto 100 
        endif
      elseif(iaux1.eq.ivfam(kt)/10) then
        if((iaux2.eq.1.and.chow.eq.'same').or.
     &     (iaux2.eq.2.and.chow.eq.'diff')) then
          ksfer1=kst1
          ksfer2=kst2
        elseif((iaux2.eq.2.and.chow.eq.'same').or.
     &     (iaux2.eq.1.and.chow.eq.'diff')) then
          ksfer1=ksb1
          ksfer2=ksb2
        else
          goto 100 
        endif
      else  
        goto 100 
      endif
      
      return
      
***** something went wrong 
 100  continue
      write(*,*) 'error in dsassfercode'
      write(*,*) 'chow,iifamv =',chow,iifamv
      write(*,*) 'iaux1,iaux2 =',iaux1,iaux2
      stop
      end
       
           
          
      
