      subroutine dsddneunuc(sigsip,sigsin,sigsdp,sigsdn)
c_______________________________________________________________________
c  neutralino nucleon cross section.
c  common:
c    'dssusy.h' - file with susy common blocks
c  output:
c    sigsip, sigsin : proton and neutron spin-independent cross sections
c    sigsdp, sigsdn : proton and neutron spin-dependent cross sections
c    units: cm^2
c  author: paolo gondolo (gondolo@lpthe.jussieu.fr) 1994,1995,2002
c     13-sep-94 pg no drees-nojiri twist-2 terms
c     22-apr-95 pg important bug corrected [ft -> ft mp/mq]
c     06-apr-02 pg drees-nojiri treatment added
c=======================================================================
      implicit none
      include 'dssusy.h'
      include 'dsprep.h'
      include 'dsddcom.h'
      include 'dshacom.h'

      real*8 sigsip,sigsdp,sigsin,sigsdn
      integer kx
      real*8 gev2cm2,mp,mn,fkinp,fkinn,gps,gns,gpa,gna
      parameter (gev2cm2 = (197.327053d-16)**2)
      parameter (mp=0.93827231d0)
      parameter (mn=0.931494013d0)

      kx = kn(kln)
      mx = mass(kx)
      fkinp = 4./pi*(mp*mx/(mp+mx))**2
      fkinn = 4./pi*(mn*mx/(mn+mx))**2

      call dsddgpgn(gps,gns,gpa,gna)

      sigsip = fkinp*(gps/2.d0)**2   ! in gev^-2
      sigsin = fkinn*(gns/2.d0)**2   ! in gev^-2

      sigsdp = fkinp*(3./4.)*(gpa)**2 ! in gev^-2
      sigsdn = fkinn*(3./4.)*(gna)**2 ! in gev^-2

      sigsip = gev2cm2*sigsip
      sigsin = gev2cm2*sigsin
      sigsdp = gev2cm2*sigsdp
      sigsdn = gev2cm2*sigsdn

      return
      end
