      subroutine dsddset(sisd,cs)
c...set parameters for scattering cross section
c...  c - character string specifying choice to be made
c...author: paolo gondolo 2000-07-07
      implicit none
      include 'dsddcom.h'
      character*(*) sisd,cs
      logical goodoption

      goodoption=.false.

c...spin-independent parameters and uncert from hep-ph/0001005

c      ftp_u= 0.020 \pm 0.004
c      ftp_d= 0.026 \pm 0.005  
c      ftp_s= 0.118 \pm 0.062

c      ftn_u= 0.014 \pm 0.003
c      ftn_d= 0.036 \pm 0.008  
c      ftn_s= 0.118 \pm 0.062


c...gaisser,leutwyler,sainio,plb253(91)252
c...drees,nojiri,prd48(93)3483
c...bergstrom,gondolo,astrop.ph.
      if (sisd.eq.'si'.and.(
     &     cs.eq.'gls91'.or.cs.eq.'dn93'.or.cs.eq.'bg96'
     &     .or.cs.eq.'default')) then
         goodoption=.true.
         ftp(7)=0.020 !0.023 new central values from hep-ph/0001005
         ftp(8)=0.026 !0.020
         ftp(9)=0.0595 
         ftp(10)=0.118 !0.118 !0.14
         ftp(11)=0.0595
         ftp(12)=0.0595
         ftn(7)=0.014 !0.019
         ftn(8)=0.036 !0.041
         ftn(9)=0.0592
         ftn(10)=0.118 !0.14
         ftn(11)=0.0592
         ftn(12)=0.0592
         dddn = 0
         ddpole = 0
      endif
            
c...spin-dependent
c...drees,nojiri,prd48(93)3483
      if (sisd.eq.'sd'.and.(cs.eq.'dn93'.or.cs.eq.'emc')) then
         goodoption=.true.
         delu=0.77
         deld=-0.49
         dels=-0.15
      endif
            
c...spin-dependent
c...bergstrom,gondolo,astrop.ph.
c...d.adams et al cern-ppe/94-57
      if (sisd.eq.'sd'.and.(
     &     cs.eq.'bg96'.or.cs.eq.'smc'.or.cs.eq.'default')) then
         goodoption=.true.
         delu=0.74
         deld=-0.40
         dels=-0.12
      endif
      
c...allow for pole in scattering
      if (cs.eq.'pole') then
         goodoption=.true.
         ddpole=1
      endif
      if (cs.eq.'nopole'.or.cs.eq.'default') then
         goodoption=.true.
         ddpole=0
      endif

c...drees-nojiri treatment of heavy quarks
      if (sisd.eq.'si'.and.cs.eq.'dn1') then
         goodoption=.true.
         dddn=1
      endif
      if (sisd.eq.'si'.and.cs.eq.'default') then
         goodoption=.true.
         dddn=0
      endif

c...form factors
      if (sisd.eq.'si'.and.(cs.eq.'default'.or.cs.eq.'W-S'.or.
     &     cs.eq.'Helm')) then
         goodoption=.true.
         ddffsi = 'Helm'
      endif
      if (sisd.eq.'si'.and.cs.eq.'exp') then
         goodoption=.true.
         ddffsi = 'exp'
      endif

      if (sisd.eq.'sd'.and.cs.eq.'default') then
         goodoption=.true.
         ddffsd = 'default'
      endif
      if (sisd.eq.'sd'.and.cs.eq.'Ge-Ressel') then
         goodoption=.true.
         ddffsd = 'Ge-Ressel'
      endif

c...invalid choice
      if (.not.goodoption) then
         write (*,*) 'dsddset: unrecognized options ',sisd,cs
         stop
      endif
      
      return
      end
