      subroutine dsddsigmaff(e,n,a,z,siff,sdff)
c_______________________________________________________________________
c  neutralino nucleus cross sections times form factors.
c  NOTE: the spin-dependent cross section is available only for a 
c        limited number of nuclei
c  common:
c    'dssusy.h' - file with susy common blocks
c  input:
c    e : real*8              : nuclear recoil energy in keV
c    n : integer             : number of nuclear species
c    a : n-dim integer array : atomic numbers
c    z : n-dim integer array : charge numbers
c  output:
c    siff : n-dim real*8 array : spin-independent cross
c           section times form factor
c    sdff : n-dim real*8 array : spin-dependent cross
c           section times form factor
c    units: cm^2
c  author: paolo gondolo (paolo@physics.utah.edu) 2004
c=======================================================================
      implicit none
      include 'dssusy.h'
      include 'dsprep.h'
      include 'dsddcom.h'
      include 'dshacom.h'

      integer n,a(n),z(n)
      real*8 e,siff(n),sdff(n)
      integer kx,i,aa,zz
      real*8 fermiGeV,gev2cm2,q,ff,
     &     mp,mn,mni,muxi,fkin,gps,gns,gpa,gna
      real*8 j,spp,snn,spn,s00,s11,s01
      parameter (fermiGeV = 1.d0/0.1973269602d0)
      parameter (gev2cm2 = (197.327053d-16)**2)
      parameter (mp=0.93827231d0)
      parameter (mn=0.931494013d0)
      real*8 etmp
      common /dsddffexp/ etmp
      
      call dsddgpgn(gps,gns,gpa,gna)

      kx = kn(kln)
      mx = mass(kx)

      do i=1,n
         aa=a(i)
         zz=z(i)
         mni = zz*mp+(aa-zz)*mn
         muxi = mni*mx/(mni+mx)
         fkin = gev2cm2*muxi**2/pi
         q = sqrt(mni*e*1.d-6)


c  SPIN-INDEPENDENT

         call dsddffsi(q,aa,zz,ff)
         siff(i) = ff*fkin*(zz*gps+(aa-zz)*gns)**2

c  SPIN-DEPENDENT
c

         call dsddffsd(q,aa,zz,s00,s01,s11,j)
         spp = s00+s11+s01
         snn = s00+s11-s01
         spn = 2.d0*(s00-s11)
         sdff(i) = gev2cm2*muxi**2/(2.d0*j+1.d0)*
     &        (gpa**2*spp+gna**2*snn+gpa*gna*spn)
         
      enddo

      return
      end
