***********************************************************************
*** dsntsundenscomp gives the number density of nucleons of atomic
*** number Z per cm^3
*** input: radius - in meters
***        itype: internal element number (def. in dsntsunread.f)
*** Author: joakim edsjo
*** Date: 2003-11-26
***********************************************************************

      real*8 function dsntsundenscomp(r,itype)
      implicit none
      real*8 r,n_a,dsntsundens,fraction,dsntsunmfrac,m_a
      integer itype
      parameter (n_a=6.022d23)    ! number per mol

      include 'dssun.h'

      if (itype.lt.1.or.itype.gt.16) then
        write(*,*) 'WARNING in dsntsundenscomp: illegal element type: ',
     &    itype
      endif

      m_a = sdma(itype)
      fraction=dsntsunmfrac(r,itype)

c...m_a is now in atomic units u which is what we want

      dsntsundenscomp=fraction*dsntsundens(r)/m_a*n_a ! number/cm^3

      return
      end
