      subroutine dsmodelsetup(unphys,hwarning)
c_______________________________________________________________________
c  set up global variables for the supersymmetric model routines.
c  If rate routines are going to be called afterwards, dsprep should
c  be called after this routine, like it is done in dssusy.
c  You should only call this routine directly yourself if you know
c  what you are doing. If you are the least unsure, call dssusy instead.
c  common:
c    'dssusy.h' - file with susy common blocks
c  uses sconst, sfesct, chasct, higsct,
c    neusct, vertx, hwidths.
c  author: paolo gondolo (gondolo@lpthe.jussieu.fr) 1994,1995
c=======================================================================
      implicit none
      include 'dssusy.h'
      include 'dsprep.h'


      integer i,unphys,hwarning
      real*8 aux,mscale,dsralph3,dsrmq

      integer j

c-----------------------------------------------------------------------

      if (tanbe.eq.0.0d0) then
         write (*,*)
     &'dsmodelsetup: susy parameters are not properly initialized'
         write (*,'(a,a)')
     &'        pls set tanbe,ma,mu,m2,m1,m3,mass2u,mass2q,mass2d,',
     &        'mass2l,mass2e,asoftu,asoftd,asofte'
         stop
      endif

      unphys=0
      mass(0)=1.d10

c------------------------------------------------------ global constants

      call dssuconst

c------------------------------------------ particle spectrum and mixing
      call dsspectrum(unphys,hwarning)
      if (unphys.ne.0.or.hwarning.ne.0) return

     
      mx=mass(kn(1))
      
c------------- reset running things, check that they are not used above

      mscale=2.d0*mass(lsp)
      alph3=dsralph3(mscale)
      g3stro=sqrt(4.d0*pi*alph3)

      aux = g2weak/dsqrt(2.d0)/mass(kw)
      yukawa(kqu(2))= aux*dsrmq(mscale,kc)/sinbe


c--------------- Yukawas at 2*mchi for relic density computations

      yukawa(ktau)=ylsp_tau
      yukawa(kb)=ylsp_b
      yukawa(kt)=ylsp_t

c-------------------------------------------------- some useful vertices

      call dsvertx

c--------------------------------------------------- and particle widths

     
c...Add Higgs widhts and QCD correction to them and to vertices
      call dshigwid

c...Widths changed 020613 by Joakim Edsjo
      width(kcha(1)) = 1.0d0
      width(kcha(2)) = 1.0d0
      width(kn(1)) = 1.0d0
      width(kn(2)) = 1.0d0
      width(kn(3)) = 1.0d0
      width(kn(4)) = 1.0d0

      do i=1,6
        width(ksl(i))=0.2d0
        width(ksnu(i))=0.2d0
        width(ksqu(i))=0.2d0
        width(ksqd(i))=0.2d0
      enddo

      end


