      subroutine dssuconst
c_______________________________________________________________________
c  useful constants
c  common:
c    'dssusy.h' - file with susy common blocks
c  author: paolo gondolo 1994-1999
c  modified: 031105 neutrino's yukawa fixed (pg)
c=======================================================================
      implicit none
      include 'dssusy.h'
      real*8 s12,s23,s13,c12,c13,c23,d13,aux
      complex*16 ed13
      integer i

      sinthw = sqrt(s2thw)
      costhw = sqrt(1.0d0-s2thw)
      g2weak=sqrt(4.0d0*pi*alphem/s2thw)
      gyweak=g2weak*sinthw/costhw
      g3stro=sqrt(4.d0*pi*alph3mz)

      s12 = ckms12
      s23 = ckms23
      s13 = ckms13
      d13 = ckmdelta
      c12 = sqrt(1.d0-s12**2)
      c13 = sqrt(1.d0-s13**2)
      c23 = sqrt(1.d0-s23**2)
      ed13 = dcmplx(cos(d13),sin(d13))
      ckm(1,1) = c12*c13
      ckm(1,2) = s12*c13
      ckm(1,3) = s13/ed13
      ckm(2,1) = -s12*c23-c12*s23*s13*ed13
      ckm(2,2) = c12*c23-s12*s23*s13*ed13
      ckm(2,3) = s23*c13
      ckm(3,1) = s12*s23-c12*c23*s13*ed13
      ckm(3,2) = -c12*s23-s12*c23*s13*ed13
      ckm(3,3) = c23*c13

      cosbe = 1.0d0 / sqrt(1.0d0+tanbe*tanbe)
      sinbe = tanbe * cosbe
      cos2be = 2.0*cosbe*cosbe-1.0d0
      sin2be = 2.0*sinbe*cosbe

      aux = g2weak/dsqrt(2.d0)/mass(kw)


c rr
      do i=1,3
         yukawa(knu(i)) = aux*runmass(knu(i))/sinbe
         yukawa(kl(i)) = aux*runmass(kl(i))/cosbe
         yukawa(kqu(i)) = aux*runmass(kqu(i))/sinbe
         yukawa(kqd(i)) = aux*runmass(kqd(i))/cosbe
      enddo    


c...Default Higgs trilinear couplings
      lam1 = 0.25d0*(g2weak**2+gyweak**2)
      lam2 = lam1
      lam3 = 0.25d0*(g2weak**2-gyweak**2)
      lam4 = -0.5d0*g2weak**2
      lam5 = 0.d0
      lam6 = 0.d0
      lam7 = 0.d0


      end
