c----------------------------------------------------------------------
c   Interface between DarkSUSY and HDECAY.
c   HDECAY is called and the results transferred to the DarkSUSY
c   common blocks. 
c   Modified by Roberto Ruiz to make it compatible with HDECAY v3.102 
c   while DarkSUSY current version employs HDECAY v2.0
c----------------------------------------------------------------------

      subroutine dshdecay(HIGGS, brr)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      include 'dssusy.h'
      logical first
      data first/.true./
      save first

      INTEGER HIGGS
      real*8 brr

c...Below are the HDECAY common blocks
      PARAMETER(K=6,NI=87,NSA=85,NSB=86,NLA=88,NLB=89,NHA=90,NHB=91,
     .          NHC=92,NAA=93,NAB=94,NCA=95,NCB=96,NRA=97,NRB=98,
     .          NSUSYL=81,NSUSYA=82,NSUSYH=83,NSUSYC=84,NPAR=80,
     .          NSUSYLA=79,NSUSYLB=78,NSUSYLC=77,NSUSYLD=76,NSUSYLE=75,
     .          NSUSYLF=59,NSUSYHF=58,
     .          NSUSYHA=74,NSUSYHB=73,NSUSYHC=72,NSUSYHD=71,NSUSYHE=70,
     .          NSUSYAA=69,NSUSYAB=68,NSUSYAC=67,NSUSYAD=66,NSUSYAE=65,
     .          NSUSYCA=64,NSUSYCB=63,NSUSYCC=62,NSUSYCD=61,NSUSYCE=60)
      DIMENSION GMN(4),XMN(4),GMC(2),GMST(2),GMSB(2),GMSL(2),
     .          GMSU(2),GMSD(2),GMSE(2),GMSN(2)
      DIMENSION HLBRSC(2,2),HLBRSN(4,4),HHBRSC(2,2),HHBRSN(4,4),
     .          HABRSC(2,2),HABRSN(4,4),HCBRSU(2,4),
     .          HHBRST(2,2),HHBRSB(2,2),HCBRSTB(2,2) 
      DIMENSION AC1(2,2),AC2(2,2),AC3(2,2),
     .          AN1(4,4),AN2(4,4),AN3(4,4),
     .          ACNL(2,4),ACNR(2,4)
      DIMENSION GLTT(2,2),GLBB(2,2),GHTT(2,2),GHBB(2,2),GCTB(2,2),
     .          GLEE(2,2),GHEE(2,2),GCEN(2,2)
      DIMENSION AGDL(4),AGDA(4),AGDH(4),AGDC(2)
      COMMON/MASSES_HDEC/AMS,AMC,AMB,AMT
      COMMON/STRANGE_HDEC/AMSB
      COMMON/PARAM_HDEC/GF,ALPH,AMTAU,AMMUON,AMZ,AMW
      COMMON/CKMPAR_HDEC/VUS,VCB,VUB
      COMMON/HMASS_HDEC/AMSM,AMA,AML,AMH,AMCH,AMAR
      COMMON/BREAK_HDEC/AMEL,AMER,AMSQ,AMUR,AMDR,AL,AU,AD,AMU,AM2
      COMMON/BREAKGLU_HDEC/AMGLU
      COMMON/SFER1ST_HDEC/AMQL1,AMUR1,AMDR1,AMEL1,AMER1
      COMMON/GLUINO_HDEC/AMGLUINO,XMSB1,XMSB2,STHB,CTHB,
     .              XLBB(2,2),XHBB(2,2),XABB(2,2),
     .              XMST1,XMST2,STHT,CTHT,
     .              XLTT(2,2),XHTT(2,2),XATT(2,2)
      COMMON/WZWDTH_HDEC/GAMC0,GAMT0,GAMT1,GAMW,GAMZ
      COMMON/COUP_HDEC/GAT,GAB,GLT,GLB,GHT,GHB,GZAH,GZAL,
     .            GHHH,GLLL,GHLL,GLHH,GHAA,GLAA,GLVV,GHVV,
     .            GLPM,GHPM,B,A
      COMMON/ALS_HDEC/XLAMBDA,AMC0,AMB0,AMT0,N0
      COMMON/FLAG_HDEC/IHIGGS,NNLO,IPOLE
      COMMON/MODEL_HDEC/IMODEL
      COMMON/ONSHELL_HDEC/IONSH,IONWZ,IOFSUSY
      COMMON/OLDFASH_HDEC/NFGG
      COMMON/WIDTHSM_HDEC/SMBRB,SMBRL,SMBRM,SMBRS,SMBRC,SMBRT,SMBRG,
     .               SMBRGA,SMBRZGA,SMBRW,SMBRZ,SMWDTH
      COMMON/WIDTHA_HDEC/ABRB,ABRL,ABRM,ABRS,ABRC,ABRT,ABRG,ABRGA,
     .              ABRZGA,ABRZ,AWDTH
      COMMON/WIDTHHL_HDEC/HLBRB,HLBRL,HLBRM,HLBRS,HLBRC,HLBRT,HLBRG,
     .               HLBRGA,HLBRZGA,HLBRW,HLBRZ,HLBRA,HLBRAZ,HLBRHW,
     .               HLWDTH
      COMMON/WIDTHHH_HDEC/HHBRB,HHBRL,HHBRM,HHBRS,HHBRC,HHBRT,HHBRG,
     .               HHBRGA,HHBRZGA,HHBRW,HHBRZ,HHBRH,HHBRA,HHBRAZ,
     .               HHBRHSW,HHWDTH
      COMMON/WIDTHHC_HDEC/HCBRB,HCBRL,HCBRM,HCBRBU,HCBRS,HCBRC,HCBRT,
     .               HCBRW,HCBRA,HCWDTH
      COMMON/WISUSY_HDEC/HLBRSC,HLBRSN,HHBRSC,HHBRSN,HABRSC,HABRSN,
     .              HCBRSU,HLBRCHT,HHBRCHT,HABRCHT,HLBRNET,HHBRNET,
     .              HABRNET,HCBRCNT,HLBRSL,HHBRSL,HCBRSL,HABRSL,HABRST,
     .              HABRSB,HHBRSQ,HHBRST,HHBRSB,HHBRSQT,HCBRSQ,HCBRSTB,
     .              HCBRSQT,HLBRSQ,HLBRSQT
      COMMON/WISFER_HDEC/BHLSLNL,BHLSLEL,BHLSLER,BHLSQUL,BHLSQUR,
     .              BHLSQDL,BHLSQDR,BHLST(2,2),BHLSB(2,2),BHLSTAU(2,2),
     .              BHHSLNL,BHHSLEL,BHHSLER,BHHSQUL,BHHSQUR,BHHSQDL,
     .              BHHSQDR,BHHST(2,2),BHHSB(2,2),BHHSTAU(2,2),
     .              BHASTAU,BHASB,BHAST,
     .              BHCSL00,BHCSL11,BHCSL21,BHCSQ,BHCSTB(2,2)
      COMMON/SMASS_HDEC/GMN,XMN,GMC,GMST,GMSB,GMSL,GMSU,GMSD,GMSE,GMSN 
      COMMON/GOLDST_HDEC/AXMPL,AXMGD,IGOLD
      COMMON/WIGOLD_HDEC/HLBRGD,HABRGD,HHBRGD,HCBRGD
      COMMON/FLAGS_HDEC/INDIDEC

      PI = 4*DATAN(1D0)

c...Set input values
      IHIGGS    = HIGGS  
      IMODEL   = 1

c...Set default values from DarkSUSY values
      TGBET    = tanbe
      ALSMZ    = alph3mz
      ams      = mass(ks) ! should be s-quark MS-bar mss at 1 GeV
      amc      = mass(kc)
      amb      = mass(kb)
      amt      = mass(kt)
      amtau    = mass(ktau)
      ammuon   = mass(kmu)
      alph     = 137.0359895D0   ! 1/alpha at Q=0
      GF       = 1.16639D-5      ! Fermi decay constant.
      GAMW     = width(kw)
      GAMZ     = width(kz)
      AMZ      = mass(kz)
      AMW      = mass(kw)
      VUS      = ckms12
      VCB      = ckms23
      RVUB     = ckms13/ckms23 ! VUB/VCB
   
      
c...HDECAY does not accept both mu and M2 negative (the chargino
c...routines in hdgaugino gets into an endless loop). Choose M2>0
c...and change signs of both mu and m2 when needed.
      if (m2.gt.0) then
        AMU      = mu
        AM2      = m2
      else
        AMU      = -mu
        AM2      = -m2
      endif
c...NOTE: The following values are taken from DarkSUSY. For MSSM
c...this is perfectly OK, but for mSUGRA it is doing things double
c...since HDECAY will recalculate things we already have. On the
c...other hand, the interface to HDECAY is kept simple.
      AMGLUINO = m3


      AMEL1    = sqrt(mass2l(1))
      AMER1    = sqrt(mass2e(1))
      AMQL1    = sqrt(mass2q(1))
      AMUR1    = sqrt(mass2u(1))
      AMDR1    = sqrt(mass2d(1))
      AMEL     = sqrt(mass2l(3))
      AMER     = sqrt(mass2e(3))
      AMSQ     = sqrt(mass2q(3))
      AMUR     = sqrt(mass2u(3))
      AMDR     = sqrt(mass2d(3))


      if(mass2l(1).lt.0.d0) AMEL1 = 0.d0
      if(mass2e(1).lt.0.d0) AMER1 = 0.d0
      if(mass2q(1).lt.0.d0) AMQL1 = 0.d0
      if(mass2u(1).lt.0.d0) AMUR1 = 0.d0
      if(mass2d(1).lt.0.d0) AMDR1 = 0.d0
      if(mass2l(3).lt.0.d0) AMEL = 0.d0
      if(mass2e(3).lt.0.d0) AMER = 0.d0
      if(mass2q(3).lt.0.d0) AMSQ = 0.d0
      if(mass2u(3).lt.0.d0) AMUR = 0.d0
      if(mass2d(3).lt.0.d0) AMDR = 0.d0

      AL       = asofte(3)
      AU       = asoftu(3)
      AD       = asoftd(3)

      B = DATAN(TGBET)
      AMGLU = AMGLUINO

      vub=rvub*vcb
      alph=1.d0/alph
      amsb=ams

      AMAR = mass(kh3)  ! mA mass

c...Set switches
      NNLO     = 1
      IONSH    = 1
      IONWZ    = 1
      IPOLE    = 0
      IOFSUSY  = 0 
      INDIDEC  = 0
      NFGG     = 5


C--CHECK NFGG
      IF(NFGG.GT.5.OR.NFGG.LT.3)THEN
       WRITE(6,*)'NF-GG NOT VALID. TAKING THE DEFAULT NF-GG = 3....'
       NFGG = 3
      ENDIF

      AMC0=AMC
      AMB0=AMB
      AMT0=AMT
      ACC=1.D-8
      NLOOP=2
      XLAMBDA=XITLA_HDEC(NLOOP,ALSMZ,ACC)
      N0=5

      CALL ALSINI_HDEC(ACC)

C--INITIALIZE COEFFICIENTS FOR POLYLOGARITHMS
      NBER = 18
      CALL BERNINI_HDEC(NBER)


      AMA = AMAR !Pseudoscalar mass

c...Now start calculating

      hdecwar = 0


      CALL SUSYCP_HDEC(TGBET)


      AMSM = AML !standard model Higgs mass set to the lightest MSSM


C
C **************************************************************

      CALL HDEC(TGBET)




      if(ihiggs.eq.1) then
       if(hlbrw.lt.1.d-10) then 
        brr = 1.d0
        hdecwar = 1
       else
        brr=hlbrb/hlbrw
       endif
      else if(ihiggs.eq.0) then
       if(smbrw.lt.1.d-10) then 
        brr = 1.d0
        hdecwar = 1
       else
        brr=smbrb/smbrw
       endif
      endif


c...Reset widths
      do i=1,19
        do j=1,4
          hdwidth(i,j)=0.0d0
        enddo
      enddo

c...H2 boson
      if (ihiggs.eq.1.or.ihiggs.eq.5) then
         mass(kh2)  = aml
         width(kh2) = hlwdth
         hdwidth(2,2)  = hlbrb  * hlwdth
         hdwidth(4,2)  = hlbrl  * hlwdth
         hdwidth(15,2) = hlbrm  * hlwdth
         hdwidth(16,2) = hlbrs  * hlwdth
         hdwidth(1,2)  = hlbrc  * hlwdth
         hdwidth(3,2)  = hlbrt  * hlwdth
         hdwidth(17,2) = hlbrg  * hlwdth
         hdwidth(18,2) = hlbrga * hlwdth
         hdwidth(19,2) = hlbrzga* hlwdth
         hdwidth(5,2)  = hlbrw  * hlwdth
         hdwidth(6,2)  = hlbrz  * hlwdth
      else
        mass(kh2)  = 0.0d0
        width(kh2) = 0.0d0
      endif


c...H1 boson
      if (ihiggs.eq.2.or.ihiggs.eq.5) then
        mass(kh1)  = amh
        width(kh1) = hhwdth
        hdwidth(2,1)  = hhbrb  * hhwdth
        hdwidth(4,1)  = hhbrl  * hhwdth
        hdwidth(15,1) = hhbrm  * hhwdth
        hdwidth(16,1) = hhbrs  * hhwdth
        hdwidth(1,1)  = hhbrc  * hhwdth
        hdwidth(3,1)  = hhbrt  * hhwdth
        hdwidth(17,1) = hhbrg  * hhwdth
        hdwidth(18,1) = hhbrga * hhwdth
        hdwidth(19,1) = hhbrzga* hhwdth
        hdwidth(5,1)  = hhbrw  * hhwdth
        hdwidth(6,1)  = hhbrz  * hhwdth
        hdwidth(8,1)  = hhbrh  * hhwdth
        hdwidth(9,1)  = hhbra  * hhwdth
        hdwidth(11,1) = hhbraz * hhwdth
        hdwidth(14,1) = hhbrhw * hhwdth
      else
        mass(kh1)  = 0.0d0
        width(kh1) = 0.0d0
      endif

c...H3 boson
      if (ihiggs.eq.3.or.ihiggs.eq.5) then
        mass(kh3)  = ama
        width(kh3) = awdth
        hdwidth(2,3)  = abrb  * awdth
        hdwidth(4,3)  = abrl  * awdth
        hdwidth(15,3) = abrm  * awdth
        hdwidth(16,3) = abrs  * awdth
        hdwidth(1,3)  = abrc  * awdth
        hdwidth(3,3)  = abrt  * awdth
        hdwidth(17,3) = abrg  * awdth
        hdwidth(18,3) = abrga * awdth
        hdwidth(19,3) = abrzga* awdth
        hdwidth(12,3) = abrz  * awdth
      else
        mass(kh3)  = 0.0d0
        width(kh3) = 0.0d0
      endif

c...H+ boson
      if (ihiggs.eq.4.or.ihiggs.eq.5) then
        mass(khc)  = amch
        width(khc) = hcwdth
        hdwidth(6,4)  = hcbrb * hcwdth
        hdwidth(12,4) = hcbrl * hcwdth
        hdwidth(11,4) = hcbrm * hcwdth
        hdwidth(2,4)  = hcbrs * hcwdth
        hdwidth(5,4)  = hcbrc * hcwdth
        hdwidth(9,4)  = hcbrt * hcwdth
        hdwidth(14,4) = hcbrw * hcwdth
        hdwidth(15,4) = hcbra * hcwdth
      else
        mass(khc)  = 0.0d0
        width(khc) = 0.0d0
      endif


      end

