* SetPara.F
* all parameters for the MSSM are initialized here
* this file is part of FeynHiggs
* last modified 12 May 06 th

#include "externals.h"


	subroutine FHSetPara(error, scalefactor,
     &    AlfasMZ_, MC_, MT_, MB_, MW_, MZ_,
     &    TB_, MA0_, MHp_, 
     &    M3SL_, M3SE_, M3SQ_, M3SU_, M3SD_,
     &    M2SL_, M2SE_, M2SQ_, M2SU_, M2SD_,
     &    M1SL_, M1SE_, M1SQ_, M1SU_, M1SD_,
     &    MUE_,
     &    Atau_, At_, Ab_, Amu_, Ac_, As_, Ae_, Au_, Ad_, 
     &    M_1_, M_2_, M_3_, 
     &    Qtau_, Qt_, Qb_)
	implicit none
	integer error
	double precision scalefactor
	double precision AlfasMZ_, MC_, MT_, MB_, MW_, MZ_
	double precision TB_, MA0_, MHp_
	double precision M3SL_, M3SE_, M3SQ_, M3SU_, M3SD_
	double precision M2SL_, M2SE_, M2SQ_, M2SU_, M2SD_
	double precision M1SL_, M1SE_, M1SQ_, M1SU_, M1SD_
	double complex MUE_, M_1_, M_2_, M_3_
	double complex At_, Ab_, Atau_, Ac_, As_, Amu_, Au_, Ad_, Ae_
	double precision Qtau_, Qt_, Qb_

#include "FH.h"

	call BeginPara(error, scalefactor, -1D0, AlfasMZ_, -1D0,
     &    MC_, MT_, MB_, MW_, MZ_, TB_, M_3_)

	call HiggsMasses(error, MA0_, MHp_, 0D0)

	call CharginoMasses(error, M_2_, MUE_)

	call NeutralinoMasses(error, M_1_)

#define SignSq(x) (x)*abs(x)

	call SfermionMasses(error, 3,
     &    SignSq(M3SL_), SignSq(M3SE_),
     &    SignSq(M3SQ_), SignSq(M3SU_), SignSq(M3SD_),
     &    Atau_, At_, Ab_,
     &    Qtau_, Qt_, Qb_)
	call SfermionMasses(error, 2,
     &    SignSq(M2SL_), SignSq(M2SE_),
     &    SignSq(M2SQ_), SignSq(M2SU_), SignSq(M2SD_),
     &    Amu_, Ac_, As_,
     &    0D0, 0D0, 0D0)
	call SfermionMasses(error, 1,
     &    SignSq(M1SL_), SignSq(M1SE_),
     &    SignSq(M1SQ_), SignSq(M1SU_), SignSq(M1SD_),
     &    Ae_, Au_, Ad_,
     &    0D0, 0D0, 0D0)

	call EndPara(error)
	end

