* se_A0Z.F
* this file is part of FeynHiggs
* generated 07 Nov 2006 18:06

#include "externals.h"


	double complex function se_A0Z(k2)
	implicit none
	double precision k2

#include "FH.h"

	double complex se_A0Z_mfv, se_A0Z_nmfv
	external se_A0Z_mfv, se_A0Z_nmfv

	if( nmfv .eq. 0 ) then
	  se_A0Z = se_A0Z_mfv(k2)
	else
	  se_A0Z = se_A0Z_nmfv(k2)
	endif

#ifdef DEBUG
	print *, 'k2 =', k2
	print *, 'se_A0Z =', se_A0Z
#endif
	end


************************************************************************


	double complex function se_A0Z_mfv(k2)
	implicit character (a-s,u-z)
	implicit double complex (t)
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer Cha1, Cha2, Gen1, Neu1, Neu2, Sfe1, Sfe2, g

	g = ieor(iand(mssmpart - 1, 2), 3)

	se_A0Z_mfv = 0

	do Gen1 = g, 3
        se_A0Z_mfv = se_A0Z_mfv + 
     -   (3*cI)/(8.D0*Pi)*(Alfa*B0(k2,Mf2(3,Gen1),Mf2(3,Gen1))*
     -       Mf2(3,Gen1))/(CW*MW*SW2*TB)
	enddo

	do Gen1 = g, 3
	do Sfe1 = 1, 2
	do Sfe2 = 1, 2
        se_A0Z_mfv = se_A0Z_mfv + 
     -   cI/(16.D0*Pi)*(Alfa*
     -       (B0(k2,MSf2(Sfe1,3,Gen1),MSf2(Sfe2,3,Gen1)) + 
     -         2*B1(k2,MSf2(Sfe1,3,Gen1),MSf2(Sfe2,3,Gen1)))*
     -       Mf(3,Gen1)*(-((Af(3,Gen1,Gen1) + TB*DCONJG(MUE))*
     -            USf(Sfe2,2,3,Gen1)*USfC(Sfe1,1,3,Gen1)) + 
     -         (MUE*TB + DCONJG(Af(3,Gen1,Gen1)))*
     -          USf(Sfe2,1,3,Gen1)*USfC(Sfe1,2,3,Gen1))*
     -       ((-3 + 4*SW2)*USf(Sfe1,1,3,Gen1)*
     -          USfC(Sfe2,1,3,Gen1) + 
     -         4*SW2*USf(Sfe1,2,3,Gen1)*USfC(Sfe2,2,3,Gen1)))/
     -     (CW*MW*SW2*TB)
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_A0Z_mfv =', se_A0Z_mfv
#endif

	if( mssmpart .eq. 1 ) return


	do Gen1 = g, 3
        se_A0Z_mfv = se_A0Z_mfv - 
     -   (3*cI)/(8.D0*Pi)*(Alfa*TB*B0(k2,Mf2(4,Gen1),Mf2(4,Gen1))*
     -       Mdy(Gen1,1)*Mf(4,Gen1))/(CW*MW*SW2)
	enddo

	do Gen1 = g, 3
	do Sfe1 = 1, 2
	do Sfe2 = 1, 2
        se_A0Z_mfv = se_A0Z_mfv + 
     -   cI/(16.D0*Pi)*(Alfa*
     -       (B0(k2,MSf2(Sfe1,4,Gen1),MSf2(Sfe2,4,Gen1)) + 
     -         2*B1(k2,MSf2(Sfe1,4,Gen1),MSf2(Sfe2,4,Gen1)))*
     -       Mdy(Gen1,1)*((TB*Af(4,Gen1,Gen1) + DCONJG(MUE))*
     -          USf(Sfe2,2,4,Gen1)*USfC(Sfe1,1,4,Gen1) - 
     -         (MUE + TB*DCONJG(Af(4,Gen1,Gen1)))*
     -          USf(Sfe2,1,4,Gen1)*USfC(Sfe1,2,4,Gen1))*
     -       ((-3 + 2*SW2)*USf(Sfe1,1,4,Gen1)*
     -          USfC(Sfe2,1,4,Gen1) + 
     -         2*SW2*USf(Sfe1,2,4,Gen1)*USfC(Sfe2,2,4,Gen1)))/
     -     (CW*MW*SW2)
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_A0Z_mfv =', se_A0Z_mfv
#endif

	if( mssmpart .eq. 2 ) return


	do Gen1 = 1, 3
        se_A0Z_mfv = se_A0Z_mfv - 
     -   cI/(8.D0*Pi)*(Alfa*TB*B0(k2,Mf2(2,Gen1),Mf2(2,Gen1))*
     -       Mf2(2,Gen1))/(CW*MW*SW2)
	enddo

	do Gen1 = 1, 3
	do Sfe1 = 1, 2
	do Sfe2 = 1, 2
        se_A0Z_mfv = se_A0Z_mfv + 
     -   cI/(16.D0*Pi)*(Alfa*
     -       (B0(k2,MSf2(Sfe1,2,Gen1),MSf2(Sfe2,2,Gen1)) + 
     -         2*B1(k2,MSf2(Sfe1,2,Gen1),MSf2(Sfe2,2,Gen1)))*
     -       Mf(2,Gen1)*((TB*Af(2,Gen1,Gen1) + DCONJG(MUE))*
     -          USf(Sfe2,2,2,Gen1)*USfC(Sfe1,1,2,Gen1) - 
     -         (MUE + TB*DCONJG(Af(2,Gen1,Gen1)))*
     -          USf(Sfe2,1,2,Gen1)*USfC(Sfe1,2,2,Gen1))*
     -       ((-1 + 2*SW2)*USf(Sfe1,1,2,Gen1)*
     -          USfC(Sfe2,1,2,Gen1) + 
     -         2*SW2*USf(Sfe1,2,2,Gen1)*USfC(Sfe2,2,2,Gen1)))/
     -     (CW*MW*SW2)
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_A0Z_mfv =', se_A0Z_mfv
#endif

	if( mssmpart .eq. 3 ) return

        se_A0Z_mfv = se_A0Z_mfv - 
     -   cI/(16.D0*Pi)*(Alfa*MW*
     -       (SAB*SBA*(S2B*B0(k2,Mh02,MZ2) + 
     -            2*S2B*B1(k2,Mh02,MZ2)) + 
     -         C2B*(CBA*SAB*
     -             (B0(k2,MA02,Mh02) + 2*B1(k2,Mh02,MA02)) + 
     -            CAB*SBA*(B0(k2,MA02,MHH2) + 2*B1(k2,MHH2,MA02)))+
     -           CBA*(CAB*S2B*
     -             (-B0(k2,MHH2,MZ2) - 2*B1(k2,MHH2,MZ2)) + 
     -            SBA*(2*B0(k2,Mh02,MZ2) - 2*B0(k2,MHH2,MZ2) - 
     -               2*B1(k2,Mh02,MZ2) + 2*B1(k2,MHH2,MZ2)))))/
     -     (CW*CW2*SW2)

	do Cha1 = 1, 2
	do Cha2 = 1, 2
        tmp1 = SW2*Delta(Cha1,Cha2) - 
     -   1/2.D0*(UCha(Cha1,2)*UChaC(Cha2,2)) - 
     -   UCha(Cha1,1)*UChaC(Cha2,1)
        tmp2 = SB*UCha(Cha2,2)*VCha(Cha1,1) + 
     -   CB*UCha(Cha2,1)*VCha(Cha1,2)
        tmp3 = SW2*Delta(Cha1,Cha2) - 
     -   1/2.D0*(VCha(Cha2,2)*VChaC(Cha1,2)) - 
     -   VCha(Cha2,1)*VChaC(Cha1,1)
        tmp4 = SB*UChaC(Cha1,2)*VChaC(Cha2,1) + 
     -   CB*UChaC(Cha1,1)*VChaC(Cha2,2)
        se_A0Z_mfv = se_A0Z_mfv - 
     -   cI/(2.D0*Pi)*(Alfa*((tmp1*tmp2 - tmp3*tmp4)*
     -          B0(k2,MCha2(Cha1),MCha2(Cha2))*MCha(Cha1) - 
     -         B1(k2,MCha2(Cha1),MCha2(Cha2))*
     -          (tmp3*tmp4*MCha(Cha1) - tmp2*tmp3*MCha(Cha2) + 
     -            tmp1*(-(tmp2*MCha(Cha1)) + tmp4*MCha(Cha2)))))/
     -     (CW*SW2*Sqrt(2.D0))
	enddo
	enddo

	do Neu1 = 1, 4
	do Neu2 = 1, 4
	tmp5 = SW*ZNeu(Neu1,1) - CW*ZNeu(Neu1,2)
	tmp6 = SW*ZNeu(Neu2,1) - CW*ZNeu(Neu2,2)
	tmp7 = CB*(-(SW*ZNeu(Neu2,1)) + CW*ZNeu(Neu2,2))
	tmp8 = SB*ZNeu(Neu2,3) - CB*ZNeu(Neu2,4)
	tmp9 = SW*ZNeuC(Neu1,1) - CW*ZNeuC(Neu1,2)
	tmp10 = ZNeu(Neu2,3)*ZNeuC(Neu1,3) - ZNeu(Neu2,4)*ZNeuC(Neu1,4)
	tmp11 = SW*ZNeuC(Neu2,1) - CW*ZNeuC(Neu2,2)
	tmp12 = CB*(-(SW*ZNeuC(Neu2,1)) + CW*ZNeuC(Neu2,2))
	tmp13 = SB*ZNeuC(Neu2,3) - CB*ZNeuC(Neu2,4)
        tmp14 = -(ZNeu(Neu1,3)*ZNeuC(Neu2,3)) + 
     -   ZNeu(Neu1,4)*ZNeuC(Neu2,4)
        se_A0Z_mfv = se_A0Z_mfv + 
     -   cI/(16.D0*Pi)*(Alfa*
     -       (-(B0(k2,MNeu2(Neu1),MNeu2(Neu2))*MNeu(Neu1)*
     -            (tmp14*(tmp5*tmp8 + SB*tmp6*ZNeu(Neu1,3) + 
     -                 tmp7*ZNeu(Neu1,4)) - 
     -              tmp10*(tmp13*tmp9 + SB*tmp11*ZNeuC(Neu1,3) + 
     -                 tmp12*ZNeuC(Neu1,4)))) + 
     -         B1(k2,MNeu2(Neu1),MNeu2(Neu2))*
     -          (tmp10*(-(MNeu(Neu2)*
     -                  (tmp5*tmp8 + SB*tmp6*ZNeu(Neu1,3) + 
     -                    tmp7*ZNeu(Neu1,4))) + 
     -               MNeu(Neu1)*
     -                (tmp13*tmp9 + SB*tmp11*ZNeuC(Neu1,3) + 
     -                  tmp12*ZNeuC(Neu1,4))) + 
     -            tmp14*(-(MNeu(Neu1)*
     -                  (tmp5*tmp8 + SB*tmp6*ZNeu(Neu1,3) + 
     -                    tmp7*ZNeu(Neu1,4))) + 
     -               MNeu(Neu2)*
     -                (tmp13*tmp9 + SB*tmp11*ZNeuC(Neu1,3) + 
     -                  tmp12*ZNeuC(Neu1,4))))))/(CW2*SW2)
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_A0Z_mfv =', se_A0Z_mfv
#endif

	end


************************************************************************


	double complex function se_A0Z_nmfv(k2)
	implicit character (a-s,u-z)
	implicit double complex (t)
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer All1, All2, Cha1, Cha2, Gen1, Ind1, Ind2, Ind3, Neu1
	integer Neu2, Sfe1, Sfe2, g

	g = ieor(iand(mssmpart - 1, 2), 3)

	se_A0Z_nmfv = 0

	do Gen1 = g, 3
        se_A0Z_nmfv = se_A0Z_nmfv + 
     -   (3*cI)/(8.D0*Pi)*(Alfa*B0(k2,Mf2(3,Gen1),Mf2(3,Gen1))*
     -       Mf2(3,Gen1))/(CW*MW*SW2*TB)
	enddo

	do All1 = g, 6, g
	do All2 = g, 6, g
	do Ind1 = g, 3
	do Ind2 = g, 3
	do Ind3 = g, 3
        se_A0Z_nmfv = se_A0Z_nmfv + 
     -   cI/(16.D0*Pi)*(Alfa*
     -       (B0(k2,MASf2(All1,3),MASf2(All2,3)) + 
     -         2*B1(k2,MASf2(All1,3),MASf2(All2,3)))*
     -       (-((Af(3,Ind2,Ind3) + 
     -              TB*DCONJG(MUE)*Delta(Ind2,Ind3))*Mf(3,Ind2)*
     -            UASf(All2,3 + Ind3,3)*UASfC(All1,Ind2,3)) + 
     -         (MUE*TB*Delta(Ind2,Ind3)*Mf(3,Ind2) + 
     -            DCONJG(Af(3,Ind3,Ind2))*Mf(3,Ind3))*
     -          UASf(All2,Ind3,3)*UASfC(All1,3 + Ind2,3))*
     -       ((-3 + 4*SW2)*UASf(All1,Ind1,3)*UASfC(All2,Ind1,3) + 
     -         4*SW2*UASf(All1,3 + Ind1,3)*UASfC(All2,3 + Ind1,3)))
     -      /(CW*MW*SW2*TB)
	enddo
	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_A0Z_nmfv =', se_A0Z_nmfv
#endif

	if( mssmpart .eq. 1 ) return


	do Gen1 = g, 3
        se_A0Z_nmfv = se_A0Z_nmfv - 
     -   (3*cI)/(8.D0*Pi)*(Alfa*TB*B0(k2,Mf2(4,Gen1),Mf2(4,Gen1))*
     -       Mdy(Gen1,1)*Mf(4,Gen1))/(CW*MW*SW2)
	enddo

	do All1 = g, 6, g
	do All2 = g, 6, g
	do Ind1 = g, 3
	do Ind2 = g, 3
	do Ind3 = g, 3
        se_A0Z_nmfv = se_A0Z_nmfv + 
     -   cI/(16.D0*Pi)*(Alfa*
     -       (B0(k2,MASf2(All1,4),MASf2(All2,4)) + 
     -         2*B1(k2,MASf2(All1,4),MASf2(All2,4)))*
     -       ((TB*Af(4,Ind2,Ind3) + DCONJG(MUE)*Delta(Ind2,Ind3))*
     -          Mdy(Ind2,1)*UASf(All2,3 + Ind3,4)*
     -          UASfC(All1,Ind2,4) - 
     -         (MUE*Delta(Ind2,Ind3)*Mdy(Ind2,1) + 
     -            TB*DCONJG(Af(4,Ind3,Ind2))*Mdy(Ind3,1))*
     -          UASf(All2,Ind3,4)*UASfC(All1,3 + Ind2,4))*
     -       ((-3 + 2*SW2)*UASf(All1,Ind1,4)*UASfC(All2,Ind1,4) + 
     -         2*SW2*UASf(All1,3 + Ind1,4)*UASfC(All2,3 + Ind1,4)))
     -      /(CW*MW*SW2)
	enddo
	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_A0Z_nmfv =', se_A0Z_nmfv
#endif

	if( mssmpart .eq. 2 ) return


	do Gen1 = 1, 3
        se_A0Z_nmfv = se_A0Z_nmfv - 
     -   cI/(8.D0*Pi)*(Alfa*TB*B0(k2,Mf2(2,Gen1),Mf2(2,Gen1))*
     -       Mf2(2,Gen1))/(CW*MW*SW2)
	enddo

	do Gen1 = 1, 3
	do Sfe1 = 1, 2
	do Sfe2 = 1, 2
        se_A0Z_nmfv = se_A0Z_nmfv + 
     -   cI/(16.D0*Pi)*(Alfa*
     -       (B0(k2,MSf2(Sfe1,2,Gen1),MSf2(Sfe2,2,Gen1)) + 
     -         2*B1(k2,MSf2(Sfe1,2,Gen1),MSf2(Sfe2,2,Gen1)))*
     -       Mf(2,Gen1)*((TB*Af(2,Gen1,Gen1) + DCONJG(MUE))*
     -          USf(Sfe2,2,2,Gen1)*USfC(Sfe1,1,2,Gen1) - 
     -         (MUE + TB*DCONJG(Af(2,Gen1,Gen1)))*
     -          USf(Sfe2,1,2,Gen1)*USfC(Sfe1,2,2,Gen1))*
     -       ((-1 + 2*SW2)*USf(Sfe1,1,2,Gen1)*
     -          USfC(Sfe2,1,2,Gen1) + 
     -         2*SW2*USf(Sfe1,2,2,Gen1)*USfC(Sfe2,2,2,Gen1)))/
     -     (CW*MW*SW2)
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_A0Z_nmfv =', se_A0Z_nmfv
#endif

	if( mssmpart .eq. 3 ) return

        se_A0Z_nmfv = se_A0Z_nmfv - 
     -   cI/(16.D0*Pi)*(Alfa*MW*
     -       (SAB*SBA*(S2B*B0(k2,Mh02,MZ2) + 
     -            2*S2B*B1(k2,Mh02,MZ2)) + 
     -         C2B*(CBA*SAB*
     -             (B0(k2,MA02,Mh02) + 2*B1(k2,Mh02,MA02)) + 
     -            CAB*SBA*(B0(k2,MA02,MHH2) + 2*B1(k2,MHH2,MA02)))+
     -           CBA*(CAB*S2B*
     -             (-B0(k2,MHH2,MZ2) - 2*B1(k2,MHH2,MZ2)) + 
     -            SBA*(2*B0(k2,Mh02,MZ2) - 2*B0(k2,MHH2,MZ2) - 
     -               2*B1(k2,Mh02,MZ2) + 2*B1(k2,MHH2,MZ2)))))/
     -     (CW*CW2*SW2)

	do Cha1 = 1, 2
	do Cha2 = 1, 2
        tmp1 = SW2*Delta(Cha1,Cha2) - 
     -   1/2.D0*(UCha(Cha1,2)*UChaC(Cha2,2)) - 
     -   UCha(Cha1,1)*UChaC(Cha2,1)
        tmp2 = SB*UCha(Cha2,2)*VCha(Cha1,1) + 
     -   CB*UCha(Cha2,1)*VCha(Cha1,2)
        tmp3 = SW2*Delta(Cha1,Cha2) - 
     -   1/2.D0*(VCha(Cha2,2)*VChaC(Cha1,2)) - 
     -   VCha(Cha2,1)*VChaC(Cha1,1)
        tmp4 = SB*UChaC(Cha1,2)*VChaC(Cha2,1) + 
     -   CB*UChaC(Cha1,1)*VChaC(Cha2,2)
        se_A0Z_nmfv = se_A0Z_nmfv - 
     -   cI/(2.D0*Pi)*(Alfa*((tmp1*tmp2 - tmp3*tmp4)*
     -          B0(k2,MCha2(Cha1),MCha2(Cha2))*MCha(Cha1) - 
     -         B1(k2,MCha2(Cha1),MCha2(Cha2))*
     -          (tmp3*tmp4*MCha(Cha1) - tmp2*tmp3*MCha(Cha2) + 
     -            tmp1*(-(tmp2*MCha(Cha1)) + tmp4*MCha(Cha2)))))/
     -     (CW*SW2*Sqrt(2.D0))
	enddo
	enddo

	do Neu1 = 1, 4
	do Neu2 = 1, 4
	tmp5 = SW*ZNeu(Neu1,1) - CW*ZNeu(Neu1,2)
	tmp6 = SW*ZNeu(Neu2,1) - CW*ZNeu(Neu2,2)
	tmp7 = CB*(-(SW*ZNeu(Neu2,1)) + CW*ZNeu(Neu2,2))
	tmp8 = SB*ZNeu(Neu2,3) - CB*ZNeu(Neu2,4)
	tmp9 = SW*ZNeuC(Neu1,1) - CW*ZNeuC(Neu1,2)
	tmp10 = ZNeu(Neu2,3)*ZNeuC(Neu1,3) - ZNeu(Neu2,4)*ZNeuC(Neu1,4)
	tmp11 = SW*ZNeuC(Neu2,1) - CW*ZNeuC(Neu2,2)
	tmp12 = CB*(-(SW*ZNeuC(Neu2,1)) + CW*ZNeuC(Neu2,2))
	tmp13 = SB*ZNeuC(Neu2,3) - CB*ZNeuC(Neu2,4)
        tmp14 = -(ZNeu(Neu1,3)*ZNeuC(Neu2,3)) + 
     -   ZNeu(Neu1,4)*ZNeuC(Neu2,4)
        se_A0Z_nmfv = se_A0Z_nmfv + 
     -   cI/(16.D0*Pi)*(Alfa*
     -       (-(B0(k2,MNeu2(Neu1),MNeu2(Neu2))*MNeu(Neu1)*
     -            (tmp14*(tmp5*tmp8 + SB*tmp6*ZNeu(Neu1,3) + 
     -                 tmp7*ZNeu(Neu1,4)) - 
     -              tmp10*(tmp13*tmp9 + SB*tmp11*ZNeuC(Neu1,3) + 
     -                 tmp12*ZNeuC(Neu1,4)))) + 
     -         B1(k2,MNeu2(Neu1),MNeu2(Neu2))*
     -          (tmp10*(-(MNeu(Neu2)*
     -                  (tmp5*tmp8 + SB*tmp6*ZNeu(Neu1,3) + 
     -                    tmp7*ZNeu(Neu1,4))) + 
     -               MNeu(Neu1)*
     -                (tmp13*tmp9 + SB*tmp11*ZNeuC(Neu1,3) + 
     -                  tmp12*ZNeuC(Neu1,4))) + 
     -            tmp14*(-(MNeu(Neu1)*
     -                  (tmp5*tmp8 + SB*tmp6*ZNeu(Neu1,3) + 
     -                    tmp7*ZNeu(Neu1,4))) + 
     -               MNeu(Neu2)*
     -                (tmp13*tmp9 + SB*tmp11*ZNeuC(Neu1,3) + 
     -                  tmp12*ZNeuC(Neu1,4))))))/(CW2*SW2)
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_A0Z_nmfv =', se_A0Z_nmfv
#endif

	end

