* se_ZZ.F
* this file is part of FeynHiggs
* generated 07 Nov 2006 18:06

#include "externals.h"


	double complex function se_ZZ(k2)
	implicit none
	double precision k2

#include "FH.h"

	double complex se_ZZ_mfv, se_ZZ_nmfv
	external se_ZZ_mfv, se_ZZ_nmfv

	if( nmfv .eq. 0 ) then
	  se_ZZ = se_ZZ_mfv(k2)
	else
	  se_ZZ = se_ZZ_nmfv(k2)
	endif

#ifdef DEBUG
	print *, 'k2 =', k2
	print *, 'se_ZZ =', se_ZZ
#endif
	end


************************************************************************


	double complex function se_ZZ_mfv(k2)
	implicit character (a-s,u-z)
	implicit double complex (t)
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer Cha1, Cha2, Gen1, Neu1, Neu2, Sfe1, Sfe2, g

	g = ieor(iand(mssmpart - 1, 2), 3)

	se_ZZ_mfv = 0

	do Gen1 = g, 3
        se_ZZ_mfv = se_ZZ_mfv - 
     -   1/(8.D0*Pi)*(Alfa*(8*SW2*
     -          (((A0(Mf2(3,Gen1)) + 
     -                 k2*B1(k2,Mf2(3,Gen1),Mf2(3,Gen1)))*
     -               (3/8.D0 + SW2*(-1 + 4/3.D0*SW2)))/SW2 + 
     -            (B00(k2,Mf2(3,Gen1),Mf2(3,Gen1))*
     -               (-3/4.D0 + SW2*(2 - 8/3.D0*SW2)))/SW2) + 
     -         3*B0(k2,Mf2(3,Gen1),Mf2(3,Gen1))*Mf2(3,Gen1)))/
     -     (CW2*SW2)
	enddo

	do Gen1 = g, 3
	do Sfe1 = 1, 2
        se_ZZ_mfv = se_ZZ_mfv + 
     -   1/(24.D0*Pi)*(Alfa*A0(MSf2(Sfe1,3,Gen1))*
     -       ((3 - 4*SW2)**2*USf(Sfe1,1,3,Gen1)*
     -          USfC(Sfe1,1,3,Gen1) + 
     -         16*SW2**2*USf(Sfe1,2,3,Gen1)*USfC(Sfe1,2,3,Gen1)))/
     -     (CW2*SW2)
	enddo
	enddo

	do Gen1 = g, 3
	do Sfe1 = 1, 2
	do Sfe2 = 1, 2
        se_ZZ_mfv = se_ZZ_mfv - 
     -   1/(12.D0*Pi)*(Alfa*B00(k2,MSf2(Sfe1,3,Gen1),
     -        MSf2(Sfe2,3,Gen1))*
     -       ((-3 + 4*SW2)*USf(Sfe2,1,3,Gen1)*
     -          USfC(Sfe1,1,3,Gen1) + 
     -         4*SW2*USf(Sfe2,2,3,Gen1)*USfC(Sfe1,2,3,Gen1))*
     -       ((-3 + 4*SW2)*USf(Sfe1,1,3,Gen1)*
     -          USfC(Sfe2,1,3,Gen1) + 
     -         4*SW2*USf(Sfe1,2,3,Gen1)*USfC(Sfe2,2,3,Gen1)))/
     -     (CW2*SW2)
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_ZZ_mfv =', se_ZZ_mfv
#endif

	if( mssmpart .eq. 1 ) return


	do Gen1 = g, 3
        se_ZZ_mfv = se_ZZ_mfv - 
     -   1/(24.D0*Pi)*(Alfa*((9 + SW2*(-12 + 8*SW2))*
     -          (A0(Mf2(4,Gen1)) + 
     -            k2*B1(k2,Mf2(4,Gen1),Mf2(4,Gen1))) + 
     -         24*B00(k2,Mf2(4,Gen1),Mf2(4,Gen1))*
     -          (-3/4.D0 + SW2*(1 - 2/3.D0*SW2)) + 
     -         9*B0(k2,Mf2(4,Gen1),Mf2(4,Gen1))*Mf2(4,Gen1)))/
     -     (CW2*SW2)
	enddo

	do Gen1 = g, 3
	do Sfe1 = 1, 2
        se_ZZ_mfv = se_ZZ_mfv + 
     -   1/(24.D0*Pi)*(Alfa*A0(MSf2(Sfe1,4,Gen1))*
     -       ((3 - 2*SW2)**2*USf(Sfe1,1,4,Gen1)*
     -          USfC(Sfe1,1,4,Gen1) + 
     -         4*SW2**2*USf(Sfe1,2,4,Gen1)*USfC(Sfe1,2,4,Gen1)))/
     -     (CW2*SW2)
	enddo
	enddo

	do Gen1 = g, 3
	do Sfe1 = 1, 2
	do Sfe2 = 1, 2
        se_ZZ_mfv = se_ZZ_mfv - 
     -   1/(12.D0*Pi)*(Alfa*B00(k2,MSf2(Sfe1,4,Gen1),
     -        MSf2(Sfe2,4,Gen1))*
     -       ((-3 + 2*SW2)*USf(Sfe2,1,4,Gen1)*
     -          USfC(Sfe1,1,4,Gen1) + 
     -         2*SW2*USf(Sfe2,2,4,Gen1)*USfC(Sfe1,2,4,Gen1))*
     -       ((-3 + 2*SW2)*USf(Sfe1,1,4,Gen1)*
     -          USfC(Sfe2,1,4,Gen1) + 
     -         2*SW2*USf(Sfe1,2,4,Gen1)*USfC(Sfe2,2,4,Gen1)))/
     -     (CW2*SW2)
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_ZZ_mfv =', se_ZZ_mfv
#endif

	if( mssmpart .eq. 2 ) return


	do Gen1 = 1, 3
        se_ZZ_mfv = se_ZZ_mfv - 
     -   1/(8.D0*Pi)*(Alfa*(-A0(MSf2(1,1,Gen1)) - 2*B00(k2,0.D0,0.D0) + 
     -         8*(-1/4.D0 + (1 - 2*SW2)*SW2)*
     -          B00(k2,Mf2(2,Gen1),Mf2(2,Gen1)) + 
     -         2*B00(k2,MSf2(1,1,Gen1),MSf2(1,1,Gen1)) + 
     -         k2*B1(k2,0.D0,0.D0) + 
     -         (1 + SW2*(-4 + 8*SW2))*
     -          (A0(Mf2(2,Gen1)) + 
     -            k2*B1(k2,Mf2(2,Gen1),Mf2(2,Gen1))) + 
     -         B0(k2,Mf2(2,Gen1),Mf2(2,Gen1))*Mf2(2,Gen1)))/
     -     (CW2*SW2)
	enddo

	do Gen1 = 1, 3
	do Sfe1 = 1, 2
        se_ZZ_mfv = se_ZZ_mfv + 
     -   1/(8.D0*Pi)*(Alfa*A0(MSf2(Sfe1,2,Gen1))*
     -       ((1 - 2*SW2)**2*USf(Sfe1,1,2,Gen1)*
     -          USfC(Sfe1,1,2,Gen1) + 
     -         4*SW2**2*USf(Sfe1,2,2,Gen1)*USfC(Sfe1,2,2,Gen1)))/
     -     (CW2*SW2)
	enddo
	enddo

	do Gen1 = 1, 3
	do Sfe1 = 1, 2
	do Sfe2 = 1, 2
        se_ZZ_mfv = se_ZZ_mfv - 
     -   1/(4.D0*Pi)*(Alfa*B00(k2,MSf2(Sfe1,2,Gen1),
     -        MSf2(Sfe2,2,Gen1))*
     -       ((-1 + 2*SW2)*USf(Sfe2,1,2,Gen1)*
     -          USfC(Sfe1,1,2,Gen1) + 
     -         2*SW2*USf(Sfe2,2,2,Gen1)*USfC(Sfe1,2,2,Gen1))*
     -       ((-1 + 2*SW2)*USf(Sfe1,1,2,Gen1)*
     -          USfC(Sfe2,1,2,Gen1) + 
     -         2*SW2*USf(Sfe1,2,2,Gen1)*USfC(Sfe2,2,2,Gen1)))/
     -     (CW2*SW2)
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_ZZ_mfv =', se_ZZ_mfv
#endif

	if( mssmpart .eq. 3 ) return

        se_ZZ_mfv = se_ZZ_mfv - 
     -   1/(16.D0*Pi)*(Alfa*(-4*MW2*
     -          (SBA**2*B0(k2,Mh02,MZ2) + CBA**2*B0(k2,MHH2,MZ2))+
     -           CW2*(-A0(MA02) - A0(Mh02) - A0(MHH2) - A0(MZ2) + 
     -            4*SBA**2*
     -             (B00(k2,Mh02,MZ2) + B00(k2,MHH2,MA02)) + 
     -            4*CBA**2*
     -             (B00(k2,Mh02,MA02) + B00(k2,MHH2,MZ2)) - 
     -            2*((CW2*(9*CW2 - 2*SW2) + SW2**2)*A0(MW2) + 
     -               2*(CW2**2*(-5*k2 - 2*MW2) + 2*MW2*SW2**2)*
     -                B0(k2,MW2,MW2) + 
     -               (CW2 - SW2)**2*
     -                (A0(MHp2) - 2*B00(k2,MHp2,MHp2))) + 
     -            4*CW2*((SW2*(CW2*(-2 + (9*CW2)/SW2) + SW2)*
     -                  B00(k2,MW2,MW2))/CW2 + 
     -               2*CW2*k2*B1(k2,MW2,MW2)))))/(CW2**2*SW2)

	do Cha1 = 1, 2
	do Cha2 = 1, 2
        tmp1 = SW2*Delta(Cha1,Cha2) - 
     -   1/2.D0*(UCha(Cha2,2)*UChaC(Cha1,2)) - 
     -   UCha(Cha2,1)*UChaC(Cha1,1)
        tmp2 = SW2*Delta(Cha1,Cha2) - 
     -   1/2.D0*(UCha(Cha1,2)*UChaC(Cha2,2)) - 
     -   UCha(Cha1,1)*UChaC(Cha2,1)
        tmp3 = SW2*Delta(Cha1,Cha2) - 
     -   1/2.D0*(VCha(Cha2,2)*VChaC(Cha1,2)) - 
     -   VCha(Cha2,1)*VChaC(Cha1,1)
        tmp4 = SW2*Delta(Cha1,Cha2) - 
     -   1/2.D0*(VCha(Cha1,2)*VChaC(Cha2,2)) - 
     -   VCha(Cha1,1)*VChaC(Cha2,1)
        se_ZZ_mfv = se_ZZ_mfv + 
     -   1/(2.D0*Pi)*(-(Alfa*(tmp1*tmp2 + tmp3*tmp4)*
     -          (A0(MCha2(Cha2)) - 
     -            2*B00(k2,MCha2(Cha1),MCha2(Cha2)) + 
     -            k2*B1(k2,MCha2(Cha1),MCha2(Cha2)))) + 
     -       Alfa*B0(k2,MCha2(Cha1),MCha2(Cha2))*
     -        (tmp2*tmp4*MCha(Cha1)*MCha(Cha2) - 
     -          tmp3*tmp4*MCha2(Cha1) + 
     -          tmp1*(tmp3*MCha(Cha1)*MCha(Cha2) - 
     -             tmp2*MCha2(Cha1))))/(CW2*SW2)
	enddo
	enddo

	do Neu1 = 1, 4
	do Neu2 = 1, 4
	tmp5 = ZNeu(Neu2,3)*ZNeuC(Neu1,3) - ZNeu(Neu2,4)*ZNeuC(Neu1,4)
	tmp6 = ZNeu(Neu1,3)*ZNeuC(Neu2,3) - ZNeu(Neu1,4)*ZNeuC(Neu2,4)
        se_ZZ_mfv = se_ZZ_mfv + 
     -   1/(16.D0*Pi)*(Alfa*(4*tmp5*tmp6*
     -          B00(k2,MNeu2(Neu1),MNeu2(Neu2)) - 
     -         B0(k2,MNeu2(Neu1),MNeu2(Neu2))*
     -          (tmp6**2*MNeu(Neu1)*MNeu(Neu2) + 
     -            tmp5*(tmp5*MNeu(Neu1)*MNeu(Neu2) + 
     -               2*tmp6*MNeu2(Neu1))) + 
     -         2*tmp5*(A0(MNeu2(Neu2)) + 
     -            k2*B1(k2,MNeu2(Neu1),MNeu2(Neu2)))*
     -          (-(ZNeu(Neu1,3)*ZNeuC(Neu2,3)) + 
     -            ZNeu(Neu1,4)*ZNeuC(Neu2,4))))/(CW2*SW2)
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_ZZ_mfv =', se_ZZ_mfv
#endif

	end


************************************************************************


	double complex function se_ZZ_nmfv(k2)
	implicit character (a-s,u-z)
	implicit double complex (t)
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer All1, All2, Cha1, Cha2, Gen1, Ind1, Ind2, Neu1, Neu2
	integer Sfe1, Sfe2, g

	g = ieor(iand(mssmpart - 1, 2), 3)

	se_ZZ_nmfv = 0

	do Gen1 = g, 3
        se_ZZ_nmfv = se_ZZ_nmfv - 
     -   1/(8.D0*Pi)*(Alfa*(8*SW2*
     -          (((A0(Mf2(3,Gen1)) + 
     -                 k2*B1(k2,Mf2(3,Gen1),Mf2(3,Gen1)))*
     -               (3/8.D0 + SW2*(-1 + 4/3.D0*SW2)))/SW2 + 
     -            (B00(k2,Mf2(3,Gen1),Mf2(3,Gen1))*
     -               (-3/4.D0 + SW2*(2 - 8/3.D0*SW2)))/SW2) + 
     -         3*B0(k2,Mf2(3,Gen1),Mf2(3,Gen1))*Mf2(3,Gen1)))/
     -     (CW2*SW2)
	enddo

	do All1 = g, 6, g
	do Ind1 = g, 3
        se_ZZ_nmfv = se_ZZ_nmfv + 
     -   1/(24.D0*Pi)*(Alfa*A0(MASf2(All1,3))*
     -       ((3 - 4*SW2)**2*UASf(All1,Ind1,3)*
     -          UASfC(All1,Ind1,3) + 
     -         16*SW2**2*UASf(All1,3 + Ind1,3)*
     -          UASfC(All1,3 + Ind1,3)))/(CW2*SW2)
	enddo
	enddo

	do All1 = g, 6, g
	do All2 = g, 6, g
	do Ind1 = g, 3
	do Ind2 = g, 3
        se_ZZ_nmfv = se_ZZ_nmfv - 
     -   1/(12.D0*Pi)*(Alfa*B00(k2,MASf2(All1,3),MASf2(All2,3))*
     -       ((-3 + 4*SW2)*UASf(All2,Ind1,3)*UASfC(All1,Ind1,3) + 
     -         4*SW2*UASf(All2,3 + Ind1,3)*UASfC(All1,3 + Ind1,3))*
     -       ((-3 + 4*SW2)*UASf(All1,Ind2,3)*UASfC(All2,Ind2,3) + 
     -         4*SW2*UASf(All1,3 + Ind2,3)*UASfC(All2,3 + Ind2,3)))
     -      /(CW2*SW2)
	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_ZZ_nmfv =', se_ZZ_nmfv
#endif

	if( mssmpart .eq. 1 ) return


	do Gen1 = g, 3
        se_ZZ_nmfv = se_ZZ_nmfv - 
     -   1/(24.D0*Pi)*(Alfa*((9 + SW2*(-12 + 8*SW2))*
     -          (A0(Mf2(4,Gen1)) + 
     -            k2*B1(k2,Mf2(4,Gen1),Mf2(4,Gen1))) + 
     -         24*B00(k2,Mf2(4,Gen1),Mf2(4,Gen1))*
     -          (-3/4.D0 + SW2*(1 - 2/3.D0*SW2)) + 
     -         9*B0(k2,Mf2(4,Gen1),Mf2(4,Gen1))*Mf2(4,Gen1)))/
     -     (CW2*SW2)
	enddo

	do All1 = g, 6, g
	do Ind1 = g, 3
        se_ZZ_nmfv = se_ZZ_nmfv + 
     -   1/(24.D0*Pi)*(Alfa*A0(MASf2(All1,4))*
     -       ((3 - 2*SW2)**2*UASf(All1,Ind1,4)*
     -          UASfC(All1,Ind1,4) + 
     -         4*SW2**2*UASf(All1,3 + Ind1,4)*
     -          UASfC(All1,3 + Ind1,4)))/(CW2*SW2)
	enddo
	enddo

	do All1 = g, 6, g
	do All2 = g, 6, g
	do Ind1 = g, 3
	do Ind2 = g, 3
        se_ZZ_nmfv = se_ZZ_nmfv - 
     -   1/(12.D0*Pi)*(Alfa*B00(k2,MASf2(All1,4),MASf2(All2,4))*
     -       ((-3 + 2*SW2)*UASf(All2,Ind1,4)*UASfC(All1,Ind1,4) + 
     -         2*SW2*UASf(All2,3 + Ind1,4)*UASfC(All1,3 + Ind1,4))*
     -       ((-3 + 2*SW2)*UASf(All1,Ind2,4)*UASfC(All2,Ind2,4) + 
     -         2*SW2*UASf(All1,3 + Ind2,4)*UASfC(All2,3 + Ind2,4)))
     -      /(CW2*SW2)
	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_ZZ_nmfv =', se_ZZ_nmfv
#endif

	if( mssmpart .eq. 2 ) return


	do Gen1 = 1, 3
        se_ZZ_nmfv = se_ZZ_nmfv - 
     -   1/(8.D0*Pi)*(Alfa*(-A0(MSf2(1,1,Gen1)) - 2*B00(k2,0.D0,0.D0) + 
     -         8*(-1/4.D0 + (1 - 2*SW2)*SW2)*
     -          B00(k2,Mf2(2,Gen1),Mf2(2,Gen1)) + 
     -         2*B00(k2,MSf2(1,1,Gen1),MSf2(1,1,Gen1)) + 
     -         k2*B1(k2,0.D0,0.D0) + 
     -         (1 + SW2*(-4 + 8*SW2))*
     -          (A0(Mf2(2,Gen1)) + 
     -            k2*B1(k2,Mf2(2,Gen1),Mf2(2,Gen1))) + 
     -         B0(k2,Mf2(2,Gen1),Mf2(2,Gen1))*Mf2(2,Gen1)))/
     -     (CW2*SW2)
	enddo

	do Gen1 = 1, 3
	do Sfe1 = 1, 2
        se_ZZ_nmfv = se_ZZ_nmfv + 
     -   1/(8.D0*Pi)*(Alfa*A0(MSf2(Sfe1,2,Gen1))*
     -       ((1 - 2*SW2)**2*USf(Sfe1,1,2,Gen1)*
     -          USfC(Sfe1,1,2,Gen1) + 
     -         4*SW2**2*USf(Sfe1,2,2,Gen1)*USfC(Sfe1,2,2,Gen1)))/
     -     (CW2*SW2)
	enddo
	enddo

	do Gen1 = 1, 3
	do Sfe1 = 1, 2
	do Sfe2 = 1, 2
        se_ZZ_nmfv = se_ZZ_nmfv - 
     -   1/(4.D0*Pi)*(Alfa*B00(k2,MSf2(Sfe1,2,Gen1),
     -        MSf2(Sfe2,2,Gen1))*
     -       ((-1 + 2*SW2)*USf(Sfe2,1,2,Gen1)*
     -          USfC(Sfe1,1,2,Gen1) + 
     -         2*SW2*USf(Sfe2,2,2,Gen1)*USfC(Sfe1,2,2,Gen1))*
     -       ((-1 + 2*SW2)*USf(Sfe1,1,2,Gen1)*
     -          USfC(Sfe2,1,2,Gen1) + 
     -         2*SW2*USf(Sfe1,2,2,Gen1)*USfC(Sfe2,2,2,Gen1)))/
     -     (CW2*SW2)
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_ZZ_nmfv =', se_ZZ_nmfv
#endif

	if( mssmpart .eq. 3 ) return

        se_ZZ_nmfv = se_ZZ_nmfv - 
     -   1/(16.D0*Pi)*(Alfa*(-4*MW2*
     -          (SBA**2*B0(k2,Mh02,MZ2) + CBA**2*B0(k2,MHH2,MZ2))+
     -           CW2*(-A0(MA02) - A0(Mh02) - A0(MHH2) - A0(MZ2) + 
     -            4*SBA**2*
     -             (B00(k2,Mh02,MZ2) + B00(k2,MHH2,MA02)) + 
     -            4*CBA**2*
     -             (B00(k2,Mh02,MA02) + B00(k2,MHH2,MZ2)) - 
     -            2*((CW2*(9*CW2 - 2*SW2) + SW2**2)*A0(MW2) + 
     -               2*(CW2**2*(-5*k2 - 2*MW2) + 2*MW2*SW2**2)*
     -                B0(k2,MW2,MW2) + 
     -               (CW2 - SW2)**2*
     -                (A0(MHp2) - 2*B00(k2,MHp2,MHp2))) + 
     -            4*CW2*((SW2*(CW2*(-2 + (9*CW2)/SW2) + SW2)*
     -                  B00(k2,MW2,MW2))/CW2 + 
     -               2*CW2*k2*B1(k2,MW2,MW2)))))/(CW2**2*SW2)

	do Cha1 = 1, 2
	do Cha2 = 1, 2
        tmp1 = SW2*Delta(Cha1,Cha2) - 
     -   1/2.D0*(UCha(Cha2,2)*UChaC(Cha1,2)) - 
     -   UCha(Cha2,1)*UChaC(Cha1,1)
        tmp2 = SW2*Delta(Cha1,Cha2) - 
     -   1/2.D0*(UCha(Cha1,2)*UChaC(Cha2,2)) - 
     -   UCha(Cha1,1)*UChaC(Cha2,1)
        tmp3 = SW2*Delta(Cha1,Cha2) - 
     -   1/2.D0*(VCha(Cha2,2)*VChaC(Cha1,2)) - 
     -   VCha(Cha2,1)*VChaC(Cha1,1)
        tmp4 = SW2*Delta(Cha1,Cha2) - 
     -   1/2.D0*(VCha(Cha1,2)*VChaC(Cha2,2)) - 
     -   VCha(Cha1,1)*VChaC(Cha2,1)
        se_ZZ_nmfv = se_ZZ_nmfv + 
     -   1/(2.D0*Pi)*(-(Alfa*(tmp1*tmp2 + tmp3*tmp4)*
     -          (A0(MCha2(Cha2)) - 
     -            2*B00(k2,MCha2(Cha1),MCha2(Cha2)) + 
     -            k2*B1(k2,MCha2(Cha1),MCha2(Cha2)))) + 
     -       Alfa*B0(k2,MCha2(Cha1),MCha2(Cha2))*
     -        (tmp2*tmp4*MCha(Cha1)*MCha(Cha2) - 
     -          tmp3*tmp4*MCha2(Cha1) + 
     -          tmp1*(tmp3*MCha(Cha1)*MCha(Cha2) - 
     -             tmp2*MCha2(Cha1))))/(CW2*SW2)
	enddo
	enddo

	do Neu1 = 1, 4
	do Neu2 = 1, 4
	tmp5 = ZNeu(Neu2,3)*ZNeuC(Neu1,3) - ZNeu(Neu2,4)*ZNeuC(Neu1,4)
	tmp6 = ZNeu(Neu1,3)*ZNeuC(Neu2,3) - ZNeu(Neu1,4)*ZNeuC(Neu2,4)
        se_ZZ_nmfv = se_ZZ_nmfv + 
     -   1/(16.D0*Pi)*(Alfa*(4*tmp5*tmp6*
     -          B00(k2,MNeu2(Neu1),MNeu2(Neu2)) - 
     -         B0(k2,MNeu2(Neu1),MNeu2(Neu2))*
     -          (tmp6**2*MNeu(Neu1)*MNeu(Neu2) + 
     -            tmp5*(tmp5*MNeu(Neu1)*MNeu(Neu2) + 
     -               2*tmp6*MNeu2(Neu1))) + 
     -         2*tmp5*(A0(MNeu2(Neu2)) + 
     -            k2*B1(k2,MNeu2(Neu1),MNeu2(Neu2)))*
     -          (-(ZNeu(Neu1,3)*ZNeuC(Neu2,3)) + 
     -            ZNeu(Neu1,4)*ZNeuC(Neu2,4))))/(CW2*SW2)
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_ZZ_nmfv =', se_ZZ_nmfv
#endif

	end

