* se_h0HH.F
* this file is part of FeynHiggs
* generated 07 Nov 2006 18:06

#include "externals.h"


	double complex function se_h0HH(k2)
	implicit none
	double precision k2

#include "FH.h"

	double complex se_h0HH_mfv, se_h0HH_nmfv
	external se_h0HH_mfv, se_h0HH_nmfv

	if( nmfv .eq. 0 ) then
	  se_h0HH = se_h0HH_mfv(k2)
	else
	  se_h0HH = se_h0HH_nmfv(k2)
	endif

#ifdef DEBUG
	print *, 'k2 =', k2
	print *, 'se_h0HH =', se_h0HH
#endif
	end


************************************************************************


	double complex function se_h0HH_mfv(k2)
	implicit character (a-s,u-z)
	implicit double complex (t)
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer Cha1, Cha2, Gen1, Neu1, Neu2, Sfe1, Sfe2, g

	g = ieor(iand(mssmpart - 1, 2), 3)

	se_h0HH_mfv = 0

	do Gen1 = g, 3
        se_h0HH_mfv = se_h0HH_mfv - 
     -   3/(4.D0*Pi)*(Alfa*CA*SA*Mf2(3,Gen1)*
     -       (A0(Mf2(3,Gen1)) + 
     -         k2*B1(k2,Mf2(3,Gen1),Mf2(3,Gen1)) + 
     -         2*B0(k2,Mf2(3,Gen1),Mf2(3,Gen1))*Mf2(3,Gen1)))/
     -     (MW2*SB2*SW2)
	enddo

	do Gen1 = g, 3
	do Sfe1 = 1, 2
        se_h0HH_mfv = se_h0HH_mfv + 
     -   1/(16.D0*Pi)*(Alfa*S2A*A0(MSf2(Sfe1,3,Gen1))*
     -       ((MW2*SB2*(-3 + 4*SW2) + 3*CW2*Mf2(3,Gen1))*
     -          USf(Sfe1,1,3,Gen1)*USfC(Sfe1,1,3,Gen1) + 
     -         (-4*MW2*SB2*SW2 + 3*CW2*Mf2(3,Gen1))*
     -          USf(Sfe1,2,3,Gen1)*USfC(Sfe1,2,3,Gen1)))/
     -     (CW2*MW2*SB2*SW2)
	enddo
	enddo

	do Gen1 = g, 3
	do Sfe1 = 1, 2
	do Sfe2 = 1, 2
        se_h0HH_mfv = se_h0HH_mfv + 
     -   1/(48.D0*Pi)*(Alfa*B0(k2,MSf2(Sfe1,3,Gen1),
     -        MSf2(Sfe2,3,Gen1))*
     -       (USf(Sfe2,1,3,Gen1)*
     -          ((MW*MZ*SAB*SB*(-3 + 4*SW2) + 6*CA*CW*Mf2(3,Gen1))*
     -             USfC(Sfe1,1,3,Gen1) + 
     -            3*CW*(MUE*SA + CA*DCONJG(Af(3,Gen1,Gen1)))*
     -             Mf(3,Gen1)*USfC(Sfe1,2,3,Gen1)) + 
     -         USf(Sfe2,2,3,Gen1)*
     -          (3*CW*(CA*Af(3,Gen1,Gen1) + SA*DCONJG(MUE))*
     -             Mf(3,Gen1)*USfC(Sfe1,1,3,Gen1) + 
     -            2*(-2*MW*MZ*SAB*SB*SW2 + 3*CA*CW*Mf2(3,Gen1))*
     -             USfC(Sfe1,2,3,Gen1)))*
     -       (USf(Sfe1,1,3,Gen1)*
     -          ((CAB*MW*MZ*SB*(3 - 4*SW2) + 6*CW*SA*Mf2(3,Gen1))*
     -             USfC(Sfe2,1,3,Gen1) + 
     -            3*CW*(-(CA*MUE) + SA*DCONJG(Af(3,Gen1,Gen1)))*
     -             Mf(3,Gen1)*USfC(Sfe2,2,3,Gen1)) + 
     -         USf(Sfe1,2,3,Gen1)*
     -          (3*CW*(SA*Af(3,Gen1,Gen1) - CA*DCONJG(MUE))*
     -             Mf(3,Gen1)*USfC(Sfe2,1,3,Gen1) + 
     -            2*(2*CAB*MW*MZ*SB*SW2 + 3*CW*SA*Mf2(3,Gen1))*
     -             USfC(Sfe2,2,3,Gen1))))/(CW2*MW2*SB2*SW2)
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_h0HH_mfv =', se_h0HH_mfv
#endif

	if( mssmpart .eq. 1 ) return


	do Gen1 = g, 3
        se_h0HH_mfv = se_h0HH_mfv + 
     -   3/(4.D0*Pi)*(Alfa*CA*SA*Hff(1,Gen1,1)*Hff(2,Gen1,1)*
     -       Mdy2(Gen1,1)*(A0(Mf2(4,Gen1)) + 
     -         k2*B1(k2,Mf2(4,Gen1),Mf2(4,Gen1)) + 
     -         2*B0(k2,Mf2(4,Gen1),Mf2(4,Gen1))*Mf2(4,Gen1)))/
     -     (CB2*MW2*SW2)
	enddo

	do Gen1 = g, 3
	do Sfe1 = 1, 2
        se_h0HH_mfv = se_h0HH_mfv - 
     -   1/(16.D0*Pi)*(Alfa*S2A*A0(MSf2(Sfe1,4,Gen1))*
     -       ((CB2*MW2*(-3 + 2*SW2) + 3*CW2*Mdy2(Gen1,1))*
     -          USf(Sfe1,1,4,Gen1)*USfC(Sfe1,1,4,Gen1) + 
     -         (-2*CB2*MW2*SW2 + 3*CW2*Mdy2(Gen1,1))*
     -          USf(Sfe1,2,4,Gen1)*USfC(Sfe1,2,4,Gen1)))/
     -     (CB2*CW2*MW2*SW2)
	enddo
	enddo

	do Gen1 = g, 3
	do Sfe1 = 1, 2
	do Sfe2 = 1, 2
        se_h0HH_mfv = se_h0HH_mfv - 
     -   1/(48.D0*Pi)*(Alfa*B0(k2,MSf2(Sfe1,4,Gen1),
     -        MSf2(Sfe2,4,Gen1))*
     -       (USf(Sfe2,1,4,Gen1)*
     -          ((CB*MW*MZ*SAB*(-3 + 2*SW2) + 
     -               6*CW*SA*Mdy2(Gen1,1))*USfC(Sfe1,1,4,Gen1) + 
     -            3*CW*(CA*MUE + SA*DCONJG(Af(4,Gen1,Gen1)))*
     -             Mdy(Gen1,1)*USfC(Sfe1,2,4,Gen1)) + 
     -         USf(Sfe2,2,4,Gen1)*
     -          (3*CW*(SA*Af(4,Gen1,Gen1) + CA*DCONJG(MUE))*
     -             Mdy(Gen1,1)*USfC(Sfe1,1,4,Gen1) - 
     -            2*(CB*MW*MZ*SAB*SW2 - 3*CW*SA*Mdy2(Gen1,1))*
     -             USfC(Sfe1,2,4,Gen1)))*
     -       (USf(Sfe1,1,4,Gen1)*
     -          ((CAB*CB*MW*MZ*(-3 + 2*SW2) + 
     -               6*CA*CW*Mdy2(Gen1,1))*USfC(Sfe2,1,4,Gen1) + 
     -            3*CW*(-(MUE*SA) + CA*DCONJG(Af(4,Gen1,Gen1)))*
     -             Mdy(Gen1,1)*USfC(Sfe2,2,4,Gen1)) + 
     -         USf(Sfe1,2,4,Gen1)*
     -          (3*CW*(CA*Af(4,Gen1,Gen1) - SA*DCONJG(MUE))*
     -             Mdy(Gen1,1)*USfC(Sfe2,1,4,Gen1) - 
     -            2*(CAB*CB*MW*MZ*SW2 - 3*CA*CW*Mdy2(Gen1,1))*
     -             USfC(Sfe2,2,4,Gen1))))/(CB2*CW2*MW2*SW2)
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_h0HH_mfv =', se_h0HH_mfv
#endif

	if( mssmpart .eq. 2 ) return


	do Gen1 = 1, 3
        se_h0HH_mfv = se_h0HH_mfv - 
     -   1/(16.D0*Pi)*(Alfa*(CB2*MW2*S2A*A0(MSf2(1,1,Gen1)) + 
     -         CAB*CB2*MW2*MZ2*SAB*
     -          B0(k2,MSf2(1,1,Gen1),MSf2(1,1,Gen1)) - 
     -         4*CA*CW2*SA*Mf2(2,Gen1)*
     -          (A0(Mf2(2,Gen1)) + 
     -            k2*B1(k2,Mf2(2,Gen1),Mf2(2,Gen1)) + 
     -            2*B0(k2,Mf2(2,Gen1),Mf2(2,Gen1))*Mf2(2,Gen1))))/
     -     (CB2*CW2*MW2*SW2)
	enddo

	do Gen1 = 1, 3
	do Sfe1 = 1, 2
        se_h0HH_mfv = se_h0HH_mfv - 
     -   1/(16.D0*Pi)*(Alfa*S2A*A0(MSf2(Sfe1,2,Gen1))*
     -       ((CB2*MW2*(-1 + 2*SW2) + CW2*Mf2(2,Gen1))*
     -          USf(Sfe1,1,2,Gen1)*USfC(Sfe1,1,2,Gen1) + 
     -         (-2*CB2*MW2*SW2 + CW2*Mf2(2,Gen1))*
     -          USf(Sfe1,2,2,Gen1)*USfC(Sfe1,2,2,Gen1)))/
     -     (CB2*CW2*MW2*SW2)
	enddo
	enddo

	do Gen1 = 1, 3
	do Sfe1 = 1, 2
	do Sfe2 = 1, 2
        se_h0HH_mfv = se_h0HH_mfv + 
     -   1/(16.D0*Pi)*(Alfa*B0(k2,MSf2(Sfe1,2,Gen1),
     -        MSf2(Sfe2,2,Gen1))*
     -       (USf(Sfe2,1,2,Gen1)*
     -          ((CB*MW*MZ*SAB*(-1 + 2*SW2) + 2*CW*SA*Mf2(2,Gen1))*
     -             USfC(Sfe1,1,2,Gen1) + 
     -            CW*(CA*MUE + SA*DCONJG(Af(2,Gen1,Gen1)))*
     -             Mf(2,Gen1)*USfC(Sfe1,2,2,Gen1)) + 
     -         USf(Sfe2,2,2,Gen1)*
     -          (CW*(SA*Af(2,Gen1,Gen1) + CA*DCONJG(MUE))*
     -             Mf(2,Gen1)*USfC(Sfe1,1,2,Gen1) + 
     -            2*(-(CB*MW*MZ*SAB*SW2) + CW*SA*Mf2(2,Gen1))*
     -             USfC(Sfe1,2,2,Gen1)))*
     -       (USf(Sfe1,1,2,Gen1)*
     -          ((CAB*CB*MW*MZ*(1 - 2*SW2) - 2*CA*CW*Mf2(2,Gen1))*
     -             USfC(Sfe2,1,2,Gen1) + 
     -            CW*(MUE*SA - CA*DCONJG(Af(2,Gen1,Gen1)))*
     -             Mf(2,Gen1)*USfC(Sfe2,2,2,Gen1)) + 
     -         USf(Sfe1,2,2,Gen1)*
     -          (CW*(-(CA*Af(2,Gen1,Gen1)) + SA*DCONJG(MUE))*
     -             Mf(2,Gen1)*USfC(Sfe2,1,2,Gen1) + 
     -            2*(CAB*CB*MW*MZ*SW2 - CA*CW*Mf2(2,Gen1))*
     -             USfC(Sfe2,2,2,Gen1))))/(CB2*CW2*MW2*SW2)
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_h0HH_mfv =', se_h0HH_mfv
#endif

	if( mssmpart .eq. 3 ) return

        se_h0HH_mfv = se_h0HH_mfv + 
     -   1/(32.D0*Pi)*(Alfa*C2B*CW2*S2A*A0(MA02) + 
     -       3*Alfa*C2A*CW2*S2A*A0(Mh02) + 
     -       2*Alfa*(-(CAB*MW2*S2B**2*SAB) + 
     -          CBA*CW2*(k2*SBA + MA02*SBA))*B0(k2,MA02,MZ2) - 
     -       Alfa*(3*C2A*CW2*S2A*A0(MHH2) - 
     -          2*CW2**2*((C2B*S2A)/CW2 + (C2A*S2B)/SW2)*SW2*
     -           (A0(MHp2) - A0(MW2)) + C2B*CW2*S2A*A0(MZ2) + 
     -          MW2*(C2B**2*CAB*SAB*B0(k2,MA02,MA02) + 
     -             3*C2A*SAB*(C2A*CAB - 2*S2A*SAB)*
     -              B0(k2,Mh02,Mh02) + 
     -             (2*CAB*S2A + C2A*SAB)*
     -              (4*S2A*SAB*B0(k2,Mh02,MHH2) + 
     -                C2A*CAB*
     -                 (-2*B0(k2,Mh02,MHH2) + 3*B0(k2,MHH2,MHH2)))-
     -               2*(-(C2B*CAB) + 2*CBA*CW2)*
     -              (C2B*SAB + 2*CW2*SBA)*B0(k2,MHp2,MHp2)) - 
     -          4*(CAB*MW2*S2B*(CBA*CW2 - S2B*SAB) + 
     -             CW2*(CBA*CW2*(k2 + MHp2 - MW2) + MW2*S2B*SAB)*
     -              SBA)*B0(k2,MHp2,MW2) + 
     -          2*(C2B**2*CAB*MW2*SAB + 
     -             CBA*CW2**2*(2*k2*SBA - 12*MW2*SBA))*
     -           B0(k2,MW2,MW2) + 
     -          (C2B**2*CAB*MW2*SAB + 
     -             2*CBA*(-7*MW2 + CW2*(k2 + MZ2))*SBA)*
     -           B0(k2,MZ2,MZ2) + 
     -          4*CBA*CW2*k2*SBA*
     -           (B1(k2,MA02,MZ2) + 
     -             CW2*(2*B1(k2,MHp2,MW2) - 2*B1(k2,MW2,MW2)) - 
     -             B1(k2,MZ2,MZ2))))/(CW2**2*SW2)

	do Cha1 = 1, 2
	do Cha2 = 1, 2
        tmp1 = SA*UCha(Cha2,2)*VCha(Cha1,1) - 
     -   CA*UCha(Cha2,1)*VCha(Cha1,2)
        tmp2 = CA*UCha(Cha1,2)*VCha(Cha2,1) + 
     -   SA*UCha(Cha1,1)*VCha(Cha2,2)
        tmp3 = CA*UChaC(Cha2,2)*VChaC(Cha1,1) + 
     -   SA*UChaC(Cha2,1)*VChaC(Cha1,2)
        tmp4 = SA*UChaC(Cha1,2)*VChaC(Cha2,1) - 
     -   CA*UChaC(Cha1,1)*VChaC(Cha2,2)
        se_h0HH_mfv = se_h0HH_mfv + 
     -   1/(4.D0*Pi)*(Alfa*(tmp1*tmp3 + tmp2*tmp4)*
     -        (A0(MCha2(Cha2)) + k2*B1(k2,MCha2(Cha1),MCha2(Cha2)))
     -         + Alfa*B0(k2,MCha2(Cha1),MCha2(Cha2))*
     -        (tmp3*tmp4*MCha(Cha1)*MCha(Cha2) + 
     -          tmp2*tmp4*MCha2(Cha1) + 
     -          tmp1*(tmp2*MCha(Cha1)*MCha(Cha2) + 
     -             tmp3*MCha2(Cha1))))/SW2
	enddo
	enddo

	do Neu1 = 1, 4
	do Neu2 = 1, 4
	tmp5 = SW*ZNeu(Neu1,1) - CW*ZNeu(Neu1,2)
	tmp6 = SW*ZNeu(Neu2,1) - CW*ZNeu(Neu2,2)
	tmp7 = CA*(-(SW*ZNeu(Neu2,1)) + CW*ZNeu(Neu2,2))
	tmp8 = -(SA*SW*ZNeu(Neu2,1)) + CW*SA*ZNeu(Neu2,2)
	tmp9 = SA*ZNeu(Neu2,3) + CA*ZNeu(Neu2,4)
	tmp10 = CA*ZNeu(Neu2,3) - SA*ZNeu(Neu2,4)
	tmp11 = SW*ZNeuC(Neu1,1) - CW*ZNeuC(Neu1,2)
	tmp12 = SW*ZNeuC(Neu2,1) - CW*ZNeuC(Neu2,2)
	tmp13 = -(SA*SW*ZNeuC(Neu2,1)) + CW*SA*ZNeuC(Neu2,2)
	tmp14 = SA*ZNeuC(Neu2,3) + CA*ZNeuC(Neu2,4)
	tmp15 = CA*ZNeuC(Neu2,3) - SA*ZNeuC(Neu2,4)
        se_h0HH_mfv = se_h0HH_mfv + 
     -   1/(16.D0*Pi)*(Alfa*(A0(MNeu2(Neu2)) + 
     -          k2*B1(k2,MNeu2(Neu1),MNeu2(Neu2)))*
     -        ((tmp10*tmp5 + CA*tmp6*ZNeu(Neu1,3) + 
     -             tmp8*ZNeu(Neu1,4))*
     -           (tmp11*tmp14 + SA*tmp12*ZNeuC(Neu1,3) + 
     -             CA*tmp12*ZNeuC(Neu1,4)) + 
     -          (tmp5*tmp9 - tmp8*ZNeu(Neu1,3) - 
     -             tmp7*ZNeu(Neu1,4))*
     -           (tmp11*tmp15 + CA*tmp12*ZNeuC(Neu1,3) + 
     -             tmp13*ZNeuC(Neu1,4))) + 
     -       Alfa*B0(k2,MNeu2(Neu1),MNeu2(Neu2))*
     -        (MNeu(Neu1)*MNeu(Neu2)*
     -           (tmp5*tmp9 - tmp8*ZNeu(Neu1,3) - 
     -             tmp7*ZNeu(Neu1,4))*
     -           (tmp10*tmp5 + CA*tmp6*ZNeu(Neu1,3) + 
     -             tmp8*ZNeu(Neu1,4)) + 
     -          MNeu2(Neu1)*
     -           (tmp10*tmp5 + CA*tmp6*ZNeu(Neu1,3) + 
     -             tmp8*ZNeu(Neu1,4))*
     -           (tmp11*tmp14 + SA*tmp12*ZNeuC(Neu1,3) + 
     -             CA*tmp12*ZNeuC(Neu1,4)) + 
     -          MNeu2(Neu1)*
     -           (tmp5*tmp9 - tmp8*ZNeu(Neu1,3) - 
     -             tmp7*ZNeu(Neu1,4))*
     -           (tmp11*tmp15 + CA*tmp12*ZNeuC(Neu1,3) + 
     -             tmp13*ZNeuC(Neu1,4)) + 
     -          MNeu(Neu1)*MNeu(Neu2)*
     -           (tmp11*tmp14 + SA*tmp12*ZNeuC(Neu1,3) + 
     -             CA*tmp12*ZNeuC(Neu1,4))*
     -           (tmp11*tmp15 + CA*tmp12*ZNeuC(Neu1,3) + 
     -             tmp13*ZNeuC(Neu1,4))))/(CW2*SW2)
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_h0HH_mfv =', se_h0HH_mfv
#endif

	end


************************************************************************


	double complex function se_h0HH_nmfv(k2)
	implicit character (a-s,u-z)
	implicit double complex (t)
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer All1, All2, Cha1, Cha2, Gen1, Ind1, Ind2, Ind3, Ind4
	integer Neu1, Neu2, Sfe1, Sfe2, g

	g = ieor(iand(mssmpart - 1, 2), 3)

	se_h0HH_nmfv = 0

	do Gen1 = g, 3
        se_h0HH_nmfv = se_h0HH_nmfv - 
     -   3/(4.D0*Pi)*(Alfa*CA*SA*Mf2(3,Gen1)*
     -       (A0(Mf2(3,Gen1)) + 
     -         k2*B1(k2,Mf2(3,Gen1),Mf2(3,Gen1)) + 
     -         2*B0(k2,Mf2(3,Gen1),Mf2(3,Gen1))*Mf2(3,Gen1)))/
     -     (MW2*SB2*SW2)
	enddo

	do All1 = g, 6, g
	do Ind1 = g, 3
        se_h0HH_nmfv = se_h0HH_nmfv + 
     -   1/(16.D0*Pi)*(Alfa*S2A*A0(MASf2(All1,3))*
     -       ((MW2*SB2*(-3 + 4*SW2) + 3*CW2*Mf2(3,Ind1))*
     -          UASf(All1,Ind1,3)*UASfC(All1,Ind1,3) + 
     -         (-4*MW2*SB2*SW2 + 3*CW2*Mf2(3,Ind1))*
     -          UASf(All1,3 + Ind1,3)*UASfC(All1,3 + Ind1,3)))/
     -     (CW2*MW2*SB2*SW2)
	enddo
	enddo

	do All1 = g, 6, g
	do All2 = g, 6, g
	do Ind1 = g, 3
	do Ind2 = g, 3
	do Ind3 = g, 3
	do Ind4 = g, 3
        se_h0HH_nmfv = se_h0HH_nmfv + 
     -   1/(48.D0*Pi)*(Alfa*B0(k2,MASf2(All1,3),MASf2(All2,3))*
     -       ((Delta(Ind1,Ind2)*
     -             (MW*MZ*SAB*SB*(-3 + 4*SW2) + 
     -               6*CA*CW*Mf2(3,Ind1))*UASf(All2,Ind2,3) + 
     -            3*CW*(CA*Af(3,Ind1,Ind2) + 
     -               SA*DCONJG(MUE)*Delta(Ind1,Ind2))*Mf(3,Ind1)*
     -             UASf(All2,3 + Ind2,3))*UASfC(All1,Ind1,3) + 
     -         (3*CW*(MUE*SA*Delta(Ind1,Ind2)*Mf(3,Ind1) + 
     -               CA*DCONJG(Af(3,Ind2,Ind1))*Mf(3,Ind2))*
     -             UASf(All2,Ind2,3) + 
     -            2*Delta(Ind1,Ind2)*
     -             (-2*MW*MZ*SAB*SB*SW2 + 3*CA*CW*Mf2(3,Ind1))*
     -             UASf(All2,3 + Ind2,3))*UASfC(All1,3 + Ind1,3))*
     -       ((Delta(Ind3,Ind4)*
     -             (CAB*MW*MZ*SB*(3 - 4*SW2) + 
     -               6*CW*SA*Mf2(3,Ind3))*UASf(All1,Ind4,3) + 
     -            3*CW*(SA*Af(3,Ind3,Ind4) - 
     -               CA*DCONJG(MUE)*Delta(Ind3,Ind4))*Mf(3,Ind3)*
     -             UASf(All1,3 + Ind4,3))*UASfC(All2,Ind3,3) + 
     -         (3*CW*(-(CA*MUE*Delta(Ind3,Ind4)*Mf(3,Ind3)) + 
     -               SA*DCONJG(Af(3,Ind4,Ind3))*Mf(3,Ind4))*
     -             UASf(All1,Ind4,3) + 
     -            2*Delta(Ind3,Ind4)*
     -             (2*CAB*MW*MZ*SB*SW2 + 3*CW*SA*Mf2(3,Ind3))*
     -             UASf(All1,3 + Ind4,3))*UASfC(All2,3 + Ind3,3)))/
     -     (CW2*MW2*SB2*SW2)
	enddo
	enddo
	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_h0HH_nmfv =', se_h0HH_nmfv
#endif

	if( mssmpart .eq. 1 ) return


	do Gen1 = g, 3
        se_h0HH_nmfv = se_h0HH_nmfv + 
     -   3/(4.D0*Pi)*(Alfa*CA*SA*Hff(1,Gen1,1)*Hff(2,Gen1,1)*
     -       Mdy2(Gen1,1)*(A0(Mf2(4,Gen1)) + 
     -         k2*B1(k2,Mf2(4,Gen1),Mf2(4,Gen1)) + 
     -         2*B0(k2,Mf2(4,Gen1),Mf2(4,Gen1))*Mf2(4,Gen1)))/
     -     (CB2*MW2*SW2)
	enddo

	do All1 = g, 6, g
	do Ind1 = g, 3
        se_h0HH_nmfv = se_h0HH_nmfv - 
     -   1/(16.D0*Pi)*(Alfa*S2A*A0(MASf2(All1,4))*
     -       ((CB2*MW2*(-3 + 2*SW2) + 3*CW2*Mdy2(Ind1,1))*
     -          UASf(All1,Ind1,4)*UASfC(All1,Ind1,4) + 
     -         (-2*CB2*MW2*SW2 + 3*CW2*Mdy2(Ind1,1))*
     -          UASf(All1,3 + Ind1,4)*UASfC(All1,3 + Ind1,4)))/
     -     (CB2*CW2*MW2*SW2)
	enddo
	enddo

	do All1 = g, 6, g
	do All2 = g, 6, g
	do Ind1 = g, 3
	do Ind2 = g, 3
	do Ind3 = g, 3
	do Ind4 = g, 3
        se_h0HH_nmfv = se_h0HH_nmfv - 
     -   1/(48.D0*Pi)*(Alfa*B0(k2,MASf2(All1,4),MASf2(All2,4))*
     -       ((Delta(Ind1,Ind2)*
     -             (CB*MW*MZ*SAB*(-3 + 2*SW2) + 
     -               6*CW*SA*Mdy2(Ind1,1))*UASf(All2,Ind2,4) + 
     -            3*CW*(SA*Af(4,Ind1,Ind2) + 
     -               CA*DCONJG(MUE)*Delta(Ind1,Ind2))*Mdy(Ind1,1)*
     -             UASf(All2,3 + Ind2,4))*UASfC(All1,Ind1,4) + 
     -         (3*CW*(CA*MUE*Delta(Ind1,Ind2)*Mdy(Ind1,1) + 
     -               SA*DCONJG(Af(4,Ind2,Ind1))*Mdy(Ind2,1))*
     -             UASf(All2,Ind2,4) - 
     -            2*Delta(Ind1,Ind2)*
     -             (CB*MW*MZ*SAB*SW2 - 3*CW*SA*Mdy2(Ind1,1))*
     -             UASf(All2,3 + Ind2,4))*UASfC(All1,3 + Ind1,4))*
     -       ((Delta(Ind3,Ind4)*
     -             (CAB*CB*MW*MZ*(-3 + 2*SW2) + 
     -               6*CA*CW*Mdy2(Ind3,1))*UASf(All1,Ind4,4) + 
     -            3*CW*(CA*Af(4,Ind3,Ind4) - 
     -               SA*DCONJG(MUE)*Delta(Ind3,Ind4))*Mdy(Ind3,1)*
     -             UASf(All1,3 + Ind4,4))*UASfC(All2,Ind3,4) + 
     -         (3*CW*(-(MUE*SA*Delta(Ind3,Ind4)*Mdy(Ind3,1)) + 
     -               CA*DCONJG(Af(4,Ind4,Ind3))*Mdy(Ind4,1))*
     -             UASf(All1,Ind4,4) - 
     -            2*Delta(Ind3,Ind4)*
     -             (CAB*CB*MW*MZ*SW2 - 3*CA*CW*Mdy2(Ind3,1))*
     -             UASf(All1,3 + Ind4,4))*UASfC(All2,3 + Ind3,4)))/
     -     (CB2*CW2*MW2*SW2)
	enddo
	enddo
	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_h0HH_nmfv =', se_h0HH_nmfv
#endif

	if( mssmpart .eq. 2 ) return


	do Gen1 = 1, 3
        se_h0HH_nmfv = se_h0HH_nmfv - 
     -   1/(16.D0*Pi)*(Alfa*(CB2*MW2*S2A*A0(MSf2(1,1,Gen1)) + 
     -         CAB*CB2*MW2*MZ2*SAB*
     -          B0(k2,MSf2(1,1,Gen1),MSf2(1,1,Gen1)) - 
     -         4*CA*CW2*SA*Mf2(2,Gen1)*
     -          (A0(Mf2(2,Gen1)) + 
     -            k2*B1(k2,Mf2(2,Gen1),Mf2(2,Gen1)) + 
     -            2*B0(k2,Mf2(2,Gen1),Mf2(2,Gen1))*Mf2(2,Gen1))))/
     -     (CB2*CW2*MW2*SW2)
	enddo

	do Gen1 = 1, 3
	do Sfe1 = 1, 2
        se_h0HH_nmfv = se_h0HH_nmfv - 
     -   1/(16.D0*Pi)*(Alfa*S2A*A0(MSf2(Sfe1,2,Gen1))*
     -       ((CB2*MW2*(-1 + 2*SW2) + CW2*Mf2(2,Gen1))*
     -          USf(Sfe1,1,2,Gen1)*USfC(Sfe1,1,2,Gen1) + 
     -         (-2*CB2*MW2*SW2 + CW2*Mf2(2,Gen1))*
     -          USf(Sfe1,2,2,Gen1)*USfC(Sfe1,2,2,Gen1)))/
     -     (CB2*CW2*MW2*SW2)
	enddo
	enddo

	do Gen1 = 1, 3
	do Sfe1 = 1, 2
	do Sfe2 = 1, 2
        se_h0HH_nmfv = se_h0HH_nmfv + 
     -   1/(16.D0*Pi)*(Alfa*B0(k2,MSf2(Sfe1,2,Gen1),
     -        MSf2(Sfe2,2,Gen1))*
     -       (USf(Sfe2,1,2,Gen1)*
     -          ((CB*MW*MZ*SAB*(-1 + 2*SW2) + 2*CW*SA*Mf2(2,Gen1))*
     -             USfC(Sfe1,1,2,Gen1) + 
     -            CW*(CA*MUE + SA*DCONJG(Af(2,Gen1,Gen1)))*
     -             Mf(2,Gen1)*USfC(Sfe1,2,2,Gen1)) + 
     -         USf(Sfe2,2,2,Gen1)*
     -          (CW*(SA*Af(2,Gen1,Gen1) + CA*DCONJG(MUE))*
     -             Mf(2,Gen1)*USfC(Sfe1,1,2,Gen1) + 
     -            2*(-(CB*MW*MZ*SAB*SW2) + CW*SA*Mf2(2,Gen1))*
     -             USfC(Sfe1,2,2,Gen1)))*
     -       (USf(Sfe1,1,2,Gen1)*
     -          ((CAB*CB*MW*MZ*(1 - 2*SW2) - 2*CA*CW*Mf2(2,Gen1))*
     -             USfC(Sfe2,1,2,Gen1) + 
     -            CW*(MUE*SA - CA*DCONJG(Af(2,Gen1,Gen1)))*
     -             Mf(2,Gen1)*USfC(Sfe2,2,2,Gen1)) + 
     -         USf(Sfe1,2,2,Gen1)*
     -          (CW*(-(CA*Af(2,Gen1,Gen1)) + SA*DCONJG(MUE))*
     -             Mf(2,Gen1)*USfC(Sfe2,1,2,Gen1) + 
     -            2*(CAB*CB*MW*MZ*SW2 - CA*CW*Mf2(2,Gen1))*
     -             USfC(Sfe2,2,2,Gen1))))/(CB2*CW2*MW2*SW2)
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_h0HH_nmfv =', se_h0HH_nmfv
#endif

	if( mssmpart .eq. 3 ) return

        se_h0HH_nmfv = se_h0HH_nmfv + 
     -   1/(32.D0*Pi)*(Alfa*C2B*CW2*S2A*A0(MA02) + 
     -       3*Alfa*C2A*CW2*S2A*A0(Mh02) + 
     -       2*Alfa*(-(CAB*MW2*S2B**2*SAB) + 
     -          CBA*CW2*(k2*SBA + MA02*SBA))*B0(k2,MA02,MZ2) - 
     -       Alfa*(3*C2A*CW2*S2A*A0(MHH2) - 
     -          2*CW2**2*((C2B*S2A)/CW2 + (C2A*S2B)/SW2)*SW2*
     -           (A0(MHp2) - A0(MW2)) + C2B*CW2*S2A*A0(MZ2) + 
     -          MW2*(C2B**2*CAB*SAB*B0(k2,MA02,MA02) + 
     -             3*C2A*SAB*(C2A*CAB - 2*S2A*SAB)*
     -              B0(k2,Mh02,Mh02) + 
     -             (2*CAB*S2A + C2A*SAB)*
     -              (4*S2A*SAB*B0(k2,Mh02,MHH2) + 
     -                C2A*CAB*
     -                 (-2*B0(k2,Mh02,MHH2) + 3*B0(k2,MHH2,MHH2)))-
     -               2*(-(C2B*CAB) + 2*CBA*CW2)*
     -              (C2B*SAB + 2*CW2*SBA)*B0(k2,MHp2,MHp2)) - 
     -          4*(CAB*MW2*S2B*(CBA*CW2 - S2B*SAB) + 
     -             CW2*(CBA*CW2*(k2 + MHp2 - MW2) + MW2*S2B*SAB)*
     -              SBA)*B0(k2,MHp2,MW2) + 
     -          2*(C2B**2*CAB*MW2*SAB + 
     -             CBA*CW2**2*(2*k2*SBA - 12*MW2*SBA))*
     -           B0(k2,MW2,MW2) + 
     -          (C2B**2*CAB*MW2*SAB + 
     -             2*CBA*(-7*MW2 + CW2*(k2 + MZ2))*SBA)*
     -           B0(k2,MZ2,MZ2) + 
     -          4*CBA*CW2*k2*SBA*
     -           (B1(k2,MA02,MZ2) + 
     -             CW2*(2*B1(k2,MHp2,MW2) - 2*B1(k2,MW2,MW2)) - 
     -             B1(k2,MZ2,MZ2))))/(CW2**2*SW2)

	do Cha1 = 1, 2
	do Cha2 = 1, 2
        tmp1 = SA*UCha(Cha2,2)*VCha(Cha1,1) - 
     -   CA*UCha(Cha2,1)*VCha(Cha1,2)
        tmp2 = CA*UCha(Cha1,2)*VCha(Cha2,1) + 
     -   SA*UCha(Cha1,1)*VCha(Cha2,2)
        tmp3 = CA*UChaC(Cha2,2)*VChaC(Cha1,1) + 
     -   SA*UChaC(Cha2,1)*VChaC(Cha1,2)
        tmp4 = SA*UChaC(Cha1,2)*VChaC(Cha2,1) - 
     -   CA*UChaC(Cha1,1)*VChaC(Cha2,2)
        se_h0HH_nmfv = se_h0HH_nmfv + 
     -   1/(4.D0*Pi)*(Alfa*(tmp1*tmp3 + tmp2*tmp4)*
     -        (A0(MCha2(Cha2)) + k2*B1(k2,MCha2(Cha1),MCha2(Cha2)))
     -         + Alfa*B0(k2,MCha2(Cha1),MCha2(Cha2))*
     -        (tmp3*tmp4*MCha(Cha1)*MCha(Cha2) + 
     -          tmp2*tmp4*MCha2(Cha1) + 
     -          tmp1*(tmp2*MCha(Cha1)*MCha(Cha2) + 
     -             tmp3*MCha2(Cha1))))/SW2
	enddo
	enddo

	do Neu1 = 1, 4
	do Neu2 = 1, 4
	tmp5 = SW*ZNeu(Neu1,1) - CW*ZNeu(Neu1,2)
	tmp6 = SW*ZNeu(Neu2,1) - CW*ZNeu(Neu2,2)
	tmp7 = CA*(-(SW*ZNeu(Neu2,1)) + CW*ZNeu(Neu2,2))
	tmp8 = -(SA*SW*ZNeu(Neu2,1)) + CW*SA*ZNeu(Neu2,2)
	tmp9 = SA*ZNeu(Neu2,3) + CA*ZNeu(Neu2,4)
	tmp10 = CA*ZNeu(Neu2,3) - SA*ZNeu(Neu2,4)
	tmp11 = SW*ZNeuC(Neu1,1) - CW*ZNeuC(Neu1,2)
	tmp12 = SW*ZNeuC(Neu2,1) - CW*ZNeuC(Neu2,2)
	tmp13 = -(SA*SW*ZNeuC(Neu2,1)) + CW*SA*ZNeuC(Neu2,2)
	tmp14 = SA*ZNeuC(Neu2,3) + CA*ZNeuC(Neu2,4)
	tmp15 = CA*ZNeuC(Neu2,3) - SA*ZNeuC(Neu2,4)
        se_h0HH_nmfv = se_h0HH_nmfv + 
     -   1/(16.D0*Pi)*(Alfa*(A0(MNeu2(Neu2)) + 
     -          k2*B1(k2,MNeu2(Neu1),MNeu2(Neu2)))*
     -        ((tmp10*tmp5 + CA*tmp6*ZNeu(Neu1,3) + 
     -             tmp8*ZNeu(Neu1,4))*
     -           (tmp11*tmp14 + SA*tmp12*ZNeuC(Neu1,3) + 
     -             CA*tmp12*ZNeuC(Neu1,4)) + 
     -          (tmp5*tmp9 - tmp8*ZNeu(Neu1,3) - 
     -             tmp7*ZNeu(Neu1,4))*
     -           (tmp11*tmp15 + CA*tmp12*ZNeuC(Neu1,3) + 
     -             tmp13*ZNeuC(Neu1,4))) + 
     -       Alfa*B0(k2,MNeu2(Neu1),MNeu2(Neu2))*
     -        (MNeu(Neu1)*MNeu(Neu2)*
     -           (tmp5*tmp9 - tmp8*ZNeu(Neu1,3) - 
     -             tmp7*ZNeu(Neu1,4))*
     -           (tmp10*tmp5 + CA*tmp6*ZNeu(Neu1,3) + 
     -             tmp8*ZNeu(Neu1,4)) + 
     -          MNeu2(Neu1)*
     -           (tmp10*tmp5 + CA*tmp6*ZNeu(Neu1,3) + 
     -             tmp8*ZNeu(Neu1,4))*
     -           (tmp11*tmp14 + SA*tmp12*ZNeuC(Neu1,3) + 
     -             CA*tmp12*ZNeuC(Neu1,4)) + 
     -          MNeu2(Neu1)*
     -           (tmp5*tmp9 - tmp8*ZNeu(Neu1,3) - 
     -             tmp7*ZNeu(Neu1,4))*
     -           (tmp11*tmp15 + CA*tmp12*ZNeuC(Neu1,3) + 
     -             tmp13*ZNeuC(Neu1,4)) + 
     -          MNeu(Neu1)*MNeu(Neu2)*
     -           (tmp11*tmp14 + SA*tmp12*ZNeuC(Neu1,3) + 
     -             CA*tmp12*ZNeuC(Neu1,4))*
     -           (tmp11*tmp15 + CA*tmp12*ZNeuC(Neu1,3) + 
     -             tmp13*ZNeuC(Neu1,4))))/(CW2*SW2)
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_h0HH_nmfv =', se_h0HH_nmfv
#endif

	end

