* TL.h
* declarations for the two-loop routines
* this file is part of FeynHiggs
* last modified 9 Dec 05 th

#include "const.h"
#include "looptools.h"


	integer Nc, MSDR
	parameter (Nc = 3)
	parameter (MSDR = -5)

	double precision Cf
	parameter (Cf = 4/3D0)

	double precision Phi, Li2, InvTri
	external Phi, Li2, InvTri

	double complex MUEc, Xtc, Atc, Xbc, Abc
	double precision DSS2(2,3:4), DSf(2,3:4)
	double precision MA02, MUE2, MGl, MGl2
	double precision MTrun, MBy, Q
	double precision Alfas, hb2, hb

	double precision MT, MT2, MB, MB2
	double precision TB, SB, CB, SB2, CB2, C2B
	double precision Xt, Yt, ht2, ht

#ifndef NPara
#define NPara 12

#define MSt12 StopPara(1)
#define MSt22 StopPara(2)
#define MSt2diff StopPara(3)
#define MSt2sum StopPara(4)
#define ctt StopPara(5)
#define ctt2 StopPara(6)
#define c2tt StopPara(7)
#define c2tt2 StopPara(8)
#define stt StopPara(9)
#define stt2 StopPara(10)
#define s2tt StopPara(11)
#define s2tt2 StopPara(12)

#define MSb12 SbotPara(1)
#define MSb22 SbotPara(2)
#define MSb2diff SbotPara(3)
#define MSb2sum SbotPara(4)
#define ctb SbotPara(5)
#define ctb2 SbotPara(6)
#define c2tb SbotPara(7)
#define c2tb2 SbotPara(8)
#define stb SbotPara(9)
#define stb2 SbotPara(10)
#define s2tb SbotPara(11)
#define s2tb2 SbotPara(12)
#endif

	double precision StopPara(NPara), SbotPara(NPara)

	common /twoloop/
     &    MUEc, Xtc, Atc, Xbc, Abc,
     &    DSS2, DSf,
     &    MA02, MUE2, MGl, MGl2,
     &    MTrun, MBy, Q,
     &    Alfas, hb2, hb,
     &    MT, MT2, MB, MB2,
     &    TB, SB, CB, SB2, CB2, C2B,
     &    Xt, Yt, ht2, ht,
     &    StopPara, SbotPara

	double precision MUE, At, Ab
	equivalence (MUEc, MUE)
	equivalence (Atc, At)
	equivalence (Abc, Ab)

* the ren. scheme: .FALSE. = DRbar, .TRUE. = on-shell

	logical onshell
	parameter (onshell = .TRUE.)

