! FH.h
! global variable declarations
! this file is part of FeynHiggs
! last modified 3 Nov 06 th


#ifndef USfC
#define USfC(a,b,t,g) DCONJG(USf(a,b,t,g))
#define UASfC(a,b,t) DCONJG(UASf(a,b,t))
#define VChaC(a,b) DCONJG(VCha(a,b))
#define UChaC(a,b) DCONJG(UCha(a,b))
#define ZNeuC(a,b) DCONJG(ZNeu(a,b))
#define CKMC(a,b) DCONJG(CKM(a,b))

#define Sq(c) (DBLE(c)**2 + DIMAG(c)**2)
#define Delta(i,j) ibits(ieor(i,j)-1,15,1)
#define Key(se) 2**(se-1)
#endif


#include "const-f90.h"
#include "FHCouplings.h"


! SM parameters

	double complex CKM(3,3)
	double precision Mf(4,3), Mf2(4,3), MTrun
	double precision MW, MW2, MZ, MZ2
	double precision SW, SW2, CW, CW2
	double precision EL, Alfa, Alfa2, Alfa0
	double precision GS, Alfas, Alfas2, AlfasMZ, GF

	common /smpara/ &
          CKM, &
          Mf, Mf2, MTrun, & 
          MW, MW2, MZ, MZ2, CW, CW2, SW, SW2,  &
          EL, Alfa, Alfa2, Alfa0,  &
          GS, Alfas, Alfas2, AlfasMZ, GF  

	double precision ME, ME2, MM, MM2, ML, ML2
	double precision MU, MU2, MC, MC2, MT, MT2
	double precision MD, MD2, MS, MS2, MB, MB2
	equivalence (Mf(2,1), ME), (Mf2(2,1), ME2)
	equivalence (Mf(2,2), MM), (Mf2(2,2), MM2)
	equivalence (Mf(2,3), ML), (Mf2(2,3), ML2)
	equivalence (Mf(3,1), MU), (Mf2(3,1), MU2)
	equivalence (Mf(3,2), MC), (Mf2(3,2), MC2)
	equivalence (Mf(3,3), MT), (Mf2(3,3), MT2)
	equivalence (Mf(4,1), MD), (Mf2(4,1), MD2)
	equivalence (Mf(4,2), MS), (Mf2(4,2), MS2)
	equivalence (Mf(4,3), MB), (Mf2(4,3), MB2)


! MSSM parameters

	double complex UCha(2,2), VCha(2,2), ZNeu(4,4)
	double precision MCha(2), MCha2(2), MNeu(4), MNeu2(4)
	double complex Af(2:4,3,3), Xf(2:4,3,3), MUETB(2:4), MUE
	double complex M_1, M_2, M_3
	double precision DSf(2,4), MSS2(2,2:4,3)
        double precision Mh0, Mh02, MHH, MHH2, MA0, MA02, MHp, MHp2
	double precision MGl, MGl2
	double precision CB, SB, TB, CB2, SB2, TB2, C2B, S2B
	double precision CA, SA, CA2, SA2, C2A, S2A
	double precision CAB, SAB, CBA, SBA
	integer inputmass

	common /mssmpara/ &
         UCha, VCha, ZNeu,  & 
         MCha, MCha2, MNeu, MNeu2,  &
         Af, Xf, MUETB, MUE,  &
         M_1, M_2, M_3,  &
         DSf, MSS2, &
         Mh0, Mh02, MHH, MHH2, MA0, MA02, MHp, MHp2, &
         MGl, MGl2, &
         CB, SB, TB, CB2, SB2, TB2, C2B, S2B, &
         CA, SA, CA2, SA2, C2A, S2A, &
         CAB, SAB, CBA, SBA, &
         inputmass

	double precision reimMUE(2), reMUE, imMUE
	equivalence (MUE, reimMUE)
	equivalence (reimMUE(1), reMUE)
	equivalence (reimMUE(2), imMUE)

	double complex UCha_flat(2*2), VCha_flat(2*2), ZNeu_flat(4*4)
	equivalence (UCha, UCha_flat)
	equivalence (VCha, VCha_flat)
	equivalence (ZNeu, ZNeu_flat)

	double complex Af_flat(3*3*3)
	equivalence (Af, Af_flat)


! Note: despite its name, sfermpara contains not only
! sfermion parameters, but all variables which need to be
! conserved during FHUncertainties.

	integer h0h02, HHHH2, h0HH2, semax2
	parameter (h0h02 = 1, HHHH2 = 2, h0HH2 = 3, semax2 = h0HH2)

	double precision DSS2(2,2:5,3)
	double precision MSf(2,4,3), MSf2(4,4,3)
	double complex USf(2,2,4,3)
	double precision MASf(6,3:4), MASf2(6,3:4)
	double complex UASf(6,6,3:4)
	double complex Hff(2,3,2), DeltaMBc(2)
	double precision Mdy(3,2), Mdy2(3,2)
	double precision space_for_maxpass, se2R(semax2)

	common /sfermpara/ &
         DSS2, &
         MSf, MSf2, USf, &
         MASf, MASf2, UASf, &
         Hff, DeltaMBc, Mdy, Mdy2, &
         space_for_maxpass, se2R 

	double precision MSf_flat(2*4*3), MASf_flat(6*2)
	equivalence (MSf, MSf_flat)
	equivalence (MASf, MASf_flat)

	double complex USf_flat(2*2*4*3), UASf_flat(6*6*2)
	equivalence (USf, USf_flat)
	equivalence (UASf, UASf_flat)

	double precision DeltaMB, DeltaMBe
	equivalence (DeltaMBc(1), DeltaMB)
	equivalence (DeltaMBc(2), DeltaMBe)

	double precision MBy, MBy2
	equivalence (Mdy(3,1), MBy)
	equivalence (Mdy2(3,1), MBy2)

	integer DeltaMB_maxpass
	equivalence (space_for_maxpass, DeltaMB_maxpass)

	integer NSfermionData 
	parameter (NSfermionData = 2*4*3 + &
         2*4*3 + 4*4*3 + 2*2*2*4*3 +  &
         6*2 + 6*2 + 2*6*6*2 +  &
         2*2*3*2 + 2*2 + 3*2 + 3*2 + 1 + semax2)
	double precision SfermionData(NSfermionData)
	equivalence (DSS2, SfermionData)


! Higgs results

	integer NNeutral, NCharged, NHiggs
	parameter (NNeutral = 3)
	parameter (NCharged = 1)
	parameter (NHiggs = NNeutral + NCharged)
	double complex SAeff, XHiggs(0:NNeutral,0:NNeutral,2)
	double precision MHiggs(NHiggs), MHiggs2(0:NHiggs)

! renormalized self-energies & counter terms

	integer h0h0, HHHH, A0A0, HmHp
	integer h0HH, h0A0, HHA0
	integer G0G0, h0G0, HHG0, A0G0
	integer GmGp, HmGp
	integer semax, cpeven, cpodd, goldstones
	parameter (h0h0 = 1, HHHH = 2, A0A0 = 3, HmHp = 4)
	parameter (h0HH = 5, h0A0 = 6, HHA0 = 7)
	parameter (G0G0 = 8, h0G0 = 9, HHG0 = 10, A0G0 = 11)
	parameter (GmGp = 12, HmGp = 13)
	parameter (semax = HmGp)
	parameter (cpeven = Key(h0h0) + Key(HHHH) + Key(h0HH))
	parameter (cpodd = Key(A0A0) + Key(h0A0) + Key(HHA0))
	parameter (goldstones = Key(G0G0) + Key(h0G0) + &
         Key(HHG0) + Key(A0G0))

	double precision dZ(semax), dMsq(semax), Msq(semax)
	double complex seR(semax), dseR(semax)

	common /higgsdata/  &
         MHiggs, SAeff, XHiggs, MHiggs2,  &
         dZ, dMsq, Msq, seR, dseR

	double complex UHiggs(0:NNeutral,0:NNeutral)
	double complex ZHiggs(0:NNeutral,0:NNeutral)
	equivalence (XHiggs(0,0,1), UHiggs)
	equivalence (XHiggs(0,0,2), ZHiggs)

	integer NHiggsErr, NHiggsData
	parameter (NHiggsErr = NHiggs + 2 + 2*(NNeutral+1)**2*2)
	parameter (NHiggsData = NHiggsErr + NHiggs+1 + (3 + 2*2)*semax)
	double precision HiggsData(NHiggsData)
	equivalence (MHiggs, HiggsData)


! couplings and widths

	double complex couplings(ncouplings)
	double complex couplingsms(ncouplingsms)
	double precision gammas(ngammas)
	double precision gammasms(ngammasms)
	double precision ratios(H0FF(3,4,3))

	common /coupdata/  &
         couplings, couplingsms, gammas, gammasms, ratios


! flags

	integer mssmpart, fieldren, tanbren
	integer higgsmix, p2approx, looplevel
	integer tl_running_mt, tl_bot_resum
	integer debuglevel, nmfv, uzint, uzext

! debuglevel = 0: no debug messages
!              1: dump setflags and setpara values
!              2: display Higgs mass matrix at p^2 = 0 and CTs
!              3: display search for zeros

	common /flags/  & 
         mssmpart, fieldren, tanbren, &
         higgsmix, p2approx, looplevel, &
         tl_running_mt, tl_bot_resum, &
         debuglevel, nmfv, uzint, uzext


	logical flags_valid, para_valid, higgs_valid, coup_valid

	common /valid/ &
         flags_valid, para_valid, higgs_valid, coup_valid


